﻿/**********************************************************************
 File:      AMECCommon.js
 Authors:   An Vo
 Last Mod:  2011-01-04
 Version:   1.0

 Description
 -----------
 Contains UI and navigation-related functions

 Class
 -------
 N/A

 Dependencies
 ------------
 N/A

 Revison History
 ---------------
 <date>         <revised by>     <reference>     <description>
 2011-01-04     An Vo            N/A            Initial Development
**********************************************************************/

/**********************************************************************
Method: LaunchWindow
Authors: An Vo
Created: 2011-01-04
        
Description
-----------
based on a URL provided, this function navigates the current window to a new URL and makes a call to CloseLightBox to close the current lightbox.
        
Passed in
---------
<name>  <type>      <description>
url     string      the URL the window should navigate to
        
Returned
--------
None
        
Sample Call
-----------
LaunchWindow('http://environment.alberta.ca/apps/OSIPDL/Browser');
        
Revison History
---------------
<date>          <revised by>     <reference>    <description>
2011-01-04      An Vo            N/A            Initial Development
2011-07-01      Robert Royall    OSIP_AENV-2424 Switched to use cross-browser navigation function
********************************************************************/
function LaunchWindow(url) {
    parent.location = url;
    CloseLightBox();
}

/*******************************************************************
Method: CloseLightBox
Authors: An Vo
Created: 2011-01-03
        
Description
-----------
Closes the current LightBox.
        
Passed in
---------
None
    
Returned
--------
None
        
Sample Call
-----------
CloseLightBox();
        
Revison History
---------------
<date>        <revised by>      <reference>     <description>
2011-01-04    An Vo             N/A             Initial Development         
************************************************************************/
function CloseLightBox() {
    parent.$.fancybox.close();
}

/*******************************************************************
Method: CloseLightBox
Authors: An Vo
Created: 2011-04-28
        
Description
-----------
Opens a LightBox.
        
Passed in
---------
<name>      <type>          <description>
url         string          the URL of the LightBox content
width       string          the desired width of the LightBox window
height      string          the desired height of the LightBox window
scrolling   boolean         true/false value indicating whether to allow scrolling in the LightBox window
    
Returned
--------
None
        
Sample Call
-----------
CloseLightBox();
        
Revison History
---------------
<date>        <revised by>      <reference>     <description>
2011-04-28    Darren Hunter     N/A             Initial Development         
************************************************************************/
function OpenLightBox(url, width, height, scrolling) {
    parent.$.fancybox({
                type: 'iframe',
                href: url,
                width: width || '80%',
                height: height || '80%',
		        scrolling: scrolling || 'auto',
		        padding: 10,
		        margin: 10
            });
}