﻿<%@ Page Title="" Language="VB" MasterPageFile="~/Views/Shared/OSIP.Master" Inherits="System.Web.Mvc.ViewPage(Of amec.osip.lightboxserver.ChemicalMeasurementModel)" %>

<%-- 
**********************************************************************
File:       ChemicalMeasurements.aspx
Author:     An Vo, AMEC Earth and Environmental
Last Mod:   2011-01-14
Version:    1.0

Description
-----------
View page for displaying Air Substance Measurements, both Current and Archive

Class
-----
N/A

Dependencies
------------
OSIPLightboxServer.AirController
OSIPLightboxServer.ChemicalMeasurementsModel
OSIPLightboxServer.ChemicalMeasurements.*

Revison History
---------------
<date>		<revised by>	<reference>		<description>
2011-01-14  An Vo       	N/A				Initial Development
**********************************************************************
--%>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Chemical Measurements
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">

    <h1><%=ViewData("stationName").ToString()%></h1>
    
    <h2><%=ViewData("type").ToString()%> Data</h2>
    <br />
<% If (Model.ChemicalMeasurements.Count > 0) Then %>
    <table style="width:615px">
        <tr>
            <td>Time of Data:</td>
        </tr>
        <tr>
            <td>
                <%=Html.Encode(Model.DateTimeStamp.ToString("yyyy-MM-dd hh:mm:ss"))%> (Mountain Standard Time)
            </td>
        </tr>
        <tr>
            <td>&nbsp;</td>
        </tr>
        <tr>
            <td>
                <table width="615px" class="borderedTable">
                    <tr>
                        <td class="tableHeader" style="width:175px;">PARAMETER</td>
                        <td class="tableHeader" style="width:220px;">HOURLY AVERAGE</td>
                        <% If ViewData("type").ToLower = "current" Then%>
                        <td class="tableHeader" style="width:220px;">HOURLY OBJECTIVE</td>
                        <% end if %>
                    </tr>
                <% For Each item In Model.ChemicalMeasurements%>
                    <tr>                        
                        <td class="tableCell" style="text-align: left"><%=Html.Encode(item.ParameterName)%></td>                        
                        <td class="tableCell" style="text-align: left"><%=Html.Encode(item.MeasurementDisplay)%></td>
                        <% If ViewData("type").ToLower = "current" Then%>
                        <td class="tableCell" style="text-align: left"><%=Html.Encode(item.ObjectiveDisplay)%></td>
                        <% end if %>
                    </tr>   
                <% Next%>
                </table>
            </td>
        </tr>
    </table>
<% Else %>
    <p>
        Currently no data to display.
    </p>
<% End If %>

</asp:Content>

<asp:Content ID="Content3" ContentPlaceHolderID="ScriptContent" runat="server">
    <link rel="Stylesheet" href="<%= ResolveUrl("~/Content/" + ViewData("cssPage").toString()) %>" media="screen" />
    <style type="text/css">
        
    .tableCell
    {
    	 border-left: solid 1px; 
    	 border-top: solid 1px;
    	 border-right: solid 1px;
    	 border-bottom: solid 1px;
    	 padding: 3px;
    }
    .tableHeader
    {
    	 border-left: solid 1px; 
    	 border-top: solid 1px;
    	 border-right: solid 1px;
    	 border-bottom: solid 1px;
    	 padding: 7px;
    	 font-weight: bold;
    	 text-align: center;
    }
    
    .borderedTable
    {
    	border: solid 1px
    }
        
    </style>
</asp:Content>

