﻿<%@ Page Title="" Language="VB" MasterPageFile="~/Views/Shared/OSIP.Master" Inherits="System.Web.Mvc.ViewPage" %>

<%-- 
**********************************************************************
File:       GetGHGGraph.aspx
Author:     An Vo, AMEC Earth and Environmental
Last Mod:   2011-02-08
Version:    1.0

Description
-----------
View page for displaying a Project's greenhouse gas emissions graph.
If a Facility uses co-generated resources, a definition for co-generation is displayed.

Class
-----
N/A

Dependencies
------------
OSIPLightboxServer.AirController
OSIPLightboxServer.ChemicalMeasurementsModel
OSIPLightboxServer.ChemicalMeasurements.*

Revison History
---------------
<date>		<revised by>	<reference>		<description>
2011-02-08  An Vo       	N/A				Initial Development
**********************************************************************
--%>

<asp:Content ID="Content1" ContentPlaceHolderID="MainContent" runat="server">
    <table border="0" style="height:560px;width:730px">
        <tr>
            <td style="padding-top: 10px">
                <iframe id="ghgGraph" src="<%= ViewData("graphURL").ToString() %>" width="750" height="435">
                </iframe>
            </td>
        </tr>
        <% If CType(ViewData("isCogen"), Boolean) = True Then%>
        <tr>
            <td style="text-align: left;">
                On site cogeneration of heat and electricity is often a more efficient use of fuel than generating process heat and using grid electricity. This increased efficiency results from the use of waste heat from the electricity generation as the starting heat for the process. In the Specified Gas Emitters 
                Regulation the heat from on site cogeneration is assumed to have come from a stand alone boiler with an 80% efficiency and the excess emissions beyond this reference are assumed to be associated with electricity production and therefore excluded from the facility's compliance obligation calculation. This adjustment avoids penalizing facilities that choose to build on site cogeneration, relative to facilities that do not. This is shown by the "cogen adjustment" bar in the graph. For sites that purchase heat and electricity from independently owned co-located cogeneration operations emissions from the oil sands facility and the cogeneration plant have been combined.
            </td>
        </tr>
    <% End If%>
    </table>
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="ScriptContent" runat="server">
    <link rel="Stylesheet" href="<%= ResolveUrl("~/Content/" + ViewData("cssPage").toString()) %>" media="screen" />
</asp:Content>
