﻿<%@ Page Title="" Language="VB" MasterPageFile="~/Views/Shared/OSIP.Master" Inherits="System.Web.Mvc.ViewPage" %>
<%-- 
**********************************************************************
File:       GetLandImpactCharts.aspx
Author:     Darren Hunter, AMEC Earth and Environmental
Last Mod:   2011-01-01
Version:    1.0

Description
-----------
View page for displaying Land Impact charts and graphs

Class
-----
N/A

Dependencies
------------
amec.osip.lightboxserver.LandImpactsLBController

Revison History
---------------
<date>		<revised by>	<reference>		<description>
2011-01-14  Darren Hunter   N/A				Initial Development
**********************************************************************
--%>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
    <h2>Click on a link to display the corresponding Table / Graph in the space below:</h2>
    <table style="width:730px" >
        <tr>
            <td>
                <a style="cursor:pointer" onclick="show('<%=ViewData("projectTable")%>', '<%=ViewData("projectTableTitle")%>');" >
                    <!--Show Land Impacts By Project Table-->
                    Table 1: <%=ViewData("projectTableTitle")%>
                </a>
            </td>
        </tr>
        <tr>
            <td>
                <a style="cursor:pointer" onclick="show('<%=ViewData("projectGraph")%>', '<%=ViewData("projectGraphTitle")%>');" >
                    <!--Show Land Impacts By Project Graph-->
                    Graph 1: <%=ViewData("projectGraphTitle")%>
                </a>
            </td>
        </tr>
        <tr>
            <td>
                <a style="cursor:pointer" onclick="show('<%=ViewData("yearTable")%>', '<%=ViewData("yearTableTitle")%>');" >
                    <!--Show Land Impacts By Year Table-->
                    Table 2: <%=ViewData("yearTableTitle")%>
                </a>
            </td>
        </tr>
        <tr>
            <td>
                <a style="cursor:pointer" onclick="show('<%=ViewData("yearGraph")%>', '<%=ViewData("yearGraphTitle")%>');" >
                    <!--Show Land Impacts By Year Graph-->
                     Graph 2: <%=ViewData("yearGraphTitle")%>
                </a>
            </td>
        </tr>
        <tr>
            <td>&nbsp;</td>
        </tr>
        <tr>
            <td>
                <div id="indicatorDiv" style="width: 730px; height: 410px; text-align: center; vertical-align: middle; display: none">
                    <img src="../Content/indicator.gif" />
                </div>
                <div id="divTitle" style="display: visible; text-align: left; font-weight: bold">
                    Table / Graph Title:
                </div>
                <iframe style="display: visible" id="iFrame" src="" frameborder="0"  width="730" height="410" />
            </td>
        </tr>
    </table>
</asp:Content>

<asp:Content ID="Content3" ContentPlaceHolderID="ScriptContent" runat="server">   
    <script language="javascript" type="text/javascript">
        /*******************************************************************
        Method: show
        Authors: Darren Hunter
        Created: 2011-01-04
                
        Description
        -----------
        Shows the selected graph or chart by URL
                
        Passed in
        ---------
        <name>      <type>      <description>
        source      String      The URL of the graph or chart 
        title       String      The title of the graph or chart
                
        Returned
        --------
        None
           
        Sample Call
        -----------
        show('www.google.ca','This is a test');
                
        Revison History
        ---------------
        <date>          <revised by>    <reference>     <description>
        2011-01-04     Darren Hunter    N/A             Initial Development
        ************************************************************************/
        function show(source, title) {
            document.getElementById("indicatorDiv").style.display = "block"
            document.getElementById("iFrame").style.display = "none";
            document.getElementById("iFrame").src = source;
            document.getElementById("divTitle").style.display = "none";
            document.getElementById("divTitle").innerHTML = title;

            waitForIFrame();
        }
        /*******************************************************************
        Method: waitForIFrame
        Authors: Darren Hunter
        Created: 2011-01-04
                
        Description
        -----------
        Waits for the IFrame to finish loading before showing
                
        Passed in
        ---------
        <none>        
                
        Returned
        --------
        None
           
        Sample Call
        -----------
        waitForIFrame();
                
        Revison History
        ---------------
        <date>          <revised by>    <reference>     <description>
        2011-01-04     Darren Hunter    N/A             Initial Development
        ************************************************************************/
        function waitForIFrame(){
            if (document.getElementById("iFrame").readyState != "complete") {             
                setTimeout("waitForIFrame();", 200);         
            } else {             
                done();         
            }
        }
        /*******************************************************************
        Method: done
        Authors: Darren Hunter
        Created: 2011-01-04
                
        Description
        -----------
        Shows the Iframe content and hides the progress indicator
                
        Passed in
        ---------
        <none>        
                
        Returned
        --------
        None
           
        Sample Call
        -----------
        done();
                
        Revison History
        ---------------
        <date>          <revised by>    <reference>     <description>
        2011-01-04     Darren Hunter    N/A             Initial Development
        ************************************************************************/
        function done() {
            document.getElementById("indicatorDiv").style.display = "none"
            document.getElementById("iFrame").style.display = "block";
            document.getElementById("divTitle").style.display = "block";
        }
        
    </script>
    <link rel="Stylesheet" href="<%= ResolveUrl("~/Content/" + ViewData("cssPage").toString()) %>" media="screen" />
</asp:Content>
