﻿<%@ Page Title="" Language="VB" MasterPageFile="~/Views/Shared/OSIP.Master" Inherits="System.Web.Mvc.ViewPage" AutoEventWireup="true" %>

<%-- 
**********************************************************************
File:       GetAboutContent.aspx
Author:     An Vo, AMEC Earth and Environmental
Last Mod:   2011-01-04
Version:    1.0

Description
-----------
View page for displaying the Portal About page.

Class
-----
N/A

Dependencies
------------
None

Revison History
---------------
<date>		<revised by>	<reference>		<description>
2011-01-04  An Vo       	N/A				Initial Development
**********************************************************************
--%>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
<form runat="server">
    <table width="100%" cellspacing="3" cellpadding="3">
        <tr>
            <td style="height:10px">&nbsp;</td>
        </tr>
        <tr>
            <td style="text-align: left; font-family: Arial; font-size: medium; font-weight: bold">
                More on Water in Alberta's Oil Sands Regions
            </td>
        </tr>
        <tr>
            <td>&nbsp;</td>
        </tr>
        <tr>
            <td style="text-align: center; font-family:Arial;">
                <a id="aboutLink" href="javascript:SwitchView('about')" class="highlighted">What are the oil sands?</a>
                &nbsp;&nbsp;|&nbsp;&nbsp;
                <a id="technologyLink" href="javascript:SwitchView('technology')" class="plain">Technology</a>
                &nbsp;&nbsp;|&nbsp;&nbsp;
                <a id="regulationsLink" href="javascript:SwitchView('regulations')" class="plain">Regulations</a>
                &nbsp;&nbsp;|&nbsp;&nbsp;
                <a id="environmentLink" href="javascript:SwitchView('environment')" class="plain">Environment</a>
                &nbsp;&nbsp;|&nbsp;&nbsp;
                <a id="glossaryLink" href="javascript:SwitchView('glossary')" class="plain">Glossary</a>
                &nbsp;&nbsp;|&nbsp;&nbsp;
                <a id="resourcesLink" href="javascript:SwitchView('resources')" class="plain">Other Resources</a>               
            </td>
        </tr>
        <tr>
            <td style="height:25px">
                &nbsp;
            </td>
        </tr>
        <tr>
            <td style="text-align: left">
                <asp:Panel ID="contentPanel" runat="server" Width="100%" Height="475px" ScrollBars="Vertical">
                    <div id="about" style="text-align:left; display: block">
                         <%  
                             If System.IO.File.Exists(Server.MapPath("~/Content/about_alberta_oil_sands.htm")) Then
                                 Response.Write(Html.InjectHtml("~/Content/about_alberta_oil_sands.htm"))
                             End If
                        %>
                   </div> 
                   <div id="technology" style="text-align:left; display: none">
                        <%  
                            If System.IO.File.Exists(Server.MapPath("~/Content/technology.htm")) Then
                                Response.Write(Html.InjectHtml("~/Content/technology.htm"))
                            End If
                         %>
                   </div> 
                   <div id="regulations" style="text-align:left; display: none">
                        <%  
                            If System.IO.File.Exists(Server.MapPath("~/Content/regulations.htm")) Then
                                Response.Write(Html.InjectHtml("~/Content/regulations.htm"))
                            End If
                        %>
                   </div> 
                   <div id="environment" style="text-align:left; display: none">
                        <%  
                            If System.IO.File.Exists(Server.MapPath("~/Content/environment.htm")) Then
                                Response.Write(Html.InjectHtml("~/Content/environment.htm"))
                            End If
                        %>
                   </div> 
                   <div id="glossary" style="text-align:left; display: none">
                        <%  
                            If System.IO.File.Exists(Server.MapPath("~/Content/portal_glossary.htm")) Then
                                Response.Write(Html.InjectHtml("~/Content/portal_glossary.htm"))
                            End If
                        %>
                   </div> 
                   <div id="resources" style="text-align:left; display: none">
                      <%  
                        If System.IO.File.Exists(Server.MapPath("~/Content/resources.htm")) Then
                            Response.Write(Html.InjectHtml("~/Content/resources.htm"))
                        End If
                     %>
                   </div> 
                </asp:Panel>
            </td>
        </tr>
    </table>   
</form> 
</asp:Content>

<asp:Content ID="Content3" ContentPlaceHolderID="ScriptContent" runat="server">
    <link rel="Stylesheet" href="<%= ResolveUrl("~/Content/" + ViewData("cssPage").toString()) %>" media="screen" />
    <link rel="Stylesheet" href="<%= ResolveUrl("~/Content/Site.css") %>" media="screen" />
    <style type="text/css">
        
        a 
        {
        	text-decoration: none;
        }
        a visited
        {
        	
        }
        
        .shown
        {
        	display: block;
        }
        
        .hidden
        {
        	display: none;
        }
        
        .highlighted
        {
        	font-weight: bold;
        }
        
        .plain
        {
        	font-weight: normal;
        }
        
    </style>
    <script language="javascript" type="text/javascript"> 
  
        /*******************************************************************
        Method: SwitchView
        Authors: An Vo
        Created: 2011-01-04
                
        Description
        -----------
        switches the current text block and highlights the currently selected text link
                
        Passed in
        ---------
        <name>      <type>      <description>
        viewId      String      the id of the text block to be displayed          
                
        Returned
        --------
        None
           
        Sample Call
        -----------
        SwitchView("about");
                
        Revison History
        ---------------
        <date>          <revised by>    <reference>     <description>
         2011-01-04     An Vo           N/A             Initial Development
        ************************************************************************/
         function SwitchView(viewId){

            // Hide all other views
            about.style.display         = "none";
            technology.style.display    = "none";
            regulations.style.display   = "none";
            environment.style.display   = "none";
            glossary.style.display      = "none";
            resources.style.display     = "none";

            aboutLink.className         = "plain";
            technologyLink.className    = "plain";
            regulationsLink.className   = "plain";
            environmentLink.className   = "plain";
            glossaryLink.className      = "plain";
            resourcesLink.className     = "plain";
             
             // Display the selected view
             switch (viewId) {
                 case "about":
                     about.style.display = "inline";
                     aboutLink.className = "highlighted";
                     break;

                 case "technology":
                     technology.style.display   = "inline";
                     technologyLink.className   = "highlighted";
                     break;

                 case "regulations":
                     regulations.style.display = "inline";
                     regulationsLink.className = "highlighted";
                     break;

                 case "environment":
                     environment.style.display = "inline";
                     environmentLink.className = "highlighted";
                     break;

                 case "glossary":
                     glossary.style.display = "inline";
                     glossaryLink.className = "highlighted";
                     break;

                 case "resources":
                     resources.style.display = "inline";
                     resourcesLink.className = "highlighted";
                     break;
             }
         }
    </script>
    
</asp:Content>
