﻿<%@ Page Title="" Language="VB" MasterPageFile="~/Views/Shared/OSIP.Master" Inherits="System.Web.Mvc.ViewPage(Of amec.osip.lightboxserver.EmailMessage)" %>

<%-- 
**********************************************************************
File:       GetContactUsContent.aspx
Author:     An Vo, AMEC Earth and Environmental
Last Mod:   2011-01-28
Version:    1.0

Description
-----------
View page for displaying the Portal Contact Us page.

Class
-----
N/A

Dependencies
------------
None

Revison History
---------------
<date>		<revised by>	<reference>		<description>
2011-01-28  An Vo       	N/A				Initial Development
**********************************************************************
--%>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
    Contact Us
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">

    <h1>Contact Us</h1>

    <%-- The following line works around an ASP.NET compiler warning --%>
    <%= ""%>
    <% Using Html.BeginForm()%>
    <%= Html.ValidationSummary(True) %>
    <fieldset>
        <% If (CType(Model.MessageSent, Boolean) = False) Then%>
        <p>
            We would like to hear from you about your experience with the AEMERIS Portal.  Your input and feedback will help us as we continue to improve and enhance the portal.
        <br />
            Use this form if you:
        </p>
        <ul>
            <li>Have a question</li>
            <li>Need more data/information</li>
            <li>Would like to provide general feedback</li>
            <li>Experienced technical difficulties</li>
            <li>Noticed something incorrect in the portal library or on the map</li>
        </ul>
        <p>&nbsp;</p>
        <p>Please complete all fields below.</p>
        <p>&nbsp;</p>

        <div class="editor-label">
            Your name:
        </div>
        <div class="editor-field">
            <%=Html.TextBoxFor(Function(model) model.Name, New With {.size = "25"})%>
            <%= Html.ValidationMessageFor(Function(model) model.Name) %>
        </div>
        <div class="editor-label">
            Your email address:
        </div>
        <div class="editor-field">
            <%=Html.TextBoxFor(Function(model) model.EmailAddress, New With {.size = "40"})%>
            <%= Html.ValidationMessageFor(Function(model) model.EmailAddress) %>
        </div>

        <div class="editor-label">
            <%=Html.LabelFor(Function(model) model.Message)%>
        </div>
        <div class="editor-field">
            <%=Html.TextAreaFor(Function(model) model.Message, 7, 85, "")%>
            <%= Html.ValidationMessageFor(Function(model) model.Message) %>
        </div>
        <p>&nbsp;</p>
        <p>
            <input type="submit" value="Send" />
        </p>
    </fieldset>
    <%Else%>
    <tr>
        <p>
            Thank you for your feedback. Your email has been sent to EMSD.<br />
        </p>
    </tr>
    <%End If%>

    <% End Using %>
</asp:Content>

<asp:Content ID="Content3" ContentPlaceHolderID="ScriptContent" runat="server">
    <link rel="Stylesheet" href="<%= ResolveUrl("~/Content/" + ViewData("cssPage").toString()) %>" media="screen" />
    <script type="text/javascript" src="<%= ResolveUrl("~/Scripts/AMECCommon.js") %>"></script>
    <script type="text/javascript" src="<%= ResolveUrl("~/Scripts/MicrosoftAjax.js") %>"></script>
    <script type="text/javascript" src="<%= ResolveUrl("~/Scripts/MicrosoftMvcValidation.js") %>"></script>
    <style type="text/css">
        td {
            font-family: Arial;
            font-size: small;
        }

        .normalText {
            font-family: Arial;
            font-size: small;
        }

        .required {
            font-family: Arial;
            font-size: small;
            color: Red;
        }
    </style>
</asp:Content>

