﻿<%@ Page Title="" Language="VB" MasterPageFile="~/Views/Shared/OSIP.Master" Inherits="System.Web.Mvc.ViewPage" %>

<%-- 
**********************************************************************
File:       GetWaterUse.aspx
Author:     Darren Hunter, AMEC Earth and Environmental
Last Mod:   2011-01-01
Version:    1.0

Description
-----------
View page for displaying Total water use for all projects

Class
-----
N/A

Dependencies
------------
amec.osip.lightboxserver.WaterLBController

Revison History
---------------
<date>		<revised by>	<reference>		<description>
2011-01-14  Darren Hunter   N/A				Initial Development
**********************************************************************
--%>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Water Use
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
    <div style="border:solid 1px black; padding-left:10px">
    <h2>Water Use</h2>
    <h3>Mining Water Use Intensity -  Amount of fresh water used by the oil sands mines to produce one barrel of synthetic crude oil:</h3>
    <% If ViewData("AverageMineFreshWaterPerBarrelCrude") Is Nothing Or ViewData("AverageMineFreshWaterPerBarrelCrudeYear") = 0 Then%>
        <p>This data is currently unavailable.</p>
    <% Else%>
        <p><%=ViewData("AverageMineFreshWaterPerBarrelCrude")%> Barrels of Fresh Water / 1 Barrel Synthetic Crude in <%=ViewData("AverageMineFreshWaterPerBarrelCrudeYear")%></p>
    <% End If%>
    <h3>In situ Water Use Intensity - Amount of water used by the oil sands in situ projects to produce one barrel of bitumen:</h3>
    <% If ViewData("AverageInSituFreshWaterPerBarrelBitumen") Is Nothing Or ViewData("AverageInSituBrackishWaterPerBarrelBitumen") Is Nothing Or ViewData("AverageInSituBrackishWaterPerBarrelBitumenYear") = 0 Then%>
        <p>This data is currently unavailable.</p>
    <% Else%>
        <p><%=ViewData("AverageInSituFreshWaterPerBarrelBitumen")%> Barrels of Fresh Water and <%=ViewData("AverageInSituBrackishWaterPerBarrelBitumen")%> barrels of Brackish Water / 1 barrel of Bitumen in <%=ViewData("AverageInSituBrackishWaterPerBarrelBitumenYear")%></p>
    <% End If%>
    <h3>Integrated In situ Water Use Intensity – Amount of water used by oil sands In situ projects with Integrated Upgrading to produce one barrel of synthetic crude oil:</h3>
    <% If ViewData("AverageIntegratedInSituFreshWaterPerBarrelCrude") Is Nothing Or ViewData("AverageIntegratedInSituBrackishWaterPerBarrelCrude") Is Nothing Or ViewData("AverageIntegratedInSituBrackishWaterPerBarrelCrudeYear") = 0 Then%>
        <p>This data is currently unavailable.</p>
    <% Else%>
        <p><%=ViewData("AverageIntegratedInSituFreshWaterPerBarrelCrude")%> barrels of Fresh Water and <%=ViewData("AverageIntegratedInSituBrackishWaterPerBarrelCrude")%> barrels of Brackish Water / 1 barrel of synthetic crude oil in <%=ViewData("AverageIntegratedInSituBrackishWaterPerBarrelCrudeYear")%></p>
    <% End If%>
    <br />
        <h3>Stand Alone Upgrading Water Use Intensity - Amount of fresh water used by stand alone oil sands upgrader projects to produce one barrel of synthetic crude oil:</h3>
    <% If ViewData("AverageUpgraderFreshWaterPerBarrelCrude") Is Nothing Or ViewData("AverageUpgraderFreshWaterPerBarrelCrudeYear") = 0 Then%>
        <p>This data is currently unavailable.</p>
    <% Else%>
        <p><%=ViewData("AverageUpgraderFreshWaterPerBarrelCrude")%> Barrels of Fresh Water / 1 Barrel Synthetic Crude in <%=ViewData("AverageUpgraderFreshWaterPerBarrelCrudeYear")%></p>
    <% End If%>        
    </div>
    <br />
    <div style="border:solid 1px black; padding-left:10px">
    <h2>Total Water Use</h2>
    <h3>Total amount of fresh surface water used by all oil sands mining operations annually:</h3>
    <% If ViewData("totalMineWaterYear") > 0 Then%>
        <p><%=ViewData("totalMineWater")%> million m3 in <%=ViewData("totalMineWaterYear")%></p>
    <% else %>
        <p>This data is currently unavailable.</p>
    <%End If%>
    <h3>Total amount of groundwater and river water used by all in situ operators:</h3>
    <% If ViewData("totalInSituWaterYear") > 0 Then%>
        <p><%=ViewData("totalInSituWater")%> million m3 in <%=ViewData("totalInSituWaterYear")%></p>
    <% else %>
        <p>This data is currently unavailable.</p>
    <%End If%>
    <h3>Total amount of groundwater and river water used by all upgrader operators:</h3>
    <% If ViewData("totalUpgraderWaterYear") > 0 Then%>
        <p><%=ViewData("totalUpgraderWater")%> million m3 in <%=ViewData("totalUpgraderWaterYear")%></p>
    <% else %>
        <p>This data is currently unavailable.</p>
    <%End If%>    
    </div>
    <br />
</asp:Content>

<asp:Content ID="Content3" ContentPlaceHolderID="ScriptContent" runat="server">
    <link rel="Stylesheet" href="<%= ResolveUrl("~/Content/" + ViewData("cssPage").toString()) %>" media="screen" />
</asp:Content>
