﻿var GridPage = 1;
$(document).ready(function() {
    $(window).bind('hashchange', function(e) {
        $("#SearchFilters").empty();
        SetHashFilters();
    });
    var whatBoxSettings = { titleShow: false, transitionIn: 'elastic', transitionOut: 'elastic',
        hideOnOverlayClick: false, hideOnContentClick: false, enableEscapeButton: true,
        type: 'ajax', width: 300, height: 200, autoDimensions: false, showCloseButton: true
    }
    $("#What1").fancybox(whatBoxSettings);
    $("#What2").fancybox(whatBoxSettings);
    //$("#MoreHelp").fancybox(whatBoxSettings);
    $(".FilterList").hide();
    $("#DummyFilterItem").hide();
    $("#CategoryHeader").toggle(function() { RefreshCategories(); },
                    function() {
                        $("#CategoryList").slideUp('fast');
                        $("#CategoryHeader").addClass("Collapsed").removeClass("Expanded");
                    });
    $("#DataSourceTypeHeader").toggle(function () { RefreshDataSourceType(); },
                    function () {
                        $("#DataSourceTypeList").slideUp('fast');
                        $("#DataSourceTypeHeader").addClass("Collapsed").removeClass("Expanded");
                    });
    $("#LocationHeader").toggle(function() { RefreshLocations(); },
                    function() {
                        $("#LocationList").slideUp('fast');
                        $("#LocationHeader").addClass("Collapsed").removeClass("Expanded");
                    });
    $("#ReportingSourceHeader").toggle(function() { RefreshRepSources(); },
                    function() {
                        $("#ReportingSourceList").slideUp('fast');
                        $("#ReportingSourceHeader").addClass("Collapsed").removeClass("Expanded");
                    });
    $("#StartDate").datepicker({
        onSelect: function(dateText, inst) {
            AddFilter(dateText,"Start Date","StartDate", dateText, "StartDateFilter");
            SetupDatePicker("StartPicker", dateText);
        }, buttonText: "Select Start Date"
    });
    $("#EndDate").datepicker({
        onSelect: function(dateText, inst) {
            AddFilter(dateText,"End Date", "EndDate", dateText, "EndDateFilter");
            SetupDatePicker("EndPicker", dateText);
        }, buttonText: "Select End Date"
    });
    $("#SearchText").keyup(function (event) {
        if (event.keyCode == 13) {
            SearchByKeyword();
        }
    });
    if ($.cookie("HideSearchTip") == "Yes") {
        $("#SearchHelp").hide();
    }
    $(window).trigger('hashchange');
});
function SetupDatePicker(id, dateText) {
    $("#" + id + " .Change .Text").text(dateText);
    $("#" + id + " .Change").show();
    $("#" + id + " .Select").hide();
}
function RefreshCategories() {
    LoadHtml(rootPath + 'Browser/Categories/', GetParameters(), Categories_Success, $("#CategoryList"));
}
function RefreshDataSourceType() {
    LoadHtml(rootPath + 'Browser/DataSourceType/', GetParameters(), DataSourceType_Success, $("#DataSourceTypeList"));
}
function RefreshLocations() {
    LoadHtml(rootPath + 'Browser/Locations/', GetParameters(), Locations_Success, $("#LocationList"));
}
function RefreshRepSources() {
    LoadHtml(rootPath + 'Browser/ReportingSources/', GetParameters(), RepSources_Success, $("#ReportingSourceList"));
}
function PageSearchGrid(newPage) {
    GridPage = newPage;
    $.bbq.pushState(GetHashString(), 2);
}
function SortSearchGrid() {
    $.bbq.pushState(GetHashString(), 2);
}
function RefreshSearchGrid() {
    var input = new SearchInput(GridPage, $("#GridSort option:selected").val(), GetParameters());
    LoadHtml(rootPath + 'Browser/Search/', input, Grid_Success, $("#SearchGrid"));
}
function GetParameters() {
    var parameters = new Array();
    $("#SearchFilters .FilterItem .Filter").each(function() {
        var p = new Parameter($(this).find(".Parameter").val(), $(this).find(".Value").val());
        parameters.push(p);
    });
    return parameters;
}
function GetHashString() {
    var hash = "";
    var params = GetParameters();
    for (i = 0; i < params.length; i++) {
        hash = hash + params[i].Name + "=" + params[i].Value + "&";        
    }
    hash = hash + "Page=" + GridPage + "&Sort=" + $("#GridSort option:selected").val();
    return hash;
}
function SetHashFilters() {
    var hash = location.hash;
    if (hash.length > 1) {
        $.ajax({
            url: rootPath + "Browser/Filters",
            type: "POST",
            contentType: "application/json; charset=utf-8",
            data: JSON.stringify(hash),
            dataType: "json",
            success: Filters_Success
        });
    }
    else {
        RefreshSearchGrid();
    }
}
function Filters_Success(data) {
    var num = data.length;
    for (x = 0; x < num; x++) {
        switch (data[x].Id.toLowerCase()) {
            case 'page':
                GridPage = parseInt(data[x].Value);
                break;
            case 'sort':
                $("#GridSort option:selected").val(data[x].Value);
                break;
            case 'startdatefilter':
                $("#StartDate").datepicker("setDate", data[x].Value);                
                SetupDatePicker("StartPicker", data[x].Value);
                AddFilter(data[x].DisplayName, data[x].Label, data[x].Parameter, data[x].Value, data[x].Id, false);
                break;
            case 'enddatefilter':
                $("#EndDate").datepicker("setDate", data[x].Value);
                SetupDatePicker("EndPicker", data[x].Value);
                AddFilter(data[x].DisplayName,data[x].Label, data[x].Parameter, data[x].Value, data[x].Id, false);
                break;
            case 'keysearch':
                $("#SearchText").val(data[x].Value);
                AddFilter(data[x].DisplayName, data[x].Label,data[x].Parameter, data[x].Value, data[x].Id, false);
                break;
            default:
                AddFilter(data[x].DisplayName,data[x].Label, data[x].Parameter, data[x].Value, data[x].Id, false);
                break;
        }
    }
    UpdateHeading();
    RefreshSearchGrid();
}
function Categories_Success(data) {
    $("#CategoryList").html(data);
    if (!$("#CategoryList").is(":visible")) {
        $("#CategoryList").slideDown('fast');
        $("#CategoryHeader").addClass("Expanded").removeClass("Collapsed");
    }
}
function DataSourceType_Success(data) {
    $("#DataSourceTypeList").html(data);
    if (!$("#DataSourceTypeList").is(":visible")) {
        $("#DataSourceTypeList").slideDown('fast');
        $("#DataSourceTypeHeader").addClass("Expanded").removeClass("Collapsed");
    }
}
function Locations_Success(data) {
    $("#LocationList").html(data);
    if (!$("#LocationList").is(":visible")) {
        $("#LocationList").slideDown('fast');
        $("#LocationHeader").addClass("Expanded").removeClass("Collapsed");
    }
}
function RepSources_Success(data) {
    $("#ReportingSourceList").html(data);
    if (!$("#ReportingSourceList").is(":visible")) {
        $("#ReportingSourceList").slideDown('fast');
        $("#ReportingSourceHeader").addClass("Expanded").removeClass("Collapsed");
    }
}
function Grid_Success(data) {
    $("#SearchGrid").html(data);
    if ($("#CategoryList").is(":visible")) {
        RefreshCategories();
    }
    if ($("#DataSourceTypeList").is(":visible")) {
        RefreshDataSourceType();
    }
    if ($("#LocationList").is(":visible")) {
        RefreshLocations();
    }
    if ($("#ReportingSourceList").is(":visible")) {
        RefreshRepSources();
    }
}
function AddFilter(display, displayLabel, parameter, value, id, setHash) {
    var item = $("#" + id);
    if (item.html() != null) {
        item.find(".Filter .Value").val(value);
        item.find(".Filter .Text").html(display);
    } else {
        var newItem = $("#DummyFilterItem").clone();
        newItem.attr("id", id);
        newItem.find(".Filter .Parameter").val(parameter);
        newItem.find(".Filter .Value").val(value);
        newItem.find(".Filter .Label").html(displayLabel);
        newItem.find(".Filter .Text").html(display);
        newItem.find(".Remove").click(function() {
            RemoveFilter(id);
        });
        newItem.appendTo("#SearchFilters").show();
        if ($("#SearchHelp").is(":visible")) {
            $("#SearchHelp").hide();
        }
    }
    GridPage = 1;
    UpdateHeading();
    var hash = GetHashString();
    if (setHash || setHash == undefined) {
        $.bbq.pushState(hash, 2);
    }
}
function RemoveFilter(id, setHash) {
    $("#" + id).remove();
    switch (id) {
        case 'StartDateFilter':
            $("#StartPicker .Change").hide();
            $("#StartPicker .Select").show();
            break;
        case 'EndDateFilter':
            $("#EndPicker .Change").hide();
            $("#EndPicker .Select").show();
            break;
        case 'KeySearch':
            $("#SearchText").val("");
            break;
    }
    GridPage = 1;
    UpdateHeading();
    if (setHash || setHash == undefined) {
        $.bbq.pushState(GetHashString(), 2);
    }
}
function ShowStartPicker() {
    $("#StartDate").datepicker("show");
}
function ShowEndPicker() {
    $("#EndDate").datepicker("show");
}

function RefreshSearch() {
    $("#KeySearch").remove();
    SearchByKeyword();
}

function SearchByKeyword() {
    var text = $("#SearchText").val();
    if (text.length > 0) {
        AddFilter(text, $("#SearchBy option:selected").val(), $("#SearchBy option:selected").val(), text, "KeySearch");
    }
}
function UpdateHeading() {
    var heading = $("#SearchHeading").html();
    var keySearch = false;
    var filterCount = $("#SearchFilters .FilterItem").length;
    if ($("#KeySearch").html() != null) {
        keySearch = true;
    }
    if (keySearch) {
        heading = 'Viewing data sets matching "' + escapeHTML($("#SearchText").val()) + '"';
        if (filterCount > 1) {
            heading = heading + ' and';
        }
        heading = heading + ':';
    } else {
        if (filterCount > 0) {
            heading = 'Viewing data sets matching:';
        } else {
            heading = 'Viewing All Data Sets';
        }
    }
    $("#SearchHeading").html(heading);
}
function HideSearchTip() {
    $.cookie("HideSearchTip", "Yes", { expires: 365 });
    $("#SearchHelp").hide();
} 