﻿var GridViewId = 0;
var GridViewPage = 1;
var dialogSettings = { titleShow: false,transitionIn:'elastic',transitionOut:'elastic',
                        hideOnOverlayClick: false, hideOnContentClick: false, enableEscapeButton: true,
                        type: 'inline'}


function LoadFormFilter(id) {
var url = rootPath + "Dataset/FormFilter/" + id;
if(qs.length > 0) {
    url = url + '?' + qs;
}
LoadHtml(url, id,
    function(data) {
        $("#PageFilter").html(data);
    }, $("#PageFilter")
);
}

function LoadODataLinks(id) {
    var url = rootPath + "Dataset/ODataLinks/" + id;
    if(qs.length > 0) {
        url = url + '?' + qs;
    }
    LoadHtml(url, id,
        function(data) {
            $("#ODataLinks").html(data);
        }, $("#ODataLinks")
    );
    }
    
 function LoadChart(chartId) {            
    var url = rootPath + "Dataset/Chart/" + chartId;
    if(qs.length > 0) {
        url = url + '?' + qs;
    }
    LoadHtml(url, chartId,
        function(data) {
            Chart_Success(data, chartId);
        }, $("#ChartSmall" + chartId)
    );
 }
 
 
 function ShowGridView()
 {
   var input = new GridInput(GridViewId,GridViewPage,GetPageFilters());
   $.fancybox.showActivity();
   LoadHtml(rootPath + "Dataset/Grid/", input,
        function(data) {
            $.fancybox.hideActivity();
            $("#Grid").html(data);
            ShowDialog($("#GridDialog"));
        }, $("#Grid"),
        function() {
            $.fancybox.hideActivity();
            ShowDialog($("#GridDialog"));
        }
    );
 }
 function RefreshGridView()
 {
    var input = new GridInput(GridViewId,GridViewPage,GetPageFilters());
    LoadHtml(rootPath + "Dataset/Grid/",input,
        function(data) {
            $("#Grid").html(data);
            $.fancybox.resize(); 
        }, $("#Grid")
    );
 }        
 function PageGridView(newPage)
 {
    GridViewPage = newPage;
    RefreshGridView();
 }
 //Javascript specific to: /Dataset
function ShowDialog(element) {
    element.click();
}
function ResizeChart(element) {
    var img = element.find("img");
    var width = img.width();
    var height = img.height();
    var newWidth = 280;
    var newHeight = Math.ceil((1 - ((width - newWidth) / width)) * height);
    img.width(newWidth);
    img.height(newHeight);
}
function RefreshChart(id) {
    var chartInput = new ChartInput(id, GetPageFilters());
    LoadHtml(rootPath + "Dataset/RefreshChart", chartInput,
        function(data) {
            Chart_Success(data, id);
        }, $("#ChartSmall" + id)
    );
    }

    function LoadChartODataLinks(id) {
        var chartInput = new ChartInput(id, GetPageFilters());
        var url = rootPath + "Dataset/ODataLinksChart/" + id;
        LoadHtml(url, chartInput,
            function(data) {
                $("#ODataLinks").html(data);
            }, $("#ODataLinks")
        );
    }
function Chart_Success(data, chartId) {
    $("#ChartSmall" + chartId).html(data);
    ResizeChart($("#ChartSmall" + chartId));
    //var isIE6 = $.browser.msie && $.browser.version < 7 && !window.XMLHttpRequest;
    $("#Chart" + chartId).html(data);
    $("#ChartSmall" + chartId + " img").click(function() {
        ShowDialog($("#ChartDialog" + chartId));
    });
}
function GetPageFilters() {
    var formValues = $("#PageFilter form").serializeArray();
    var filters = new Array();
    jQuery.each(formValues, function(i, field) {
        var f = new Parameter(field.name, field.value);
        filters.push(f);
    });
    return filters;
}
function ShowDownload() {
    ShowDialog($("#DownloadDialog"));
}
function ClearCheckboxes(eId) {
    $("#" + eId + " input:checked").attr("checked", false);
}
//Dec 13, 2011 adding logic to validate parameters before attempting download
function Download(url, validationUrl) {
    var qs = $("#PageFilter form").serialize();
    ValidateParameters(url, validationUrl + "?" + qs); //new
}
function ValidateParameters(url, validationUrl) {

    document.getElementById("ValidationErrorText").innerHTML = ""; //reset from last call, just in case

    $.ajax({
        url: validationUrl,
        type: "GET",
        contentType: "application/x-www-form-urlencoded",
        data: "",
        dataType: "html",
        success: function(data, textStatus, jqXHR) {
            if (data == "ok") {
                ProceedToDownLoad(url); //if no validation errors, do download
            }
            else {
                ShowValidationDialog(data, "#ValidationErrorDialog");
            }
        },
        error: function(req, status, err) {
            //var res = jQuery.parseJSON(req.responseText);
            ShowValidationDialog(req.responseText, "#ValidationErrorDialog");
        }
    });
}
function ProceedToDownLoad(url) {
 var qs = $("#PageFilter form").serialize();
    if (qs.length > 0) {
        window.location = url + "?" + qs;
    }
    else {
        window.location = url;
    }
}
function ShowValidationDialog(msg, dialog) {
    document.getElementById("ValidationErrorText").innerHTML = msg;
    ShowDialog($(dialog)); //opens fancybox w/ validation error message
}
// end Dec 13, 2011
//Jan 05, 2011 adding disclaimer function
function ShowDisclaimerDialog(msg, clickHandler) {
    document.getElementById("DisclaimerText").innerHTML = msg;
    document.getElementById("DisclaimerButton").onclick = clickHandler;
    ShowDialog($("#DisclaimerDialog")); //opens fancybox w/ validation error message
}
