<%@ Control Language="VB"  Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.SearchGridModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.Metadata" %>
<%  
    Dim siteCode = CStr(ViewData("SiteCode"))
    If Model.ItemCount = 0 Then%>
    <p>No datasets were found for the selected criteria.</p>
<% Else %>
<table width="100%">
    <tr>
        <td><%=Model.Pager.PageStart %>&nbsp;-&nbsp;<%=Model.Pager.PageEnd%> of <%=Model.ItemCount%> matches</td>
        <td>Sort by 
            <select id="GridSort" onchange="SortSearchGrid();">            
                <option value="Title" <%=IIf(Model.Sort = "Title", "selected=""selected""", "")%>>Title</option>
                <option value="DATA_PERIOD_START_DATE" <%=IIf(Model.Sort = "DATA_PERIOD_START_DATE", "selected=""selected""", "")%>>Start Date</option>
                <option value="DATA_PERIOD_END_DATE" <%=IIf(Model.Sort = "DATA_PERIOD_END_DATE", "selected=""selected""", "")%>>End Date</option>
                <option value="REPORTING_SOURCE_NUMBER" <%=IIf(Model.Sort = "REPORTING_SOURCE_NUMBER", "selected=""selected""", "")%>>Reporting Source</option>
            </select>
        </td>
        <td align="right"><%Html.RenderPartial("Pager", Model.Pager)%></td>
    </tr>
</table>

<%  For Each dataset In Model.Items%>    
    <table width="100%" class="SearchGridItem">
            <tr>
           
                                <%If (DateTime.Now - dataset.PROVISION_DATE).Days <= 60 Then%>
                                       <td colspan="4" style="font-size: 1.1em; padding-bottom: 10px;"><img  src="<%=ResolveUrl("~/Content/icons/new.png")%>" /><%=dataset.Title%></td>
                                <%Else%>
                                       <td colspan="4" style="font-size: 1.1em; padding-top: 5px; padding-bottom: 10px;"><%=dataset.Title%></td>
                                <%End If%>
                                <%  If dataset.FILE_TYPE_CODE = "REPORT" Or dataset.FILE_TYPE_CODE = "ODATA" Or dataset.FILE_TYPE_CODE = "STATICREP" Or dataset.FILE_TYPE_CODE = "SHAPEFILE" Then%>                        
                                    <td  colspan="4" style="horiz-align:left"><a href="<%=Url.Action("Details", "Dataset", New RouteValueDictionary(New With {Key .id = dataset.DATASET_ID}))%>" class="LinkButton"><img src="<%=Me.ResolveUrl("~/Content/icons/arrow-right2.png")%>" />View Details</a></td>
                                <%  Else%>
                                    <td  colspan="4" style="horiz-align:left"><%=Html.FileTypeImageLink(dataset.FILE_TYPE_CODE, dataset.FileType.Name, Me.ResolveUrl("~/Content/icons/"), dataset.URL)%></td>                       
                                <%  End If%>
             </tr>
             <tr>
             <td colspan="8" class="borderClass" ></td>
             </tr>
        <tr>
            <td width="7%"  style="vertical-align: text-top"><strong>Posted Date:</strong></td>
            <td width="18%"  style="vertical-align: text-top">
                <%=dataset.PROVISION_DATE.ToString("MMM d, yyyy")%>
            </td>
            <td width="7%"  style="vertical-align: text-top"><strong>Category:</strong></td>
            <td width="33%"  style="vertical-align: text-top">
                &nbsp;&nbsp;
                 <%If dataset.DATASET_CATEGORies IsNot Nothing Then%>
                    <%=dataset.DATASET_CATEGORies.Where(Function(c) c.CATEGORY_CODE1.CATEGORY_CODE_SITES_X_REFs.Any(Function(x) x.SITE.NAME = siteCode)).OrderBy(Function(p) p.CATEGORY_CODE).Select(Function(c) c.CATEGORY_CODE1.NAME).Distinct.ToCSVString%>
                 <% else %>Not Specified<%End If%>
            </td>
            <td width="5%" style="vertical-align: text-top">
                <strong>Location:</strong>
            </td>
            <td rowspan="2" colspan="3" style=" vertical-align: text-top; padding-left: 0px;">
                
                 <%
                     Dim datasetRegions = dataset.DatasetRegions.Where(Function(dr) dr.Region.REGION_CODE_SITES_X_REFs.Any(Function(x) x.SITE.NAME = siteCode))
                     If datasetRegions.Count > 0 Then%>
                    <%=datasetRegions.Select(Function(dr) dr.Region.Name).Distinct.ToCSVString%>
                 <% else %>Not Specified<%End If%>
           </td>


        </tr>
        <tr>
            <td  style="vertical-align: text-top"><strong>Date Range:</strong></td>
            <td  style="vertical-align: text-top">
             <%=dataset.DATA_PERIOD_START_DATE.ToString("MMM d, yyyy")%> -
            <%If dataset.DATA_PERIOD_END_DATE.HasValue Then%>
                <%=dataset.DATA_PERIOD_END_DATE.Value.ToString("MMM d, yyyy")%>
            <%Else%>
                Present
            <%End If%>
            </td>
            <td  style="vertical-align: text-top"><strong>Source:</strong></td>
            <td colspan="1">
            <%  If dataset.ReportingSource IsNot Nothing Then
                    Dim datasetReportingSource = dataset.ReportingSource.REPORTING_SOURCE_SITES_X_REFs.Where(Function(a) a.SITE.NAME = siteCode)
                    If datasetReportingSource.Count > 0 Then%>
                        <%If dataset.ReportingSource.PARTNER_LOGOS_ICONS_ID > 0 Then%>
                            <table>
                                 <tr>
                                     <td align="left" valign="top"><img style="max-height: 50px;max-width:50px;"  src="<%=Url.Action("DisplayImage", "Dataset", New With {Key .id = dataset.ReportingSource.PARTNER_LOGOS_ICONS_ID})%>"/></td>
                                     <td align="center"><%=dataset.ReportingSource.Name%></td>
                                 </tr>
                             </table>
                        <%Else%>
                             &nbsp;&nbsp;<%=dataset.ReportingSource.Name%>
                        <%End If%>
                    <%End If%>
                <%End If%>
            </td>
        </tr>
    </table>
<%  Next%>
<table width="100%">
    <tr>
        <td align="right"><%Html.RenderPartial("Pager", Model.Pager)%></td>
    </tr>
</table>
<%End If%>