﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>
<% 
    Model.FormatChart(chBar)
    chBar.DataSource = Model.Data
    chBar.DataBind()
    
    If Model.Data.Count > 0 Then
        chBar.DataManipulator.InsertEmptyPoints(1, IntervalType.Days, "Disturbed,Reclaimed,Certified")
    End If
    
%>
<asp:Chart ID="chBar" runat="server" Height="450px" Width="700px">
    <Legends>
        <asp:Legend Alignment="Center" Docking="Bottom" 
            LegendItemOrder="ReversedSeriesOrder" Name="Legend1">
        </asp:Legend>
    </Legends>
    <Titles>
        <asp:Title Name="Title1" Text="Disturbed + Reclaimed + Certified">
        </asp:Title>
    </Titles>
    <Series>
        <asp:Series Name="Disturbed" ChartType="StackedColumn" 
            CustomProperties="PointWidth=0.7" Legend="Legend1" XValueMember="ReportYear" 
            YValueMembers="Disturbed">
        </asp:Series>
        <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" 
            CustomProperties="PointWidth=0.7" Legend="Legend1" Name="Reclaimed" 
            XValueMember="ReportYear" YValueMembers="Reclaimed">
        </asp:Series>
        <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" 
            CustomProperties="PointWidth=0.7" Legend="Legend1" Name="Certified" 
            XValueMember="ReportYear" YValueMembers="Certified">
        </asp:Series>
    </Series>
    <ChartAreas>
        <asp:ChartArea Name="ChartArea1">
            <AxisY Title="Hectares">
                <MajorGrid Interval="10000" />
                <LabelStyle Interval="10000" />
            </AxisY>
            <AxisX IsLabelAutoFit="False" Title="Year">
                <MajorTickMark Enabled="False" TickMarkStyle="InsideArea" />
                <LabelStyle Angle="-45" Interval="1" IsEndLabelVisible="False" />
            </AxisX>
        </asp:ChartArea>
    </ChartAreas>
</asp:Chart>
