﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.LandReclamation" %>
<%
    Dim data As List(Of HistoricalReclamationSummary) = CType(Model.Data, List(Of HistoricalReclamationSummary))
    Dim minYear As Integer = 0
    Dim maxYear As Integer = 0
    
    If data.Count > 0 Then
        minYear = data.Select(Function(d) d.ReportYear).Min
        maxYear = data.Select(Function(d) d.ReportYear).Max
    End If
   
    Dim projectNames As New List(Of String)
    For Each projData In data.GroupBy(Function(d) d.ProjectKey)
        
        Dim name As String = projData.First.ProjectHistoricalName
        
        If (Not projectNames.Exists(Function(a) a.Contains(name))) Then
            
            projectNames.Add(name)
            Dim series As New Series(name)
       
            For year As Integer = minYear To maxYear
                Dim aYear As Integer = year
                Dim active = (From d In projData Where d.ReportYear = aYear Select d.Disturbed - d.Reclaimed).FirstOrDefault
                series.Points.AddXY(year, active)
            Next
            
            series.ChartType = SeriesChartType.StackedArea
            series.MarkerBorderWidth = 0
            series.LegendText = name
            
            chArea.Series.Add(Series)
        End If
        
        
    Next
    Model.FormatChart(chArea)
%>

<asp:Chart ID="chArea" runat="server" Height="500px" Width="750px" >
    <Legends>
        <asp:Legend Alignment="Center" Docking="Top" Name="Legend1" LegendItemOrder="ReversedSeriesOrder">
        </asp:Legend>
    </Legends>
    <Titles>
        <asp:Title Name="Title1" Text="Historical Oil Sands Mine Active Land Tracking by Company">
        </asp:Title>
    </Titles>
    <ChartAreas>
        <asp:ChartArea Name="ChartArea1" BorderDashStyle="Solid">
            <AxisY Title="Hectares">
                <MajorGrid Interval="10000" />
                <MajorTickMark Interval="10000" />
                <LabelStyle Interval="10000" />
            </AxisY>
            <AxisX IsLabelAutoFit="False" IsMarginVisible="False" Title="Year">
                <MajorGrid Enabled="False" Interval="1" />
                <MajorTickMark Interval="1" />
                <LabelStyle Angle="-45" Interval="1" />
            </AxisX>
        </asp:ChartArea>
    </ChartAreas>
</asp:Chart>
