﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.Objects" %>
<%

    Dim data As List(Of YearlyWaterAllocationAndUse) = ctype(Model.Data, List(of YearlyWaterAllocationAndUse))
    Model.FormatChart(chBar)
    Dim projects = From d In data Select d.Project, d.Operator
    Dim x As Integer = 0
    For Each project In projects.Distinct().ToList()
        Dim oName As String = project.Operator
        Dim pName As String = project.Project
        Dim groupName As String = oName & "_" & pName
        Dim useSeries As New Series
        Dim allSeries As New Series
        useSeries.ChartType = SeriesChartType.StackedColumn
        allSeries.ChartType = SeriesChartType.StackedColumn
        Dim projData = data.Where(Function(p) p.Operator = oName And p.Project = pName).ToList()
        useSeries.Points.DataBind(projData, "Year", "UseValue", "")
        allSeries.Points.DataBind(projData, "Year", "ChartAllocatedValue", "")
        useSeries("StackedGroupName") = groupName
        allSeries("StackedGroupName") = groupName
        useSeries.LegendText = pName & " (Use)"
        allSeries.LegendText = pName & " (Allocated)"
        useSeries.Color = Model.Colors(x)
        allSeries.Color = Model.LightColors(x)
        chBar.Series.Add(useSeries)
        chBar.Series.Add(allSeries)
        x = x + 1
    Next
%>
<asp:Chart ID="chBar" runat="server" Height="700px" Width="1000px">
    <Titles>
        <asp:Title Name="ChartTitle" Text="Annual Water Use vs Water Allocation by Oil Sands Mining Operator">
        </asp:Title>
    </Titles>
    <Legends>
        <asp:Legend Docking="Bottom" Name="Legend1">
        </asp:Legend>
    </Legends>
    <ChartAreas>
        <asp:ChartArea Name="MainChartArea">
            <AxisX Title="Year">
            </AxisX>
            <AxisY Title="Actual vs. allocated Water Use (m³)" LabelAutoFitMaxFontSize="8">
                <LabelStyle Format="N0" />
            </AxisY>
        </asp:ChartArea>
    </ChartAreas>
</asp:Chart>
