﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models.ProviderObjects" %>
<%
    Dim data As EmissionsIntensityHistory = CType(Model.Data, EmissionsIntensityHistory)
    Dim frothTreatmentMessage = ""

    chLine.Titles("MainTitle").Text = "Emissions Intensity History Graph for " & data.ProjectName
    chLine.Titles("Disclaimer").Visible = False
    If data.CommonReportingProjects IsNot Nothing Then
        If data.CommonReportingProjects.Count > 0 Then
            Dim disclaimer As String = "* This project shares some reporting with "
            For Each project In data.CommonReportingProjects
                disclaimer &= project.Name & " and "
            Next
            disclaimer = disclaimer.Substring(0, disclaimer.Length - 4).Trim() & "."
            chLine.Titles("Disclaimer").Text = disclaimer
            chLine.Titles("Disclaimer").Visible = True
        End If
    End If
    Model.FormatChart(chLine)
    chLine.ChartAreas(0).AxisY.Title = "Intensity " & vbCrLf & "(kg CO2e / Barrel of " & data.Produces & ")"
    chLine.DataSource = data.Intensities
    chLine.DataBind()

    Dim projectId = Request.QueryString("ProjectId")
    Dim projectId1 = data.ProjectId

    Dim url = "#"
    Dim target = String.Empty
    Dim urlReferrer As Uri = Request.UrlReferrer

    If urlReferrer IsNot Nothing Then
        If Not (Request.UrlReferrer.AbsoluteUri.Contains("Details")) Then
            url = "/library/Dataset/Details/22?ProjectId=" + IIf(projectId IsNot Nothing, projectId, projectId1)
            target = "_blank"
        End If
    End If
    If data.FrothTreatment Then
        frothTreatmentMessage = "The production total presented here is prior to the froth treatment; typically the froth treatment results in a 2% loss in bitumen."
    End If

%>

<table>
    <tr>
        <td>
<asp:Chart ID="chLine" runat="server" Height="450px" Width="750px">
    <Titles>
        <asp:Title Name="MainTitle">
        </asp:Title>
        <asp:Title Alignment="BottomCenter" Docking="Bottom" Name="Disclaimer">
        </asp:Title>
    </Titles>
    <Series>
        <asp:Series ChartType="Line" MarkerSize="8" MarkerStyle="Diamond" 
            Name="Intensity" XValueMember="Year" YValueMembers="Intensity">
        </asp:Series>
    </Series>
    <ChartAreas>
        <asp:ChartArea Name="ChartArea1">
            <AxisY>
            </AxisY>
            <AxisX Title="Year">
            </AxisX>
        </asp:ChartArea>
    </ChartAreas>
</asp:Chart>
</td>
</tr>
 <tr>
        <td>
           
            <asp:Label ID="lblViewmore" runat="server" Text="For more details, usage considerations and data downloads" ></asp:Label>
            <a  href='<%=url%>' target="<%=target%>">"View GHG emissions intensity history data library page"</a>
             <br/>
            <%=frothTreatmentMessage%>
        </td>
    </tr>
</table>