﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models.ProviderObjects" %>

<%
    Dim data As GHGEmissionHistorySummary = CType(Model.Data, GHGEmissionHistorySummary)
    chBar.Titles("MainTitle").Text = "Greenhouse Gas Emissions from " & data.ProjectName
    For Each item In data.YearlyValues
        If item.SGERProduction.HasValue Then
            chBar.Series("SGERProduction").Points.AddXY(item.Year, item.SGERProduction)
        End If
        If item.SGERElectricity.HasValue Then
            chBar.Series("SGERElectricity").Points.AddXY(item.Year, item.SGERElectricity)
        End If
        If item.SGRRTotal.HasValue Then
            chBar.Series("SGRRTotal").Points.AddXY(item.Year, item.SGRRTotal)
        End If
    Next
    Model.FormatChart(chBar)

    Dim projectId = Request.QueryString("ProjectId")
    Dim projectId1 = data.ProjectId

    Dim url = "#"
    Dim target = String.Empty
    Dim urlReferrer As Uri = Request.UrlReferrer

    If urlReferrer IsNot Nothing Then
        If Not (Request.UrlReferrer.AbsoluteUri.Contains("Details")) Then
            url = "/library/Dataset/Details/23?ProjectId=" + IIf(projectId IsNot Nothing, projectId, projectId1)
            target = "_blank"
        End If
    End If

    If Not IsNothing(Model.Data) Then
        chBar.DataManipulator.InsertEmptyPoints(1, IntervalType.Days, "SGERProduction, SGERElectricity,SGRRTotal")
    End If
%>
<table>
    <tr>
        <td>
            <asp:Chart ID="chBar" runat="server" Height="450px" Width="700px">
                <Legends>
                    <asp:Legend Alignment="Center" Name="Legend1">
                    </asp:Legend>
                </Legends>
                <Titles>
                    <asp:Title Name="MainTitle">
                    </asp:Title>
                </Titles>
                <Series>
                    <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
                        LegendText="Tonnes of greenhouse gas emissions associated with production of bitumen or synthetic crude" 
                        Name="SGERProduction">
                    </asp:Series>
                    <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
                        LegendText="Tonnes of greenhouse gas emissions associated with on-site co-generation of electricity" 
                        Name="SGERElectricity">
                    </asp:Series>
                    <asp:Series ChartArea="ChartArea1" Legend="Legend1" 
                        LegendText="Tonnes total greenhouse gas emissions (from Specified Gas Reporting Regulation)" Name="SGRRTotal">
                    </asp:Series>
                </Series>
                <ChartAreas>
                    <asp:ChartArea Name="ChartArea1">
                        <AxisY Title="Tonnes CO2e">
                            <LabelStyle Format="N0" />
                        </AxisY>
                        <AxisX Title="Year">
                            <LabelStyle Angle="30" />
                        </AxisX>
                    </asp:ChartArea>
                </ChartAreas>
            </asp:Chart>
        </td>
    </tr>
    
     <tr>
        <td>
            <asp:Label ID="lblViewmore" runat="server" Text="For more details, usage considerations and data downloads" ></asp:Label>
            <a  href='<%=url%>' target="<%=target%>">"View emissions history data library page"</a>
        </td>
    </tr>

</table>

