﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.Objects" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models.ProviderObjects" %>
<%
    Dim data As WaterUseIntensityHistory = CType(Model.Data, WaterUseIntensityHistory)
    Dim frothTreatmentMessage = ""
    
    If data.FrothTreatment Then
        frothTreatmentMessage = "The production total presented here is prior to the froth treatment; typically the froth treatment results in a 2% loss in bitumen."
    End If
    
    chLine.Titles.First.Text = "Historical Water Use per Barrel of " & data.Production & " Produced"
    Dim series As New Series()
    series.LegendText = data.ProjectName
    series.Points.DataBind(data.Values.OrderBy(Function(v) v.Year).ToList(), "Year", "WaterUsedPerBarrelProduced", "")
    series.BorderWidth = 3
    series.ChartType = SeriesChartType.Line
    If data.Values.Count = 1 Then
        series.MarkerStyle = MarkerStyle.Circle
        series.MarkerSize = 8
    End If
    chLine.Series.Add(series)
    Model.FormatChart(chLine)
%>


<asp:Chart ID="chLine" runat="server" Height="450px" Width="700px">
    <Legends>
        <asp:Legend Docking="Top" Name="Legend1">
        </asp:Legend>
    </Legends>
    <Titles>
        <asp:Title Name="Title1" Text="Historical Water Use per Barrel of Oil Produced">
        </asp:Title>
    </Titles>
    <Series></Series>
    <ChartAreas>
        <asp:ChartArea Name="ChartArea1">
            <AxisY Title="Barrels of Fresh Water">
            </AxisY>
            <AxisX Title="Year">
                <MajorGrid Interval="1" />
                <LabelStyle Angle="-45"  />
            </AxisX>
        </asp:ChartArea>
    </ChartAreas>
</asp:Chart>

<br/>
<%=frothTreatmentMessage%>