﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.GHGEmissions" %>
<%  
    Dim data As EmissionsByCountry = CType(Model.Data, EmissionsByCountry)
    For Each item In data.CountryEmissions.OrderByDescending(Function(ce) ce.Emissions).ToList()
        Dim index As Integer = chPie.Series.First.Points.AddXY(item.Country, item.Emissions)
        If item.Country = "Canada" Then
            Dim point As DataPoint = chPie.Series.First.Points(index)
            point.CustomProperties = "PieLabelStyle=Outside, PieLineColor=Black, Exploded=True"
            point.Label = "Alberta's Oil Sands account for less than 0.15% of the world's GHG emissions"
        End If
    Next
    chPie.Titles.First.Text = "Global Energy-Related Emissions (" & data.Year & ")"
    chPie.Titles.Last.Text = "Source: " & data.Source

       
    
    Model.FormatChart(chPie)
%>
<asp:Chart ID="chPie" runat="server" Height="400px" Width="700px">
    <Legends>
        <asp:Legend Alignment="Center" Name="Legend1">
        </asp:Legend>
    </Legends>
    <Titles>
        <asp:Title Name="MainTitle" 
            Text="Global Energy-Related Emissions">
        </asp:Title>
        <asp:Title Alignment="BottomRight" 
            Docking="Bottom" Name="Source">
        </asp:Title>
    </Titles>
    <Series>
        <asp:Series BorderColor="White" ChartType="Pie" Legend="Legend1" Name="Series1" 
            CustomProperties="PieStartAngle=45, MinimumRelativePieSize=70,PieLabelStyle=Disabled"
            LegendText="#VALX (#PERCENT)">
        </asp:Series>
    </Series>
    <ChartAreas>
        <asp:ChartArea Name="ChartArea1" >
            <InnerPlotPosition Height="75" Width="60" X="10" Y="12.500001" />
        </asp:ChartArea>
    </ChartAreas>
</asp:Chart>

