﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>

<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.Objects" %>
<%
    Dim data As List(Of ProjectEmission) = CType(Model.Data, List(Of ProjectEmission))
    Dim latest As ProjectEmission = data.OrderByDescending(Function(d) d.Year).First()
    chPie.Series("Series1").Points.AddXY("Carbon Dioxide", latest.CarbonDioxide)
    chPie.Series("Series1").Points.AddXY("Methane", latest.Methane)
    chPie.Series("Series1").Points.AddXY("Nitrous Oxide", latest.NitrousOxide)
    chPie.Series("Series1").Points.AddXY("Hydrofluorocarbons", latest.Hydrofluorocarbons)
    chPie.Series("Series1").Points.AddXY("Perfluorocarbons", latest.Perfluorocarbons)
    chPie.Series("Series1").Points.AddXY("Sulfur Hexafluoride", latest.SulfurHexafluoride)
    chPie.Titles("MainTitle").Text = "Latest GHG Emissions (" & latest.Year.ToString & ") for " & latest.ProjectName
    Model.FormatChart(chPie)
%>

<asp:Chart ID="chPie" runat="server" Width="700px" Height="475px">
    <Legends>
        <asp:Legend Alignment="Center" Name="Legend1" Docking="Top">
        </asp:Legend>
    </Legends>
    <Titles>
        <asp:Title Name="MainTitle">
        </asp:Title>
    </Titles>
    <Series>
        <asp:Series ChartArea="ChartArea1" ChartType="Pie" Legend="Legend1" 
            Name="Series1" CustomProperties="PieLabelStyle=Outside" Label="#PERCENT" 
            LegendText="#VALX">
        </asp:Series>
    </Series>
    <ChartAreas>
        <asp:ChartArea Name="ChartArea1">
        <InnerPlotPosition Height="97.80219" Width="97.80219" X="1" Y="1" />
            <Area3DStyle Enable3D="True" Inclination="50" />
        </asp:ChartArea>
    </ChartAreas>
</asp:Chart>