﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models.ProviderObjects" %>

<%
    Dim data As CurrentReclamationSummary = CType(Model.Data, CurrentReclamationSummary)
    Model.FormatChart(chBar)
    Dim yAxisTitle As String = "Hectares"
    Select Case data.Unit
        Case GoA.Environment.OSIP.DataLibrary.LandReclamationUnits.Acres
            yAxisTitle = "Acres"
        Case GoA.Environment.OSIP.DataLibrary.LandReclamationUnits.Hectares
            yAxisTitle = "Hectares"
        Case GoA.Environment.OSIP.DataLibrary.LandReclamationUnits.KmSquared
            yAxisTitle = "Kilometres Squared"
        Case GoA.Environment.OSIP.DataLibrary.LandReclamationUnits.MilesSquared
            yAxisTitle = "Miles Squared"
    End Select
    Dim dateString As String = "December 31, " & data.Records.First.ReportYear.ToString()
    chBar.Titles.First.Text = "Regional Reclamation and Disturbance Tracking by Company, to " & dateString
    chBar.ChartAreas.First.AxisY.Title = yAxisTitle
    chBar.DataSource = data.Records
    chBar.DataBind()

    Dim url = "#"
    Dim target = String.Empty
    Dim urlReferrer As Uri = Request.UrlReferrer

    If urlReferrer IsNot Nothing Then
        If Not (Request.UrlReferrer.AbsoluteUri.Contains("Details")) Then
            url = "/library/Dataset/Details/29"
            target = "_blank"
        End If
    End If

    If data.Records.Count > 0 Then
        chBar.DataManipulator.InsertEmptyPoints(1, IntervalType.Days, "Cleared,Distrubed,ReadyforReclamation,SoilsPlaced,PermanentReclamation(Terrestrial),PermanentReclamation(WetlandsandAquatics),TemporaryReclamation(Terrestrial),Certified")
    End If
%>

<table>
    <tr>
       <td>
            <asp:Chart ID="chBar" runat="server" Height="500px" Width="900px">
                <Legends>
                    <asp:Legend Alignment="Center" MaximumAutoSize="33" Name="Legend1">
                    </asp:Legend>
                </Legends>
                <Titles>
                    <asp:Title Name="Title1" 
                        Text="Regional Cumulative Totals to the End of the Reporting Year">
                    </asp:Title>
                </Titles>
                <Series>
                    <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" 
                        CustomProperties="PointWidth=0.5" Legend="Legend1" LegendText="Cleared" 
                        Name="Cleared" XValueMember="ProjectName" YValueMembers="Cleared">
                    </asp:Series>
                    <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
                        CustomProperties="PointWidth=0.5" LegendText="Disturbed: Used for Mine or Plant Purposes" Name="Distrubed" 
                        XValueMember="ProjectName" YValueMembers="DisturbedMinePlant">
                    </asp:Series>
                    <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
                        CustomProperties="PointWidth=0.5" LegendText="Ready for Reclamation: No Longer Used for Mine or Plant Purposes" 
                        Name="ReadyforReclamation" XValueMember="ProjectName" 
                        YValueMembers="ReadyForReclamation">
                    </asp:Series>
                    <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
                        CustomProperties="PointWidth=0.5" LegendText="Soils Placed (Terrestrial &amp; Wetlands &amp; Aquatics)" 
                        Name="SoilsPlaced" XValueMember="ProjectName" YValueMembers="SoilsPlaced">
                    </asp:Series>
                    <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
                        CustomProperties="PointWidth=0.5" LegendText="Permanent Reclamation (Terrestrial)" 
                        Name="PermanentReclamation(Terrestrial)" XValueMember="ProjectName" 
                        YValueMembers="PermanentRecTerrestrial">
                    </asp:Series>
                    <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
                        CustomProperties="PointWidth=0.5" LegendText="Permanent Reclamation (Wetlands &amp; Aquatics)" 
                        Name="PermanentReclamation(WetlandsandAquatics)" 
                        XValueMember="ProjectName" YValueMembers="PermanentRecWetlandsAquatics">
                    </asp:Series>
                    <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
                        CustomProperties="PointWidth=0.5" LegendText="Temporary Reclamation (Terrestrial)" 
                        Name="TemporaryReclamation(Terrestrial)" XValueMember="ProjectName" 
                        YValueMembers="TemporaryRecTerrestrial">
                    </asp:Series>
                    <asp:Series ChartType="StackedColumn" Legend="Legend1" LegendText="Certified" 
                        CustomProperties="PointWidth=0.5" Name="Certified" XValueMember="ProjectName" YValueMembers="Certified">
                    </asp:Series>
                </Series>
                <ChartAreas>
                    <asp:ChartArea Name="ChartArea1">
                        <AxisX>
                            <LabelStyle Angle="-45" />
                        </AxisX>
                    </asp:ChartArea>
                </ChartAreas>
            </asp:Chart>
        </td>
    </tr>

    <tr>
        <td>
            <asp:Label ID="lblViewmore" runat="server" Text="For more details, usage considerations and data downloads" ></asp:Label>
            <a  href='<%=url%>' target="<%=target%>">"View data library page"</a>
        </td>
    </tr>

</table>