﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models.ProviderObjects" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary" %>
<%
    Dim data As OperatorWaterUseHistory = CType(Model.Data, OperatorWaterUseHistory)
    Dim years As List(Of Integer) = data.WaterUseHistory.Select(Function(h) h.Year).Distinct.ToList
    Dim brackish = From b In data.WaterUseHistory Where b.BrackishWaterUse.HasValue Select b.BrackishWaterUse, b.Year
    For Each item In brackish
        chLine.Series("Brackish").Points.AddXY(item.Year, item.BrackishWaterUse)
    Next
    Dim maxBrackish As Nullable(Of Decimal) = brackish.Select(Function(b) b.BrackishWaterUse).Max()
    Dim fresh = From b In data.WaterUseHistory Where b.FreshWaterUse.HasValue Select b.FreshWaterUse, b.Year
    For Each item In fresh
        chLine.Series("Fresh").Points.AddXY(item.Year, item.FreshWaterUse)
    Next
    Dim maxFresh As Nullable(Of Decimal) = fresh.Select(Function(f) f.FreshWaterUse).Max()
    Dim maximum As Nullable(Of Decimal) = maxFresh
    If maxBrackish > maxFresh Then
        maximum = maxBrackish
    End If
    Dim upperLimit As Double = maximum.GetUpperLimit()
    Model.FormatChart(chLine)
    chLine.Titles(0).Text = String.Format("{0} Water Use", data.OperatorName)
    chLine.ChartAreas.First().AxisY.Maximum = upperLimit
    chLine.ChartAreas.First().AxisY.Interval = upperLimit / 4
    chLine.ChartAreas.First().AxisY2.Maximum = upperLimit * 6.29295
    chLine.ChartAreas.First().AxisY2.Interval = (upperLimit * 6.29295) / 4

    Dim projectId1 = data.ProjectId

    Dim url = "#"
    Dim target = String.Empty
    Dim urlReferrer As Uri = Request.UrlReferrer

    If urlReferrer IsNot Nothing Then
        If Not (Request.UrlReferrer.AbsoluteUri.Contains("Details")) Then
            url = "/library/Dataset/Details/56?ProjectId=" + projectId1
            target = "_blank"
        End If
    End If

%>

<table>
    <tr>
        <td>
            <asp:Chart ID="chLine" runat="server" Width="750px" Height="475px">
            <Legends>
                <asp:Legend Alignment="Center" Name="Legend1">
                </asp:Legend>
            </Legends>
            <Titles>
                <asp:Title Name="Title1">
                </asp:Title>
            </Titles>
            <Series>
                <asp:Series Name="Fresh" ChartType="Line" MarkerStyle="Square" 
                   Legend="Legend1">
                </asp:Series>
                <asp:Series ChartArea="ChartArea1" ChartType="Line" MarkerStyle="Square" 
                    Name="Brackish"       Legend="Legend1">
                </asp:Series>
            </Series>
            <ChartAreas>
                <asp:ChartArea Name="ChartArea1">
                    <AxisY Title="Water Use (m3)">
                        <LabelStyle Format="N0" />
                    </AxisY>
                    <AxisX Title="Year" IsLabelAutoFit="False">
                        <LabelStyle Angle="-45" />
                    </AxisX>
                    <AxisY2 Enabled="True" Title="Water Use (barrels)">
                        <LabelStyle Format="N0" />
                    </AxisY2>
                </asp:ChartArea>
            </ChartAreas>
        </asp:Chart>
        </td>
    </tr>
    <tr>
        <td>
            <asp:Label ID="lblViewmore" runat="server" Text="For more details, usage considerations and data downloads" ></asp:Label>
            <a  href='<%=url%>' target="<%=target%>">"View water use history data library page"</a>
        </td>
    </tr>
</table>

