﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models.ProviderObjects" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.Objects" %>

<% 
    Dim data As PollutantTrend = CType(Model.Data, PollutantTrend)
    Dim chartTitle As String = "Pollutant Trend report for {0}"
    chLine.Titles("SubTitle").Text = data.StartDate.ToString("g") & " to " & data.EndDate.ToString("g")
    If data.Measurements.Count > 0 Then
        Dim groupData As List(Of IGrouping(Of String, AQPollutantMeasurement))
        If data.MultipleStations Then
            chartTitle = String.Format(chartTitle, data.Measurements.First.ParameterWithUnit)
            chLine.ChartAreas.First.AxisY.Title = data.Measurements.First.ParameterWithUnit
            groupData = data.Measurements.GroupBy(Function(m) m.Station).ToList()
        Else
            chartTitle = String.Format(chartTitle, data.Measurements.First.Station)
            groupData = data.Measurements.GroupBy(Function(m) m.ParameterWithUnit).ToList()
        End If
        For Each item In groupData
            Dim series As New Series(item.Key)
            series.ChartType = SeriesChartType.Line
            series.BorderWidth = 1
            series.Points.DataBind(item.ToList(), "ReadingDateTime", "Value", "")
            chLine.Series.Add(series)
        Next
    Else
        chartTitle = "No data for selected criteria."
    End If
    Model.FormatChart(chLine)
    chLine.Titles("MainTitle").Text = chartTitle
%>
<asp:Chart ID="chLine" runat="server" Height="525px" Width="1000px">
    <Legends>
        <asp:Legend Alignment="Center" Name="Legend1">
        </asp:Legend>
    </Legends>
    <Titles>
        <asp:Title Name="MainTitle">
        </asp:Title>
        <asp:Title Name="SubTitle"></asp:Title>
    </Titles>
    <Series>
    </Series>
    <ChartAreas>
        <asp:ChartArea Name="ChartArea1">
        </asp:ChartArea>
    </ChartAreas>
</asp:Chart>
