﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>

<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.Objects" %>
<%
    Dim data As List(Of ProjectEmission) = CType(Model.Data, List(Of ProjectEmission))
    chBar.Titles.First.Text = "Yearly GHG Emission Totals for " & data.First().ProjectName
    Model.FormatChart(chBar)
    chBar.DataSource = data
    chBar.DataBind()
    
    If data.Count > 0 Then
        chBar.DataManipulator.InsertEmptyPoints(1, IntervalType.Days, "C02,CH4,N2O,HFCs,PFCs,SF6")
    End If
    
%>

<asp:Chart ID="chBar" runat="server" Width="900px" Height="550px">
    <Legends>
        <asp:Legend Alignment="Center" Name="Legend1" 
            LegendItemOrder="ReversedSeriesOrder">
        </asp:Legend>
    </Legends>
    <Titles>
        <asp:Title Name="Title1" Text="Total Tonnes CO2e">
        </asp:Title>
    </Titles>
    <Series>
        <asp:Series Name="C02" LegendText="Carbon Dioxide" XValueMember="Year" 
            YValueMembers="CarbonDioxide" Legend="Legend1" ChartType="StackedColumn"></asp:Series>
        <asp:Series Name="CH4" LegendText="Methane" XValueMember="Year" 
            YValueMembers="Methane" Legend="Legend1" ChartType="StackedColumn"></asp:Series>
        <asp:Series Name="N2O" LegendText="Nitrous Oxide" XValueMember="Year" 
            YValueMembers="NitrousOxide" Legend="Legend1" ChartType="StackedColumn"></asp:Series>
        <asp:Series Name="HFCs" LegendText="Hydrofluorocarbons" XValueMember="Year" 
            YValueMembers="Hydrofluorocarbons" Legend="Legend1" 
            ChartType="StackedColumn"></asp:Series>
        <asp:Series Name="PFCs" LegendText="Perfluorocarbons" XValueMember="Year" 
            YValueMembers="Perfluorocarbons" Legend="Legend1" 
            ChartType="StackedColumn"></asp:Series>
        <asp:Series Name="SF6" LegendText="Sulfur Hexafluoride" XValueMember="Year" 
            YValueMembers="SulfurHexafluoride" Legend="Legend1" 
            ChartType="StackedColumn"></asp:Series>
    </Series>
    <ChartAreas>
        <asp:ChartArea Name="ChartArea1">
            <AxisY Title="Tonnes CO2e">               
                <LabelStyle Format="N0" />
                
            </AxisY>
            <AxisX IsLabelAutoFit="False" Title="Year">
                <MajorGrid Enabled="False" />
                <MajorTickMark Interval="1" />
            </AxisX>
        </asp:ChartArea>
    </ChartAreas>
</asp:Chart>