﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models.ProviderObjects" %>
<%@ Import Namespace="System.Web.Configuration" %>
<%
    Dim data As ProductionHistory = CType(Model.Data, ProductionHistory)
    Dim frothTreatmentMessage = ""
    
    Model.FormatChart(chBar)
    chBar.Titles.First.Text = "Historic Production for " & data.ProjectName
    chBar.ChartAreas.First.AxisY.Title = "Production (m3) " & data.Product
    chBar.ChartAreas.First.AxisY2.Title = "Production (barrels) " & data.Product
    
    If data.FrothTreatment Then
        frothTreatmentMessage = "The production total presented here is prior to the froth treatment; typically the froth treatment results in a 2% loss in bitumen."
    End If
    
    If data.ProductionData Is Nothing Then
        chBar.Titles.First.Text = "Production data is unavailable for this project"
        
    Else
        Dim allProductionValue = From b In data.ProductionData Where b.ProductionValue.HasValue Select b.ProductionValue, b.Year
        Dim maxProductionValue As Nullable(Of Decimal) = allProductionValue.Select(Function(f) f.ProductionValue).Max()
        Dim maximum As Nullable(Of Decimal) = maxProductionValue
    
        chBar.ChartAreas.First().AxisY.Maximum = maximum
        chBar.ChartAreas.First().AxisY.Interval = maximum / 4
        chBar.ChartAreas.First().AxisY2.Maximum = maximum * 6.29295
        chBar.ChartAreas.First().AxisY2.Interval = (maximum * 6.29295) / 4
    
        chBar.DataSource = data.ProductionData
        chBar.DataBind()

    End If
    
    Dim projectId = Request.QueryString("ProjectId")
    Dim projectId1 = data.ProjectId
    

    
%>
<table>
    <tr>
        <td>
            <asp:Chart ID="chBar" runat="server" Width="700px" Height="400px">
            <Titles>
                <asp:Title Name="Title1">
                </asp:Title>
            </Titles>
            <Series>
                <asp:Series Name="Series1" XValueMember="Year" YValueMembers="ProductionValue">
                </asp:Series>
            </Series>
            <ChartAreas>
                <asp:ChartArea Name="ChartArea1">
                    <AxisY Title="Production">
                        <LabelStyle Format="N0"/>
                    </AxisY>
                    <AxisX Title="Year">
                        <MajorGrid Enabled="False" Interval="1" />
                        <MajorTickMark Interval="1" />
                        <LabelStyle IntervalOffset="1" Angle="-45" />
                    </AxisX>
                    <AxisY2 Enabled="True" Title="">
                        <LabelStyle Format="N0" />
                    </AxisY2>
                </asp:ChartArea>
            </ChartAreas>
        </asp:Chart>
        </td>
    </tr>
    <tr>
        <td>
            For more details, usage considerations and data downloads
            <a target="_blank"  href='/library/Dataset/Details/45?ProjectId=<%=IIf(projectId IsNot Nothing,projectId,projectId1 )%>'>"View production history data library page"</a>
            <br/>
            <%=frothTreatmentMessage%>
        </td>
    </tr>
    
</table>





