﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.GHGEmissions" %>
<%
    Dim data As List(Of ProvincialEmission) = CType(Model.Data, List(Of ProvincialEmission))
    chBar.Titles.First.Text = "Total  Tonnes CO2e (" & data.First.Year & ")"
    Model.FormatChart(chBar)
    chBar.DataSource = data
    chBar.DataBind()
%>

<asp:Chart ID="chBar" runat="server" Width="900px" Height="550px">
    <Legends>
        <asp:Legend Alignment="Center" Docking="Top" Name="Legend1">
        </asp:Legend>
    </Legends>
    <Titles>
        <asp:Title Name="Title1" Text="Total Tonnes CO2e">
        </asp:Title>
    </Titles>
    <Series>
        <asp:Series Name="C02" LegendText="Carbon Dioxide" XValueMember="Province" 
            YValueMembers="CarbonDioxide" Legend="Legend1"></asp:Series>
        <asp:Series Name="CH4" LegendText="Methane" XValueMember="Province" 
            YValueMembers="Methane" Legend="Legend1"></asp:Series>
        <asp:Series Name="N2O" LegendText="Nitrous Oxide" XValueMember="Province" 
            YValueMembers="NitrousOxide" Legend="Legend1"></asp:Series>
        <asp:Series Name="HFCs" LegendText="Hydrofluorocarbons" XValueMember="Province" 
            YValueMembers="Hydrofluorocarbons" Legend="Legend1"></asp:Series>
        <asp:Series Name="PFCs" LegendText="Perfluorocarbons" XValueMember="Province" 
            YValueMembers="Perfluorocarbons" Legend="Legend1"></asp:Series>
        <asp:Series Name="SF6" LegendText="Sulfur Hexafluoride" XValueMember="Province" 
            YValueMembers="SulfurHexafluoride" Legend="Legend1"></asp:Series>
        <asp:Series Name="Total" LegendText="Total" XValueMember="Province" 
            YValueMembers="Total" Legend="Legend1"></asp:Series>
    </Series>
    <ChartAreas>
        <asp:ChartArea Name="ChartArea1">
            <AxisY Interval="50000000" Title="Total Tonnes CO2e">
                <MajorGrid Interval="50000000" />
                <MajorTickMark Interval="50000000" />
                
                <LabelStyle Format="N0" />
                
            </AxisY>
            <AxisX IsLabelAutoFit="False" Title="Province">
                <MajorGrid Enabled="False" />
                <MajorTickMark Interval="1" />
                <LabelStyle Angle="-45" Interval="1" />
            </AxisX>
        </asp:ChartArea>
    </ChartAreas>
</asp:Chart>
