﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models.ProviderObjects" %>
<%
    Dim data As SGERComplianceSummary = CType(Model.Data, SGERComplianceSummary)
    chMain.Titles("MainTitle").Text = "Facility Emissions and SGER Required Activity for " & data.ProjectName
    chMain.Titles("Disclaimer").Visible = False
    If data.CommonReportingProjects IsNot Nothing Then
        If data.CommonReportingProjects.Count > 0 Then
            Dim disclaimer As String = "* This project shares some reporting with "
            For Each project In data.CommonReportingProjects
                disclaimer &= project.Name & " and "
            Next
            disclaimer = disclaimer.Substring(0, disclaimer.Length - 4).Trim() & "."
            chMain.Titles("Disclaimer").Text = disclaimer
            chMain.Titles("Disclaimer").Visible = True
        End If
    End If
    Model.FormatChart(chMain)
    chMain.DataSource = data.Summaries
    chMain.DataBind()
    chMain.Series(0).Color = Model.Colors(6)
    chMain.Series(1).Color = Model.Colors(5)
    chMain.Series(2).Color = Model.Colors(4)
    chMain.Series(3).Color = Model.Colors(3)
    chMain.Series(4).Color = Model.Colors(2)
    chMain.Series(5).Color = Model.Colors(1)
    chMain.Series(6).Color = Model.Colors(0)
    chMain.Series(7).Color = Model.Colors(7)
    chMain.Legends.First().CustomItems.First().Color = Model.Colors(7)


    Dim projectId = Request.QueryString("ProjectId")
    Dim projectId1 = data.ProjectId

    Dim url = "#"
    Dim target = String.Empty
    Dim urlReferrer As Uri = Request.UrlReferrer

    If urlReferrer IsNot Nothing Then
        If Not (Request.UrlReferrer.AbsoluteUri.Contains("Details")) Then
            url = "/library/Dataset/Details/18?ProjectId=" + IIf(projectId IsNot Nothing, projectId, projectId1)
            target = "_blank"
        End If
    End If

    If data.Summaries.Count > 0 Then
        chMain.DataManipulator.InsertEmptyPoints(1, IntervalType.Days, "EmissionsNetCompliance,FundContributions,Offsets,EPCsRetired,CogenEfficiencyCredit,IncCogenElectricityEmissions,TotalOnsiteEmissions,EPCsGenerated")
    End If
%>

<table>
    <tr>
        <td>
            <asp:Chart ID="chMain" runat="server" Height="500px" Width="800px">
    <Legends>
        <asp:Legend Alignment="Center" Name="Legend1">
            <CustomItems>
                <asp:LegendItem ImageStyle="Line" Name="EPCs Generated" 
                        MarkerSize="8" MarkerStyle="Triangle" MarkerBorderWidth="0" BorderWidth="2"></asp:LegendItem>
            </CustomItems>
        </asp:Legend>
    </Legends>
    <Titles>
        <asp:Title Name="MainTitle"></asp:Title>
        <asp:Title Alignment="BottomCenter" Docking="Bottom" Name="Disclaimer">
        </asp:Title>
        <asp:Title Alignment="BottomCenter" Docking="Bottom" Name="Disclaimer2" 
            Text="The first period of mandatory reductions for established facilities was July 1 to December 31 2007.  Details of the method of compliance for the 2007 half year period are currently unavailable.  All subsequent compliance cycles cover entire calendar years.">
        </asp:Title>
    </Titles>
    <Series>
        <asp:Series ChartType="StackedColumn" Legend="Legend1" 
            LegendText="Emissions net of SGER requirements" Name="EmissionsNetCompliance" 
                XValueMember="Year" YValueMembers="EmissionsNetCompliance">
        </asp:Series>
        <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
            LegendText="Climate Change Emissions Management Fund contributions" Name="FundContributions"
                XValueMember="Year" YValueMembers="FundCreditsPurchased">
        </asp:Series>
        <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
            LegendText="Offsets retired" Name="Offsets"
                XValueMember="Year" YValueMembers="OffsetsSubmitted">
        </asp:Series>
        <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
            LegendText="EPCs Retired" Name="EPCsRetired"
                XValueMember="Year" YValueMembers="EPCsRetired">
        </asp:Series>
        <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
            LegendText="Cogen efficiency credit" Name="CogenEfficiencyCredit"
                XValueMember="Year" YValueMembers="CogenEfficiencyCredit">
        </asp:Series>
         <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
            LegendText="Incremental cogeneration electricity emissions" 
            Name="IncCogenElectricityEmissions" XValueMember="Year" YValueMembers="GHGFromElectricity">
        </asp:Series>
        <asp:Series ChartArea="ChartArea1" ChartType="Point" Legend="Legend1" 
            LegendText="Total on-site emissions" MarkerSize="20" MarkerStyle="Star4" 
            Name="TotalOnsiteEmissions" XValueMember="Year" YValueMembers="TotalGHGEmissions">
        </asp:Series>
        <asp:Series ChartArea="ChartArea1" ChartType="Line" Legend="Legend1" 
            LegendText="EPCs generated" MarkerSize="8" MarkerStyle="Triangle" 
            Name="EPCsGenerated" XValueMember="Year" YValueMembers="EPCsGenerated" IsVisibleInLegend="False">
        </asp:Series>     
    </Series>
    <ChartAreas>
        <asp:ChartArea Name="ChartArea1">
            <AxisY Title="Tonnes of CO2e">
                <LabelStyle Format="N0" />
            </AxisY>
            <AxisX Title="Year">
                <LabelStyle Angle="-45" />
            </AxisX>
        </asp:ChartArea>
    </ChartAreas>
</asp:Chart>
        </td>
    </tr>
    <tr>
        <td>
            <asp:Label ID="lblViewmore" runat="server" Text="For more details, usage considerations and data downloads" ></asp:Label>
            <a  href='<%=url%>' target="<%=target%>">"View emissions history data library page"</a>
        </td>
    </tr>
</table>

