﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.LandReclamation" %>
<%
    Dim data As List(Of CumulativeSecurityFundContribution) = CType(Model.Data, List(Of CumulativeSecurityFundContribution))
       
    
    For Each item In data.AsQueryable().GroupBy(Function(d) d.ProjectGroup)
        Dim project As ProjectGroup = item.First.ProjectGroup
        Dim series As New Series(project.ProjectGroupName)
        series.ChartType = SeriesChartType.Line
        For Each constribution In item.OrderBy(Function(i) i.Year).ToList()
            series.Points.AddXY(constribution.Year, constribution.Value)
        Next
        series.LegendText = project.ProjectGroupName
        series.BorderWidth = 2
        chLine.Series.Add(series)
    Next
    Model.FormatChart(chLine)
%>

<asp:Chart ID="chLine" runat="server" Width="800px" Height="450px">
    <Legends>
        <asp:Legend Name="Legend1" Docking="Bottom" Alignment="Center">
        </asp:Legend>
    </Legends>
    <Titles>
        <asp:Title Name="Title1" 
            Text="Reclamation Security Fund Contributions over Time">
        </asp:Title>
    </Titles>
    <ChartAreas>
        <asp:ChartArea Name="Main">
            <AxisY Title="Yearly Contributions ($)">
                <MajorGrid Interval="50000000" />
                <MajorTickMark Interval="50000000" />
                <LabelStyle Format="C" Interval="50000000" />
            </AxisY>
            <AxisX Title="Year" IsMarginVisible="False">
                <MajorGrid Enabled="False" />
                <MajorTickMark Interval="1" />
                <LabelStyle Interval="1" />
            </AxisX>
        </asp:ChartArea>
    </ChartAreas>
</asp:Chart>
