﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models.ProviderObjects" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.Objects" %>
<%
    Dim data As AQIStationHistory = CType(Model.Data, AQIStationHistory)
    Dim aggregation As String = ""
    Dim measurements As List(Of AQIStationHistoryMeasurement) = data.Measurements.OrderBy(Function(m) m.ReadingDateTime).ToList()
    Dim minDate As DateTime = measurements.Select(Function(m) m.ReadingDateTime).Min()
    Dim maxDate As DateTime = measurements.Select(Function(m) m.ReadingDateTime).Max()
    Dim curDate As DateTime = minDate
    
    Select Case data.Aggregation
        Case GoA.Environment.OSIP.DataLibrary.AggregationType.DailyAverage
            aggregation = "Daily Average"
            Do While curDate <= maxDate
                Dim curMeasurements = measurements.Where(Function(m) m.ReadingDateTime.Day = curDate.Day And _
                                                                        m.ReadingDateTime.Month = curDate.Month And _
                                                                        m.ReadingDateTime.Year = curDate.Year).ToList()
                If curMeasurements.Count = 0 Then
                    Dim index As Integer = chGraph.Series.First.Points.AddXY(curDate, 0)
                    chGraph.Series.First.Points(index).IsEmpty = True
                Else
                    For Each m In curMeasurements
                        chGraph.Series.First.Points.AddXY(m.ReadingDateTime, m.Value)
                    Next
                End If
                curDate = curDate.AddDays(1)
            Loop
        Case GoA.Environment.OSIP.DataLibrary.AggregationType.MonthlyAverage
            aggregation = "Monthly Average"
            chGraph.ChartAreas.First.AxisX.LabelStyle.Format = "MMM yyyy"
            Do While curDate <= maxDate
                Dim curMeasurements = measurements.Where(Function(m) m.ReadingDateTime.Month = curDate.Month And _
                                                                        m.ReadingDateTime.Year = curDate.Year).ToList()
                If curMeasurements.Count = 0 Then
                    Dim index As Integer = chGraph.Series.First.Points.AddXY(curDate, 0)
                    chGraph.Series.First.Points(index).IsEmpty = True
                Else
                    For Each m In curMeasurements
                        chGraph.Series.First.Points.AddXY(m.ReadingDateTime, m.Value)
                    Next
                End If
                curDate = curDate.AddMonths(1)
            Loop
    End Select
    chGraph.Titles.First.Text = String.Format("Air Quality History for {0} ({1})", data.Station.Name, aggregation)
    Model.FormatChart(chGraph)
    'chGraph.DataSource = data.Measurements
    'chGraph.DataBind()
%>
<asp:Chart ID="chGraph" runat="server" Height="450px" Width="700px">
    <Titles>
        <asp:Title Name="Title1">
        </asp:Title>
    </Titles>
    <Series>
        <asp:Series Name="Series1" BorderWidth="3" ChartType="Line" 
            XValueMember="ReadingDateTime" YValueMembers="Value">
        </asp:Series>
    </Series>
    <ChartAreas>
        <asp:ChartArea Name="ChartArea1">
            <AxisY Title="Air Quality Index Value">
            </AxisY>
            <AxisX Title="Date" IsLabelAutoFit="False">
                <LabelStyle Angle="-45" />
            </AxisX>
        </asp:ChartArea>
    </ChartAreas>
</asp:Chart>
