﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>

<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.Objects" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models.ProviderObjects" %>
<%
    Dim data As YearlyProductionTotals = CType(Model.Data, YearlyProductionTotals)
    Dim frothTreatmentMessage = ""
    
    If Not IsNothing(data.FrothTreatmentProjectNames) Then
        frothTreatmentMessage = data.FrothTreatmentProjectNames
    End If
    Dim chartData = data.ProductionData.OrderByDescending(Function(d) d.Year_Int_Sort)
%>
    <style type="text/css">
        /*This style has been defined inline so that it will take precendence over the tundra.css style*/
         .dijitTooltipContainer {
             border: none;
             background: transparent;
         }
    </style>
<script>
    // ----------------------------------------------------------
    // A short snippet for detecting versions of IE in JavaScript
    // without resorting to user-agent sniffing
    // ----------------------------------------------------------
    // If you're not in IE (or IE version is less than 5) then:
    //     ie === undefined
    // If you're in IE (>=5) then you can determine which version:
    //     ie === 7; // IE7
    // Thus, to detect IE:
    //     if (ie) {}
    // And to detect the version:
    //     ie === 6 // IE6
    //     ie > 7 // IE8, IE9 ...
    //     ie < 9 // Anything less than IE9
    // ----------------------------------------------------------

    // UPDATE: Now using Live NodeList idea from @jdalton

    var ie = (function () {

        var undef,
            v = 3,
            div = document.createElement('div'),
            all = div.getElementsByTagName('i');

        while (
            div.innerHTML = '<!--[if gt IE ' + (++v) + ']><i></i><![endif]-->',
            all[0]
        );

        return v > 4 ? v : undef;

    }());
    <%--
    Have to use this global variable to see if the script has run already since the non-js charts are added twice, once for the preview and once for the full size chart.
    There is likely a better way to handle this... perhaps something in the model to indicate whether it is a js chart or not.
    --%>
    if (typeof chart<%=Model.DatasetView.DatasetViewID%> === 'undefined' || ie <= 9) {
        chart<%=Model.DatasetView.DatasetViewID%> = null;
        require([
            "dojo/dom-construct",
            "dojo/dom-style",
            "dojo/dom",
            "dijit/registry",
            "dojo/_base/window",
            "dojox/gfx",
            "dojox/gfx/utils",
            "dojo/_base/array",
            "dojox/charting/Chart",
            "dojox/charting/themes/MiamiNice",
            "dojox/charting/plot2d/StackedColumns",
            "dojox/charting/plot2d/Grid",
            "dojox/charting/action2d/Tooltip",
            "dojox/charting/widget/Legend",
            "dojox/charting/action2d/MouseZoomAndPan",
            "dojox/charting/action2d/TouchZoomAndPan",
            "dojox/charting/axis2d/Default",
            "dojo/domReady!"
        ], function (domConstruct, domStyle, dom, registry, win, gfx, utils, arrayUtil, Chart, theme, StackedColumns, Grid, Tooltip, Legend, MouseZoomAndPan, TouchZoomAndPan) {
            var productionData = JSON.parse('<%=System.Web.Helpers.Json.Encode(chartData.OrderBy(Function(p) p.Year_Int_Sort))%>');
            var TotalThermalInSituBitumenM3 = [];
            var TotalPrimaryAndConventionalBitumenM3 = [];
            var TotalMiningBitumenM3 = [];
            
            var TotalBitumenM3 = [];
            var TotalSyntheticCrudeOilM3 = [];

            var TotalThermalInSituBitumenBbl = [];
            var TotalPrimaryAndConventionalBitumenBbl = [];
            var TotalMiningBitumenBbl = [];

            var TotalBitumenBbl = [];
            var TotalSyntheticCrudeOilBbl = [];

            var xLabels = [];
            var maxScoM3 = 0;
            var maxBitumenM3 = 0;
            var maxScoBbl = 0;
            var maxBitumenBbl = 0;

            productionData.forEach(function(item, index) {
                TotalThermalInSituBitumenM3.push(item.TotalThermalInSituBitumenM3);
                TotalPrimaryAndConventionalBitumenM3.push(item.TotalPrimaryBitumenM3 + item.TotalConventionalBitumenM3);
                TotalMiningBitumenM3.push(item.TotalMiningBitumenM3);
                TotalBitumenM3.push(item.TotalThermalInSituBitumenM3 + item.TotalPrimaryBitumenM3 + item.TotalConventionalBitumenM3 + item.TotalMiningBitumenM3);
                TotalSyntheticCrudeOilM3.push(item.TotalSyntheticCrudeOilM3);

                TotalThermalInSituBitumenBbl.push(item.TotalThermalInSituBitumenBBL);
                TotalPrimaryAndConventionalBitumenBbl.push(item.TotalPrimaryBitumenBBL + item.TotalConventionalBitumenBBL);
                TotalMiningBitumenBbl.push(item.TotalMiningBitumenBBL);
                TotalBitumenBbl.push(item.TotalThermalInSituBitumenBBL + item.TotalPrimaryBitumenBBL + item.TotalConventionalBitumenBBL + item.TotalMiningBitumenBBL);
                TotalSyntheticCrudeOilBbl.push(item.TotalSyntheticCrudeOilBBL);
                xLabels.push({ value: index + 1, text: item.Year });
                if (TotalSyntheticCrudeOilM3[TotalSyntheticCrudeOilM3.length - 1] > maxScoM3) {
                    maxScoM3 = TotalSyntheticCrudeOilM3[TotalSyntheticCrudeOilM3.length - 1];
                    maxScoBbl = TotalSyntheticCrudeOilBbl[TotalSyntheticCrudeOilBbl.length - 1];
                }
                if (TotalBitumenM3[TotalBitumenM3.length - 1] > maxBitumenM3) {
                    maxBitumenM3 = TotalBitumenM3[TotalBitumenM3.length - 1];
                    maxBitumenBbl = TotalBitumenBbl[TotalBitumenBbl.length - 1];
                }
            });
            
            var chartId = "Chart<%=Model.DatasetView.DatasetViewID%>";
            if (!dom.byId(chartId)) {
                domConstruct.place("<div id='" + chartId + "'></div>", win.body());
            }
            domStyle.set(chartId, { "height": "500px", "width": "800px", "font-family": "calibri, arial, helvetica, sans-serif" });

            // Create the chart within it's "holding" node
            var chart = new Chart(chartId, {
                title: "Yearly Production Totals",
                titlePos: "top",
                titleGap: 25,
                titleFont: "normal normal normal 15pt Calibri",
                titleFontColor: "black"
            });

            // Set the theme
            chart.setTheme(theme);

            chart.addPlot("bitumen", {
                type: "Columns",
                markers: true,
                tension: "S",
                maxBarSize: 80,
                shadow: { dx: -15, dy: 0, width: 0, color: [0, 0, 0, 0.6] }
            });

            //Add Plots
            chart.addPlot("default", {
                type: StackedColumns,
                htmlLabels: false,
                maxBarSize: 80
            });

            chart.addPlot("barrels", {
                type: StackedColumns,
                hAxis: "x",
                vAxis: "other y",
                maxBarSize: 80//make bigger to become visible. right now this is obscured by the other plots (and also transparent!)
            });
            
            // Add axes
            chart.addAxis("x", {
                labels: xLabels,
                title: "Year",
                titleOrientation: "away"
                
            });
            chart.addAxis("y", {
                vertical: true,
                labelFunc: function (text, value, precision) {
                    return (value / 1000000).toLocaleString();
                },
                max: maxScoM3 + maxBitumenM3,
                min: 0,
                title: "Production in Millions of m³"
            });
            chart.addAxis("other y", {
                vertical: true,
                leftBottom: false,
                labelFunc: function (text, value, precision) {
                    return (value / 1000000).toLocaleString();
                },
                max: maxScoBbl + maxBitumenBbl,
                min: 0,
                title: "Production in Millions of Barrels"
            });
            // Add the series of data
            chart.addSeries("Bitumen from Primary and Conventional Wells", TotalPrimaryAndConventionalBitumenM3, {
                stroke: { color: "black" },
                fill: "#75481F"
            });
            chart.addSeries("Bitumen from Thermal In Situ projects", TotalThermalInSituBitumenM3, {
                stroke: { color: "black" },
                fill: "#601500"
            });
            chart.addSeries("Bitumen from Mines", TotalMiningBitumenM3, {
                stroke: { color: "black" },
                fill: "#36424B"
            });

            chart.addSeries("Synthetic Crude Oil upgraded in Alberta", TotalSyntheticCrudeOilM3, {
                stroke: { color: "black" },
                fill: "#EA822D"
            });

            chart.addSeries("Total Bitumen produced but not upgraded in Alberta", TotalBitumenM3, {
                plot: "bitumen",
                stroke: { color: [0, 0, 0, 0.6], width: 1 },
                fill: [0, 0, 0, 0.6]
            });

            chart.movePlotToFront("default");

            var tooltip = new Tooltip(chart, "default", {
                text: function (chartItem) {
                    var borderColour = chartItem.event.target.attributes['fill'].value;
                    var tip = "<div style='padding: 5px; background: white; border-radius: 10px; width: auto; height: auto; border: solid 2px " + borderColour + ";font-family: calibri, arial, helvetica, sans-serif;'>" + chartItem.run.name + " in " + chartItem.chart.axes["x"].labels[chartItem.index].text + ": " + (chartItem.run.data[chartItem.index]).toLocaleString() + " m³";
                    if (chartItem.run.name.toLowerCase().indexOf("synthetic") < 0) {
                        tip += "<br/>Total Bitumen: " + (chartItem.chart.series[4].data[chartItem.index]).toLocaleString() + " m³";
                    }
                    tip += "</div>";
                    return tip;
                }
            });
            var zoomAndPan = new MouseZoomAndPan(chart, "default", { axis: "x", scaleFactor: 2, maxScale: 15, keyZoomModifier: "shift" });//switched to use shift key instead of default ctrl to avoid conflict with browser zooming
            var touchZoomAndPan = new TouchZoomAndPan(chart, "default", { axis: "x", scaleFactor: 2, maxScale: 15 });
            // Render the chart!
            chart.resize();
            chart.render();
            

            chart<%=Model.DatasetView.DatasetViewID%> = chart;


            var legendId = "legend<%=Model.DatasetView.DatasetViewID%>";
            if (!dom.byId(legendId)) {
                domConstruct.place("<div id='" + legendId + "'></div>", win.body());
            }


            var legend;
            legend = registry.byId(legendId);
            if (legend) {
                legend.destroy();
            }
            legend = new Legend({
                chart: chart,
                horizontal: false
            }, legendId);
            
            //these series are added after the legend so they don't appear in the legend.
            chart.addSeries("BitumenBarrels", TotalBitumenBbl, {
                plot: "barrels",
                hidden: true,
                stroke: { color: "transparent", width: 1 },
                fill: "transparent"
            });
            chart.addSeries("ScoBarrels", TotalSyntheticCrudeOilBbl, {
                plot: "barrels",
                hidden: true,
                stroke: { color: "transparent", width: 1 },
                fill: "transparent"
            });

            chart<%=Model.DatasetView.DatasetViewID%> = chart;
            //If the ChartSmall node exists add a small coopy of the chart there
            if (dom.byId('ChartSmall<%=Model.DatasetView.DatasetViewID%>') && !dom.byId('smallChartSurface')) {
                domConstruct.place("<div id='smallChartSurface'></div>", 'ChartSmall<%=Model.DatasetView.DatasetViewID%>');

                //Create dojox GFX surface to copy the chart to
                var surface = gfx.createSurface("smallChartSurface", 280, 175);//.setClip({ x: 66.66666666666, y: 60.5, width: 50, height: 50 });
                var serializedChart = utils.serialize(chart.surface);
                var allGroup = surface.createGroup();
                utils.deserialize(allGroup, serializedChart);
                //Scale the copy down
                allGroup.applyTransform(gfx.matrix.scale({ x: 0.35, y: 0.35 }));
                //Add click event handler on surface
                surface.on("click", function() {
                    dom.byId("ChartDialog<%=Model.DatasetView.DatasetViewID%>").click();
                });
                domConstruct.place("<p><%=frothTreatmentMessage%></p>", 'ChartSmall<%=Model.DatasetView.DatasetViewID%>');
            }
            //set default scale and offset (where the chart will be zoomed and panned to
            chart.setAxisWindow("x", 10, 44.1);
            chart.render();

            var chartNode = dom.byId(chartId);
            var legendDiv = dom.byId(legendId);
            var zoomP = domConstruct.place("<p>Click and drag the chart to pan. Use shift plus +/- or scrolling the mouse wheel to zoom the chart.</p>", chartNode);
            chartNode.appendChild(legendDiv);
            var frothP = domConstruct.place("<p><%=frothTreatmentMessage%></p>", chartNode);
            //this line sets the height of the chart div to include the appended p tag so scroll bars don't appear in the fancybox
            var newHeight = domStyle.get(chartNode, "height") + domStyle.get(frothP, "height") + domStyle.get(zoomP, "height") + domStyle.get(legendId, "height") + 70;
            domStyle.set(chartNode, { "height": newHeight + "px" });
        });
    }
</script>
