﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models.ProviderObjects" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.OilSandsApi" %>
<%
    Dim data As List(Of YearlySummary) = CType(Model.Data, List(Of YearlySummary))
    Model.FormatChart(chMain)
    chMain.DataSource = data
    chMain.DataBind()
    chMain.Series(0).Color = Model.Colors(6)
    chMain.Series(1).Color = Model.Colors(5)
    chMain.Series(2).Color = Model.Colors(4)
    chMain.Series(3).Color = Model.Colors(3)
    chMain.Series(4).Color = Model.Colors(2)
    chMain.Series(5).Color = Model.Colors(1)
    chMain.Series(6).Color = Model.Colors(0)
    chMain.Series(7).Color = Model.Colors(7)
    chMain.Legends.First().CustomItems.First().Color = Model.Colors(7)
    
    If data.Count > 0 Then
        chMain.DataManipulator.InsertEmptyPoints(1, IntervalType.Days, "EmissionsNetCompliance,FundContributions,Offsets,EPCsRetired,CogenEfficiencyCredit,IncCogenElectricityEmissions,TotalOnsiteEmissions,EPCsGenerated")
    End If
    
%>
<asp:Chart ID="chMain" runat="server" Height="500px" Width="800px">
    <Legends>
        <asp:Legend Alignment="Center" Name="Legend1">
            <CustomItems>
                <asp:LegendItem ImageStyle="Line" Name="EPCs Generated" 
                        MarkerSize="8" MarkerStyle="Triangle" MarkerBorderWidth="0" BorderWidth="2"></asp:LegendItem>
            </CustomItems>
        </asp:Legend>
    </Legends>
    <Titles>
        <asp:Title Name="MainTitle" Text="Facility Emissions and SGER Required Activity (All Projects)">
        </asp:Title>
        <asp:Title Alignment="BottomCenter" Docking="Bottom" Name="Disclaimer" 
            Text="The first period of mandatory reductions for established facilities was July 1 to December 31 2007.  Details of the method of compliance for the 2007 half year period are currently unavailable.  All subsequent compliance cycles cover entire calendar years.">
        </asp:Title>
    </Titles>
    <Series>                 
        <asp:Series ChartType="StackedColumn" Legend="Legend1" 
            LegendText="Emissions net of SGER requirements" Name="EmissionsNetCompliance" 
                XValueMember="Year" YValueMembers="EmissionsNetCompliance">
        </asp:Series>
        <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
            LegendText="Climate Change Emissions Management Fund contributions" Name="FundContributions"
                XValueMember="Year" YValueMembers="FundCreditsPurchased">
        </asp:Series>
        <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
            LegendText="Offsets retired" Name="Offsets"
                XValueMember="Year" YValueMembers="OffsetsSubmitted">
        </asp:Series>
        <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
            LegendText="EPCs Retired" Name="EPCsRetired"
                XValueMember="Year" YValueMembers="EPCsRetired">
        </asp:Series>
        <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
            LegendText="Cogen efficiency credit" Name="CogenEfficiencyCredit"
                XValueMember="Year" YValueMembers="CogenEfficiencyCredit">
        </asp:Series>
         <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
            LegendText="Incremental cogeneration electricity emissions" 
            Name="IncCogenElectricityEmissions" XValueMember="Year" YValueMembers="GHGFromElectricity">
        </asp:Series>
        <asp:Series ChartArea="ChartArea1" ChartType="Point" Legend="Legend1" 
            LegendText="Total on-site emissions" MarkerSize="20" MarkerStyle="Star4" 
            Name="TotalOnsiteEmissions" XValueMember="Year" YValueMembers="TotalGHGEmissions">
        </asp:Series>
        <asp:Series ChartArea="ChartArea1" ChartType="Line" Legend="Legend1" 
            LegendText="EPCs generated" MarkerSize="8" MarkerStyle="Triangle" 
            Name="EPCsGenerated" XValueMember="Year" YValueMembers="EPCsGenerated" IsVisibleInLegend="False">
        </asp:Series> 
    </Series>
    <ChartAreas>
        <asp:ChartArea Name="ChartArea1">
            <AxisY Title="Tonnes of CO2e">
                <LabelStyle Format="N0" />
            </AxisY>
            <AxisX Title="Year">
            </AxisX>
        </asp:ChartArea>
    </ChartAreas>
</asp:Chart>
