﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.WaterQualityService" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models.ProviderObjects" %>
<%@ Import Namespace="System.Windows.Forms" %>
<% 
    Dim data As StationWaterQualityIndexHistory = CType(Model.Data, StationWaterQualityIndexHistory)
    chBar.Titles("MainTitle").Text = data.StationName
    For Each rating As WaterQualityRating In data.Ratings
        Dim stripLine As New StripLine
        Dim labelText As String = rating.Name & " (" & rating.MinValue & " - " & rating.MaxValue & ")"
        stripLine.IntervalOffset = rating.MinValue
        stripLine.StripWidth = rating.MaxValue - rating.MinValue + 1
        stripLine.BackColor = ControlPaint.LightLight(ControlPaint.LightLight(Drawing.ColorTranslator.FromHtml("#" & rating.WebColor)))
        chBar.ChartAreas.First.AxisY.StripLines.Add(stripLine)
        chBar.ChartAreas.First.AxisY.CustomLabels.Add(Convert.ToDouble(rating.MinValue), Convert.ToDouble(rating.MaxValue), labelText)
    Next
    Dim maxY As Short = data.Ratings.Select(Function(r) r.MaxValue).Max
    chBar.ChartAreas.First.AxisY.Maximum = maxY
    'If Not data.IndiciesToShow.ShowWaterQualityIndex Then chBar.Series.Remove(chBar.Series("Water Quality Index"))
    'If Not data.IndiciesToShow.ShowBacterialIndex Then chBar.Series.Remove(chBar.Series("Bacterial Index"))
    'If Not data.IndiciesToShow.ShowMetalsIndex Then chBar.Series.Remove(chBar.Series("Metals Index"))
    'If Not data.IndiciesToShow.ShowNutrientIndex Then chBar.Series.Remove(chBar.Series("Nutrient Index"))
    'If Not data.IndiciesToShow.ShowPesticideIndex Then chBar.Series.Remove(chBar.Series("Pesticide Index"))
    chBar.Series("Water Quality Index").Enabled = data.IndiciesToShow.ShowWaterQualityIndex
    chBar.Series("Bacterial Index").Enabled = data.IndiciesToShow.ShowBacterialIndex
    chBar.Series("Metals Index").Enabled = data.IndiciesToShow.ShowMetalsIndex
    chBar.Series("Nutrient Index").Enabled = data.IndiciesToShow.ShowNutrientIndex
    chBar.Series("Pesticide Index").Enabled = data.IndiciesToShow.ShowPesticideIndex
    Model.FormatChart(chBar)
    chBar.DataSource = data.Records
    chBar.DataBind()
%>
<asp:Chart ID="chBar" runat="server" Height="500px" Width="900px">
    <Legends>
        <asp:Legend Name="Legend1">
        </asp:Legend>
    </Legends>
    <Titles>
        <asp:Title Name="MainTitle">
        </asp:Title>
    </Titles>
    <Series>
        <asp:Series ChartArea="ChartArea1" ChartType="Column" Name="Water Quality Index" 
            XValueMember="Period" YValueMembers="WaterQualityIndex" 
            Legend="Legend1" CustomProperties="PointWidth=0.7"></asp:Series>
        <asp:Series ChartArea="ChartArea1" ChartType="Column" Name="Bacterial Index" 
            XValueMember="Period" YValueMembers="BacterialIndex" 
            Legend="Legend1" CustomProperties="PointWidth=0.7"></asp:Series>
        <asp:Series ChartArea="ChartArea1" ChartType="Column" Name="Metals Index" 
            XValueMember="Period" YValueMembers="MetalsIndex" 
            Legend="Legend1" CustomProperties="PointWidth=0.7"></asp:Series>
        <asp:Series ChartArea="ChartArea1" ChartType="Column" Name="Nutrient Index" 
            XValueMember="Period" YValueMembers="NutrientsIndex" 
            Legend="Legend1" CustomProperties="PointWidth=0.7"></asp:Series>
        <asp:Series ChartArea="ChartArea1" ChartType="Column" Name="Pesticide Index" 
            XValueMember="Period" YValueMembers="PesticidesIndex" 
            Legend="Legend1" CustomProperties="PointWidth=0.7"></asp:Series>
    </Series>
    <ChartAreas>
        <asp:ChartArea Name="ChartArea1">
            <AxisY Title="Index Value">
                <MajorGrid Enabled="False" />
                <MajorTickMark Enabled="False" />
            </AxisY>
            <AxisX Title="Period" Interval="1" >
                <LabelStyle Angle="-45" />
            </AxisX>
        </asp:ChartArea>
    </ChartAreas>
</asp:Chart>
