﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.Objects" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models.ProviderObjects" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.WaterQuantityModel" %>
<%
    Dim data As StationWaterQuantity(Of NRTDailyAverage) = CType(Model.Data, StationWaterQuantity(Of NRTDailyAverage))
    Model.FormatChart(chLine)
    chLine.Titles("ChartTitle").Text = data.Station.Name & " (Daily Average)"
    chLine.Titles("SubTitle").Text = "Station: " & data.Station.Id & " Sensor: " & data.Sensor.Id
    Dim yLabel As String = String.Empty
    Select Case data.Parameter.Id
        Case 14000 'Water Flow
            yLabel = "Discharge (m3/s)"
        Case 10000 'Water Level
            yLabel = "Water Level (m)"
        Case Else
            yLabel = "Values"
    End Select
    chLine.ChartAreas.First.AxisY.Title = yLabel
    Dim seriesLabel As String = "All available time"
    If data.StartDate.HasValue And data.EndDate.HasValue Then
        seriesLabel = data.StartDate.Value.ToString("f") & " - " & data.EndDate.Value.ToString("f")
    ElseIf data.StartDate.HasValue Then
        seriesLabel = "Starting " & data.StartDate.Value.ToString("f")
    ElseIf data.EndDate.HasValue Then
        seriesLabel = "Ending " & data.EndDate.Value.ToString("f")
    End If
    chLine.Series.First.LegendText = seriesLabel
    chLine.ChartAreas.First.AxisX.Title = "Date"
    Dim measurements As List(Of NRTDailyAverage) = data.Measurements.OrderBy(Function(m) m.Date).ToList()
    Dim minDate As DateTime = measurements.Select(Function(m) m.Date).Min()
    Dim maxDate As DateTime = measurements.Select(Function(m) m.Date).Max()
    Dim curDate As DateTime = minDate
    Do While curDate <= maxDate
        Dim curMeasurements = measurements.Where(Function(m) m.Date.Day = curDate.Day And _
                                                                m.Date.Month = curDate.Month And _
                                                                m.Date.Year = curDate.Year).ToList()
        If curMeasurements.Count = 0 Then
            Dim index As Integer = chLine.Series.First.Points.AddXY(curDate, 0)
            chLine.Series.First.Points(index).IsEmpty = True
        Else
            For Each m In curMeasurements
                chLine.Series.First.Points.AddXY(m.Date, m.Value)
            Next
        End If
        curDate = curDate.AddDays(1)
    Loop
    'chLine.DataSource = points
    'chLine.DataBind()
%>
<asp:Chart ID="chLine" runat="server" Height="700px" Width="1000px">
    <Legends>
        <asp:Legend DockedToChartArea="ChartArea1" Docking="Top" 
            IsDockedInsideChartArea="False" Name="Legend1">
        </asp:Legend>
    </Legends>
    <Titles>
        <asp:Title Name="ChartTitle">
        </asp:Title>
        <asp:Title Name="SubTitle">
        </asp:Title>
    </Titles>
    <Series>
        <asp:Series ChartType="Line" Name="Series1" BorderWidth="3" 
            Legend="Legend1" 
            XValueType="DateTime" >
            <EmptyPointStyle BorderWidth="0" />
        </asp:Series>
    </Series>
    <ChartAreas>
        <asp:ChartArea Name="ChartArea1">
        </asp:ChartArea>
    </ChartAreas>
</asp:Chart>
