﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.ChartModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models.ProviderObjects" %>

<%
    Dim data As YearlyCurrentReclamationSummary = CType(Model.Data, YearlyCurrentReclamationSummary)
    Model.FormatChart(chBar)
    Dim yAxisTitle As String = "Hectares"
    Select Case data.Unit
        Case GoA.Environment.OSIP.DataLibrary.LandReclamationUnits.Acres
            yAxisTitle = "Acres"
        Case GoA.Environment.OSIP.DataLibrary.LandReclamationUnits.Hectares
            yAxisTitle = "Hectares"
        Case GoA.Environment.OSIP.DataLibrary.LandReclamationUnits.KmSquared
            yAxisTitle = "Kilometres Squared"
        Case GoA.Environment.OSIP.DataLibrary.LandReclamationUnits.MilesSquared
            yAxisTitle = "Miles Squared"
    End Select
    chBar.ChartAreas.First.AxisY.Title = "Cumulative " & yAxisTitle
    chBar.DataSource = data.Records
    chBar.DataBind()

    Dim url = "#"
    Dim target = String.Empty
    Dim urlReferrer As Uri = Request.UrlReferrer

    If urlReferrer IsNot Nothing Then
        If Not (Request.UrlReferrer.AbsoluteUri.Contains("Details")) Then
            url = "/library/Dataset/Details/27"
            target = "_blank"
        End If
    End If


    If Not IsNothing(Model.Data) Then
        chBar.DataManipulator.InsertEmptyPoints(1, IntervalType.Days, "Cleared,Distrubed,ReadyforReclamation,SoilsPlaced,PermanentReclamation(Terrestrial),PermanentReclamation(WetlandsandAquatics),TemporaryReclamation(Terrestrial),Certified")
    End If

%>

<table>
    <tr>
        <td>
            <asp:Chart ID="chBar" runat="server" Height="500px" Width="900px">
                <Legends>
                    <asp:Legend Alignment="Center" MaximumAutoSize="33" Name="Legend1">
                    </asp:Legend>
                </Legends>
                <Titles>
                    <asp:Title Name="Title1" 
                        Text="Regional Totals for Reclamation and Disturbance Tracking, by Year">
                    </asp:Title>
                    <asp:Title Alignment="MiddleLeft" Docking="Bottom" Name="Title2" 
                        Text="* Data is as of December 31 of each year reported">
                    </asp:Title>
                </Titles>
                <Series>
                    <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" 
                        CustomProperties="PointWidth=0.5" Legend="Legend1" LegendText="Cleared" 
                        Name="Cleared" XValueMember="ReportYear" YValueMembers="Cleared">
                    </asp:Series>
                    <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
                        CustomProperties="PointWidth=0.5" LegendText="Disturbed: Used for Mine or Plant Purposes" Name="Distrubed" 
                        XValueMember="ReportYear" YValueMembers="DisturbedMinePlant">
                    </asp:Series>
                    <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
                        CustomProperties="PointWidth=0.5" LegendText="Ready for Reclamation: No Longer Used for Mine or Plant Purposes" 
                        Name="ReadyforReclamation" XValueMember="ReportYear" 
                        YValueMembers="ReadyForReclamation">
                    </asp:Series>
                    <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
                        CustomProperties="PointWidth=0.5" LegendText="Soils Placed (Terrestrial &amp; Wetlands &amp; Aquatics)" 
                        Name="SoilsPlaced" XValueMember="ReportYear" YValueMembers="SoilsPlaced">
                    </asp:Series>
                    <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
                        CustomProperties="PointWidth=0.5" LegendText="Permanent Reclamation (Terrestrial)" 
                        Name="PermanentReclamation(Terrestrial)" XValueMember="ReportYear" 
                        YValueMembers="PermanentRecTerrestrial">
                    </asp:Series>
                    <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
                        CustomProperties="PointWidth=0.5" LegendText="Permanent Reclamation (Wetlands &amp; Aquatics)" 
                        Name="PermanentReclamation(WetlandsandAquatics)" 
                        XValueMember="ReportYear" YValueMembers="PermanentRecWetlandsAquatics">
                    </asp:Series>
                    <asp:Series ChartArea="ChartArea1" ChartType="StackedColumn" Legend="Legend1" 
                        CustomProperties="PointWidth=0.5" LegendText="Temporary Reclamation (Terrestrial)" 
                        Name="TemporaryReclamation(Terrestrial)" XValueMember="ReportYear" 
                        YValueMembers="TemporaryRecTerrestrial">
                    </asp:Series>
                    <asp:Series ChartType="StackedColumn" Legend="Legend1" LegendText="Certified" 
                        CustomProperties="PointWidth=0.5" Name="Certified" XValueMember="ReportYear" YValueMembers="Certified">
                    </asp:Series>
                </Series>
                <ChartAreas>
                    <asp:ChartArea Name="ChartArea1">
                    </asp:ChartArea>
                </ChartAreas>
            </asp:Chart>            
        </td>
    </tr>
    <tr>
        <td>
            <asp:Label ID="lblViewmore" runat="server" Text="For more details, usage considerations and data downloads" ></asp:Label>
            <a  href='<%=url%>' target="<%=target%>">"View data library page"</a>
        </td>
    </tr>
</table>

