﻿<%@ Page Language="VB" Inherits="GoA.Environment.OSIP.DataLibrary._Details" CodeBehind="Details.aspx.vb" %>

<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.Metadata" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary" %>
<%@ Import Namespace="Microsoft.VisualStudio.Web.PageInspector.Runtime" %>
<asp:content id="Content2" contentplaceholderid="conHead" runat="server">
    <title>OSIP Data Library - <%=Model.Dataset.Title %></title>
    <link rel="Stylesheet" type="text/css" media="screen" href="<%= ResolveClientUrl("~/Content/fancybox.Dataset.css")%>" title="default"/>    
    
    <% 'Dec 12, 2011 - Perry - adding meta tags for WebTrends %>
    <meta name="DCS.dcsuri" content="<%="/" & HttpContext.Current.Request.Url.GetComponents(UriComponents.Path, UriFormat.UriEscaped)%>" /> 
    <meta name="WT.ti" content="<%=Model.Dataset.Title %>" />
    <meta name="WT.cg_n" content="OSIP Dataset; OSIP Data Library; Web Application" />
    <meta name="description" content="<%=Model.Dataset.Abstract.ToString.Substring(0, Math.Min(100, Model.Dataset.Abstract.Length)).Replace(vbCrLf, " ").Replace("<","").Replace(">","") %>" />    
    <% 'end Dec 12, 2011 %>
    <link rel="stylesheet" type="text/css" href="//ajax.googleapis.com/ajax/libs/dojo/1.7.1/dijit/themes/tundra/tundra.css"/>
    <script src="//ajax.googleapis.com/ajax/libs/dojo/1.10.1/dojo/dojo.js"></script>
    <script type="text/javascript">
        var qs = '<%=Model.QueryString %>';
        $(document).ready(function() {
            <% If Model.Dataset.FormFilterView IsNot Nothing Then%>
            LoadFormFilter(<%=Model.Dataset.FormFilterView.DatasetViewID %>);
            LoadODataLinks(<%=Model.Dataset.FormFilterView.DatasetViewID %>);

            <% End If%>
            <% For Each chartView In Model.Dataset.ChartViews%>
            LoadChart(<%=chartView.DatasetViewID %>);
            LoadChartODataLinks(<%=chartView.DatasetViewID %>);
            <% Next%>
            $(".DialogButton").fancybox(dialogSettings);
            <% If Model.Dataset.GridDisplayView IsNot Nothing Then%>
            GridViewId = <%=Model.Dataset.GridDisplayView.DatasetViewID %>
            <% End If%>
            $(".Button").hover(function() {
                $(this).addClass("ButtonHover");
            }, function() {
                $(this).removeClass("ButtonHover");
            });       
        });
        function RefreshCharts()
        {
            <% For Each chartView In Model.Dataset.ChartViews.Where(Function(c) c.Refresh).ToList()%>
            RefreshChart(<%=chartView.DatasetViewID %>);           
            <% Next%>
            GridViewPage = 1;
        }
        function GoBack()  {
            <%If Request.UrlReferrer IsNot Nothing AndAlso Request.UrlReferrer.ToString().Contains("/Browser") Then%> 
            window.history.back();                
            <%Else%>
            window.location = '<%=Url.Action("Index", "Browser")%>';
            <%End If%>
        }
    </script>
</asp:content>
<asp:content id="Content3" contentplaceholderid="conLeft" runat="server">
    <div class="Button" onclick="GoBack();">
        <img src="<%=Me.ResolveUrl("~/Content/icons/arrow-left-green.png") %>" width="16" height="16" alt="Back to the Library" />&nbsp;
        <span class="Text">Back to the Library</span>
    </div>
</asp:content>
<asp:content id="Content1" contentplaceholderid="conRight" runat="server">
    <%  Const ENFORCEMENT_DISCLAIMER As String = "Enforcement Actions are presented on a Company-wide basis. Enforcement Actions listed may include oil sands and non-oil sands related events."
        Dim strDisclaimer As String = String.Empty
        If Model.Dataset.TITLE = "Enforcement Actions" Then
            strDisclaimer = ENFORCEMENT_DISCLAIMER
        End If
        Dim siteCode = CStr(ViewData("SiteCode"))
        
    %>
    
    <h1><%=Model.Dataset.Title%></h1>
    <table width="100%" cellpadding="0" cellspacing="0">
        <tr>
            <td valign="top">
     
                <h2>Description</h2>
                <%=Model.Dataset.Abstract%>
                <br />
                <h2>Details</h2>
                <table width="100%">
                    <tr>
                        <td style="width: 10%" >Posted Date:</td>
                        <td style="width: 30%" >
                            <%=Model.Dataset.PROVISION_DATE.ToString("MMM d, yyyy")%>
                        </td>
                        <td style="width: 7%">Source:</td>
                        <td style="vertical-align: top;horiz-align: left; width: 40%">
                            <%If Model.Dataset.ReportingSource IsNot Nothing Then
                                    Dim recCounts = Model.Dataset.ReportingSource.REPORTING_SOURCE_SITES_X_REFs.Where(Function(dr) dr.ReportingSource.REPORTING_SOURCE_SITES_X_REFs.Any(Function(x) x.SITE.NAME = siteCode)).Count%>
                                <%If recCounts > 0 Then%>
                                    <%If Model.Dataset.ReportingSource.PARTNER_LOGOS_ICONS_ID > 0 Then%>
                                    <table>
                                             <tr>
                                                 <td style="vertical-align: top;horiz-align: left"><img style="max-height: 50px;max-width:50px;"  src="<%=Url.Action("DisplayImage", "Dataset", New With {Key .id = Model.Dataset.ReportingSource.PARTNER_LOGOS_ICONS_ID})%>"/></td>
                                                 <td style="vertical-align: middle;horiz-align: left"><%=Model.Dataset.ReportingSource.Name%></td>
                                             </tr>
                                         </table>
                                    <%Else%>
                                           &nbsp;&nbsp;<%=Model.Dataset.ReportingSource.Name%>
                                    <%End If%>
                                <%End If%>
                            <%End If%>
                        </td>
                    </tr>
                    <tr>
                        <td>Date Range: </td>
                        <td style="horiz-align: left">
                            <%=Model.Dataset.DATA_PERIOD_START_DATE.ToString("MMM d, yyyy")%> -
                            <%If Model.Dataset.DATA_PERIOD_END_DATE.HasValue Then%>
                                <%=Model.Dataset.DATA_PERIOD_END_DATE.Value.ToString("MMM d, yyyy")%>
                            <%Else%>
                    Present
                <%End If%>
                        </td>
                        <td>
                <%If Model.Dataset.DatasetRegions IsNot Nothing Then%>
                                Location:
                <%End If%>
                        </td>
                        <td style="horiz-align: left">
                            &nbsp;
                            <%If Model.Dataset.DatasetRegions IsNot Nothing Then
                                    Dim datasetRegions = Model.Dataset.DatasetRegions.Where(Function(dr) dr.Region.REGION_CODE_SITES_X_REFs.Any(Function(x) x.SITE.NAME = siteCode))%>
                                    <%=datasetRegions.Select(Function(dr) dr.Region.Name).Distinct.ToCSVString()%>
                            <%End If%>
                        </td>
                    </tr>
                    <tr>
                        <%  Dim downloadView As DatasetView = Model.Dataset.DownloadView
                            Dim gridDisplayView As DatasetView = Model.Dataset.GridDisplayView
                            Dim pdfDownloadView As DatasetView = Model.Dataset.PDFDownloadView
                    
                    
                        %>
                        <td style="vertical-align: text-top;horiz-align: left;" colspan="2" align="right">
                        <% If pdfDownloadView IsNot Nothing Then%>
                            <div id="DownloadBtn" class="Button" 
                            onclick="ProceedToDownLoad('<%=Me.ResolveUrl("~/Content/Downloads/" & pdfDownloadView.View.ControlName) %>');">
                                <%Html.RenderPartial("DownloadPDFButton")%>
                            </div>
                        <% Else
                                If downloadView IsNot Nothing Then%>
                                <a id="DownloadDialog" href="#Download" class="DialogButton"></a>
                                <% If Not strDisclaimer = String.Empty Then%>
                                     <div id="Div3" class="Button" onclick="ShowDisclaimerDialog('<%=strDisclaimer %>', ShowDownload);">
                                <% Else%>
                                     <div id="Div4" class="Button" onclick="ShowDownload();">
                                <%  End If%>
                                    <%Html.RenderPartial("DownloadButton")%>                        
                                </div> 
                            <%End If%></div>                
                            </td>
                        <td align="left" style="vertical-align: text-top;padding-left: 8px;" colspan="2" >                
                            <%If gridDisplayView IsNot Nothing Then%>
                                <a id="GridDialog" href="#Grid" class="DialogButton"></a>
                                <% If Not strDisclaimer = String.Empty Then%>
                                     <div id="ViewBtn" class="Button" onclick="ShowDisclaimerDialog('<%=strDisclaimer %>', ShowGridView);">
                                <% Else%>
                                     <div id="ViewBtn" class="Button" onclick="ShowGridView();">
                                <%  End If%>
                                    <%Html.RenderPartial("ViewTableButton")%>                           
                                </div>
                            <%End If%>
                        <%End If%></div>
                        </td>
                    </tr>
                </table>
                <%If Model.Dataset.DATASETS_ATTACHMENTs.Count > 0 Then%>
                <h2>Attachments</h2>
                <ul>
                    <% Dim fileSaveURL As String = System.Configuration.ConfigurationManager.AppSettings.Item("FileSaveURL") + Model.Dataset.DATASET_ID.ToString() + "/"%>
        
                <%For Each dsFiles As DATASETS_ATTACHMENT In Model.Dataset.DATASETS_ATTACHMENTs.OrderBy(Function(d) d.ATTACHMENT_TITLE).ToList()%>
                    <li>
                        <a target="_blank" href="<%=Url.Content(String.Concat(fileSaveURL,dsFiles.ATTACHMENT_NAME))%>">
                          <%=dsFiles.ATTACHMENT_TITLE%>
                          (<%=dsFiles.ATTACHMENT_TYPE%>)
                          <%If dsFiles.ATTACHMENT_SIZE <= 1024 Then%>
                                (1 Kb)
                          <%ElseIf dsFiles.ATTACHMENT_SIZE >= (1 << 20) Then%>
                            <%=String.Format("({0} Mb)", dsFiles.ATTACHMENT_SIZE >> 20)%>
                          <%ElseIf dsFiles.ATTACHMENT_SIZE >= (1 << 10) Then%>
                            <%=String.Format("({0} Kb)", dsFiles.ATTACHMENT_SIZE >> 10)%>
                          <%End If%>
                        </a>
                    </li>
                    <% Next%>
                </ul>
                <br/>
                <%End If%>
                <h2>Usage Considerations</h2>
                <%=Model.Dataset.USAGE_CONSIDERATIONS%>
        
                <% If Not strDisclaimer = String.Empty Then%>             
                     <h2>Disclaimer</h2>                                     
                      <%=strDisclaimer%>       
                <% End If%>

                <%If Model.Dataset.DATASETS_PARTNER_LOGOS_ICONS_X_REFs.Count > 0 Then%>
                <h2>Partners</h2>
                <table>
                <%For Each dsLogos As DATASETS_PARTNER_LOGOS_ICONS_X_REF In Model.Dataset.DATASETS_PARTNER_LOGOS_ICONS_X_REFs.OrderBy(Function(p) p.PARTNER_LOGOS_ICON.IMAGE_NAME).ToList()%>
                    <tr>
                        <td>
                            <img  src="<%=Url.Action("DisplayImage", "Dataset", New With {Key .id = dsLogos.PARTNER_LOGOS_ICONS_ID})%>" style="max-width: 100px;max-height: 100px;"/>
                        </td>
                        <td valign="top">
                            <%=dsLogos.PARTNER_LOGOS_ICON.IMAGE_DESCRIPTION%>
                        </td>
                    </tr>
                    <% Next%>
                </table>
                <%End If%>

                <br />
                <% If Model.Dataset.FILE_TYPE_CODE = "ODATA" Then%>
                        <div id="ODataLinks"></div>                   
                <% End If%>

          </td>
            <td style="width: 280px;padding-left: 10px;vertical-align: top;">

                <% If Model.Dataset.FormFilterView IsNot Nothing Then%>
                   <div id="PageFilter"></div>     
                <% End If%>
                <% For Each chartView In Model.Dataset.ChartViews%>
                    <a href="#Chart<%=chartView.DatasetViewID %>" id="ChartDialog<%=chartView.DatasetViewID %>" class="DialogButton"></a>
                    <div id="ChartSmall<%=chartView.DatasetViewID %>" class="Chart"></div>
                    <div id="legend<%=chartView.DatasetViewID %>" style="position: absolute; left: -1000px; top: -1000px;"></div>
                    <div style="position: absolute; left: -1000px; top: -1000px;"><%-- positioning the chart off screen instead of display:none; as the chart resize function doesn't work when not displayed.--%>
                        <div id="Chart<%=chartView.DatasetViewID %>" class="ChartDialog"></div>
                    </div>
                <% Next%>

                <% If ViewData("IS_RELATED_LINKS_VISIBLE").ToString() = "True" And Model.Dataset.RelatedDatasets.Count > 0 Then%>
                <h2>Related Data Sets</h2>
                    <%For Each relatedDS As RelatedDataset In Model.Dataset.RelatedDatasets%>
                    <%If relatedDS.RelatedDatasetID.HasValue Then%>
                    <a href="<%=relatedDS.Url  %>"><%=relatedDS.Name%> &gt;</a><br />
                    <%End If%>
                    <% Next%>
                <% End If%>

                <% If ViewData("IS_FURTHER_REOURCES_LINKS_VISIBLE").ToString() = "True" And Model.Dataset.DatasetLinks.Count > 0 Then%>
                <h2>Further Resources</h2>
                <% For Each dsLink As DatasetLink In Model.Dataset.DatasetLinks.OrderBy(Function(l) l.Link.Name).ToList()%>
                    <a href="<%=dsLink.Link.Url%>"><%=dsLink.Link.Name%> &gt;</a><br />
                <% Next%>
                <% End If%>
            </td>
        </tr>
    </table>
    <div style="display:none">
        <div id="Grid"></div>
    </div>
    <div style="display:none;">
        <div id="Download">
            <%If downloadView IsNot Nothing Then%>
                <% 'downloadView.Dataset.DataValidator %>
                <%  Dim pdfDL As String = Url.Action("PDF", "Dataset", New With {.Id = downloadView.DatasetViewID})
                    Dim xlsDL As String = Url.Action("Excel", "Dataset", New With {.Id = downloadView.DatasetViewID})
                    'Dec 13, 2011 - Perry - Report Running Failures
                    'fetch url to service that will validate download parameters
                    Dim downloadValidate As String = Url.Action("ValidateDownLoadParameters", "Dataset", New With {.Id = downloadView.DatasetViewID})
                    
                %>
                <div class="PopupContent">
                    <table width="280">
                        <% If Model.Dataset.IS_LARGE_DATASET_FLAG Then%>
                        <tr>
                            <td colspan="4">This is a large dataset and thus it might take several minutes to prepare 
                            the download depending on the parameters selected.</td>
                        </tr>
                        <% End If%>                                                                        
                        <tr>
                        <%  'Dec 13, 2011 - Perry - Report Running Failures
                            'adding downloadValidate arg to Download function called onclick%>                   
                            <td><a href="#" onclick="Download('<%=xlsDL %>','<%=downloadValidate %>');return false;"><img src="<%=Me.ResolveUrl("~/Content/icons/xls.gif") %>" alt="Microsoft Office Excel (.xls)"/></a></td>
                            <td><a href="#" onclick="Download('<%=xlsDL %>','<%=downloadValidate %>');return false;">Microsoft Office<br />Excel (.xls)</a></td>
                            <td><a href="#" onclick="Download('<%=pdfDL %>','<%=downloadValidate %>');return false;"><img src="<%=Me.ResolveUrl("~/Content/icons/pdf2.gif") %>" alt="Adobe PDF (.pdf)"/></a></td>
                            <td><a href="#" onclick="Download('<%=pdfDL %>','<%=downloadValidate %>');return false;">Adobe PDF (.pdf)</a></td>
                        </tr>
                    </table>
                </div>
            <%End If%>
        </div>
    </div>
    <div style="display:none;">
        <%  'Dec 13, 2011 - Perry - Report Running Failures
            'adding validation popup fancybox to display errors when the parameters are insufficient %>
        <a id="ValidationErrorDialog" href="#ValidationError" class="DialogButton"></a>
        <div id="ValidationError">
                <table width="280"><tr><td id="ValidationErrorText"></td></tr></table>
        </div>
    </div>
    <div style="display:none;">
        <%  'Jan 06, 2012 - Perry - Disclaimer dialog %>
        <a id="DisclaimerDialog" href="#Disclaimer" class="DialogButton"></a>
        <div id="Disclaimer">
                <table width="400"><tr><td id="DisclaimerText"></td></tr></table>
                <input id="DisclaimerButton" class="button" type="button" value="ok"  /> 
        </div>
    </div>
    <script type="text/javascript" src="<%= ResolveClientUrl("~/Scripts/DataLibrary.Dataset.js")%>"></script> 
    
</asp:content>
