﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.GridModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.Objects" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models" %>
<%
    Dim data As List(Of PermanentReclamation) = CType(Model.Data, List(Of PermanentReclamation))
    Dim projects As List(Of String) = data.Select(Function(d) d.Project).Distinct().ToList()
    Dim yearGroup = data.GroupBy(Function(d) d.Year).ToList()
    Dim pageSize As Integer = 15
    Dim pagerModel As New PagerModel(Model.Page, yearGroup.Count, pageSize)
    yearGroup = yearGroup.Skip(pageSize * (Model.Page - 1)).Take(pageSize).ToList()
    Dim alt As Boolean = False
%>

<%  Html.RenderPartial("Grids/PagerStart", pagerModel)%>
<table cellspacing="1">
    <tr class="Header">        
        <th rowspan="2">Year</th>
        <th rowspan="2">Age of Reclamation</th>
        <%For Each project As String In projects%>
        <th><%=project%></th>
        <%Next%>
        <th># of ha's of each age across the region</th>
    </tr>
    <tr>
        <td  style="text-align: center" colspan="<%=projects.Count +1 %>">Total Hectares Permanetly Reclaimed in that Year</td>
    </tr>
<%  For Each groupItem In yearGroup%>
    <tr <%=iif(alt,"class=""Alternate""","") %>>
        <td><%=groupItem.Key%></td>
        <td><%=groupItem.First.Age%></td>
        <%
            Dim total As Decimal = groupItem.Select(Function(g) g.PermanentReclamation).Sum
        For Each project As String In projects
            Dim projectName As String = project
            Dim value As PermanentReclamation = groupItem.FirstOrDefault(Function(g) g.Project = project)
            If value IsNot Nothing AndAlso value.PermanentReclamation.HasValue Then%>
                <td><%=value.PermanentReclamation.Value.ToString("N1")%></td>
            <%Else%>
                <td>n/a</td>
            <%
            End If
        Next
        %>
        <td><%=total.ToString("N1")%></td>
    </tr>
<%  
    alt = Not alt
Next
%>
</table>
<%  Html.RenderPartial("Grids/PagerEnd", pagerModel)%>