﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.GridModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.Objects" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models.ProviderObjects" %>
<% 
    Dim data As WaterUseIntensityHistory = CType(Model.Data, WaterUseIntensityHistory)
    Dim records As List(Of YearlyWaterUsedPerBarrelProduced) = data.Values
    Dim pageSize As Integer = 15
    Dim pagerModel As New PagerModel(Model.Page, records.Count, pageSize)
    records = records.Skip(pageSize * (Model.Page - 1)).Take(pageSize).ToList()
    Dim alt As Boolean = False
    Dim frothTreatmentMessage = ""
    
    If data.FrothTreatment Then
        frothTreatmentMessage = "The production total presented here is prior to the froth treatment; typically the froth treatment results in a 2% loss in bitumen."
    End If
    
%>

<%  Html.RenderPartial("Grids/PagerStart", pagerModel)%>
<table cellspacing="1">
    <tr class="Header">
        <th>Project</th>
        <th>Year</th>
        <th>Water Use per Barrel<br />of <%=data.Production%> Produced (Barrels)</th>
    </tr>
<%  For Each dataItem As YearlyWaterUsedPerBarrelProduced In records%>
    <tr <%=iif(alt,"class=""Alternate""","") %>>
        <td><%=data.ProjectName%></td>
        <td><%=dataItem.Year%></td>
        <td><%=dataItem.WaterUsedPerBarrelProduced.ToString("N3")%></td>
    </tr>       
<%  
    alt = Not alt
Next
%>
     <tr>
        <td colspan="3"> <%=frothTreatmentMessage%> </td>
    </tr>
</table>
<%  Html.RenderPartial("Grids/PagerEnd", pagerModel)%>