﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.GridModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models.ProviderObjects" %>
<%
    Dim data As CurrentReclamationSummary = CType(Model.Data, CurrentReclamationSummary)
    Dim UnitTitle As String = "Hectares"
    Select Case data.Unit
        Case GoA.Environment.OSIP.DataLibrary.LandReclamationUnits.Acres
            UnitTitle = "Acres"
        Case GoA.Environment.OSIP.DataLibrary.LandReclamationUnits.Hectares
            UnitTitle = "Hectares"
        Case GoA.Environment.OSIP.DataLibrary.LandReclamationUnits.KmSquared
            UnitTitle = "Km<sup>2</sup>"
        Case GoA.Environment.OSIP.DataLibrary.LandReclamationUnits.MilesSquared
            UnitTitle = "Miles<sup>2</sup>"
    End Select
    Dim alt As Boolean = False
    Dim dateString As String = "December 31, " & data.Records.First.ReportYear.ToString()
%>
<p class="GridTitle">Regional Reclamation and Disturbance Tracking by Company, to <%= dateString%></p>
<%  Html.RenderPartial("Grids/Start")%>
<table cellspacing="1">
    <tr class="Header">        
        <th rowspan="2">Mine Site/Facility</th>
        <th colspan="12"><%=UnitTitle%></th>
    </tr>
    <tr>
        <td class="Header">EPEA Approved Footprint</td>
        <td class="Header">Mine Site Footprint</td>
        <td class="Header">Plant Site Footprint</td>
        <td class="Header">Total Active Footprint</td>
        <td>Cleared</td>
        <td>Disturbed: Used for Mine or Plant Purposes</td>
        <td>Ready for Reclamation: No Longer Used for Mine or Plant Purposes</td>
        <td>Soils Placed (Terrestrial & Wetlands & Aquatics)</td>
        <td>Permanent Reclamation (Terrestrial)</td>
        <td>Permanent Reclamation (Wetlands & Aquatics)</td>
        <td>Temporary Reclamation (Terrestrial)</td>
        <td>Certified</td>
    </tr>
<%  For Each dataItem In data.Records%>
    <tr <%=iif(alt,"class=""Alternate""","") %>>
        <td><%=dataItem.ProjectName%></td>
        <td><% If dataItem.EPEAFootprint.HasValue Then%><%=Math.Round(dataItem.EPEAFootprint.Value, 1).ToString("N1")%><%End If%></td>
        <td><% If dataItem.MineFootprint.HasValue Then%><%=Math.Round(dataItem.MineFootprint.Value, 1).ToString("N1")%><%End If%></td>
        <td><% If dataItem.PlantFootprint.HasValue Then%><%=Math.Round(dataItem.PlantFootprint.Value, 1).ToString("N1")%><%End If%></td>
        <td><% If dataItem.TotalFootprint.HasValue Then%><%=Math.Round(dataItem.TotalFootprint.Value, 1).ToString("N1")%><%End If%></td>
        <td><% If dataItem.Cleared.HasValue Then%><%=Math.Round(dataItem.Cleared.Value, 1).ToString("N1")%><%End If%></td>
        <td><% If dataItem.DisturbedMinePlant.HasValue Then%><%=Math.Round(dataItem.DisturbedMinePlant.Value, 1).ToString("N1")%><%End If%></td>
        <td><% If dataItem.ReadyForReclamation.HasValue Then%><%=Math.Round(dataItem.ReadyForReclamation.Value, 1).ToString("N1")%><%End If%></td>
        <td><% If dataItem.SoilsPlaced.HasValue Then%><%=Math.Round(dataItem.SoilsPlaced.Value, 1).ToString("N1")%><%End If%></td>
        <td><% If dataItem.PermanentRecTerrestrial.HasValue Then%><%=Math.Round(dataItem.PermanentRecTerrestrial.Value, 1).ToString("N1")%><%End If%></td>
        <td><% If dataItem.PermanentRecWetlandsAquatics.HasValue Then%><%=Math.Round(dataItem.PermanentRecWetlandsAquatics.Value, 1).ToString("N1")%><%End If%></td>
        <td><% If dataItem.TemporaryRecTerrestrial.HasValue Then%><%=Math.Round(dataItem.TemporaryRecTerrestrial.Value, 1).ToString("N1")%><%End If%></td>
        <td><% If dataItem.Certified.HasValue Then%><%=Math.Round(dataItem.Certified.Value, 1).ToString("N1")%><%End If%></td>
    </tr>       
<%  
    alt = Not alt
Next%>
</table>
<%  Html.RenderPartial("Grids/End")%>