﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.GridModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models.ProviderObjects" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.OilSandsApi" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models" %>
<% 
    Dim data As SGERComplianceSummary = CType(Model.Data, SGERComplianceSummary)
    Dim records As List(Of YearlySummaryByProject) = data.Summaries
    Dim pageSize As Integer = 15
    Dim pagerModel As New PagerModel(Model.Page, records.Count, pageSize)
    records = records.Skip(pageSize * (Model.Page - 1)).Take(pageSize).ToList()
    Dim alt As Boolean = False
%>
<%  Html.RenderPartial("Grids/PagerStart", pagerModel)%>
<table cellspacing="1">
    <tr class="Header">
        <th>Project</th>        
        <th>Year</th>
        <th>Emissions net Of Compliance</th>
        <th>Fund Contributions</th>
        <th>Offsets</th>
        <th>EPCs Retired</th>
        <th>Cogen Efficiency Credit</th>
        <th>Incremental Cogen Electricity Emissions</th>
        <th>EPCs Generated</th>
        <th>Total Onsite Emissions</th>
    </tr>
<%  For Each dataItem As YearlySummaryByProject In records%>
    <tr <%=iif(alt,"class=""Alternate""","") %>>
        <td><%=data.ProjectName%></td>
        <td><%=dataItem.Year%></td>
        <td><% If dataItem.EmissionsNetCompliance.HasValue Then%><%=dataItem.EmissionsNetCompliance.Value.ToString("N0")%><%End If%></td>
        <td><% If dataItem.FundCreditsPurchased.HasValue Then%><%=dataItem.FundCreditsPurchased.Value.ToString("N0")%><%End If%></td>
        <td><% If dataItem.OffsetsSubmitted.HasValue Then%><%=dataItem.OffsetsSubmitted.Value.ToString("N0")%><%End If%></td>
        <td><% If dataItem.EPCsRetired.HasValue Then%><%=dataItem.EPCsRetired.Value.ToString("N0")%><%End If%></td>
        <td><% If dataItem.CogenEfficiencyCredit.HasValue Then%><%=dataItem.CogenEfficiencyCredit.Value.ToString("N0")%><%End If%></td>
        <td><% If dataItem.GHGFromElectricity.HasValue Then%><%=dataItem.GHGFromElectricity.Value.ToString("N0")%><%End If%></td>
        <td><% If dataItem.EPCsGenerated.HasValue Then%><%=dataItem.EPCsGenerated.Value.ToString("N0")%><%End If%></td>
        <td><% If dataItem.TotalGHGEmissions.HasValue Then%><%=dataItem.TotalGHGEmissions.Value.ToString("N0")%><%End If%></td>
    </tr>       
<%  
    alt = Not alt
Next
%>
</table>
<%  Html.RenderPartial("Grids/PagerEnd", pagerModel)%>
