﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.GridModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.Objects" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.OilSandsApi" %>
<% 
    Dim data As YearlyProductionTotals = CType(Model.Data, YearlyProductionTotals)
    Dim frothTreatmentMessage = ""
    If Not IsNothing(data.FrothTreatmentProjectNames) Then
        frothTreatmentMessage = data.FrothTreatmentProjectNames
    End If
    Dim records As List(Of YearlyTotalProduction) = data.ProductionData
    Dim pageSize As Integer = 15
    Dim pagerModel As New PagerModel(Model.Page, records.Count, pageSize)
    records = records.Skip(pageSize * (Model.Page - 1)).Take(pageSize).ToList()
    Dim alt As Boolean = False
%>
<%  Html.RenderPartial("Grids/PagerStart", pagerModel)%>
<table cellspacing="1" style="text-align: right">
    <tr class="Header" style="text-align: center">
        <th></th>
        <th colspan="6">Million Metres &sup3</th>
        <th></th>
        <th colspan="6">Million Barrels</th>
    </tr>
    <tr  class="Header">
        <th rowspan="3">Year</th>
        <th rowspan="3">Total</th>
        <th colspan="5"></th>
        <th rowspan="3">Total</th>
        <th colspan="5"></th>
    </tr>
    <tr class="Header">
        <th rowspan="2">Total Synthetic Crude Oil</th>
        <th rowspan="2">Total Non-Upgraded Bitumen</th>
        <th colspan="3"></th>
        <th rowspan="2">Total Synthetic Crude Oil</th>
        <th rowspan="2">Total Non-Upgraded Bitumen</th>
        <th colspan="3"></th>
    </tr>
    <tr class="Header">
        <th>Mining</th>
        <th>Thermal In Situ</th>
        <th>Primary and Conventional</th>
        <th>Mining</th>
        <th>Thermal In Situ</th>
        <th>Primary and Conventional</th>
    </tr>

<%  For Each dataItem As YearlyTotalProduction In records%>
    <tr <%=iif(alt,"class=""Alternate""","") %>>
        <td><%=dataItem.Year%> </td>
        <td><%=Math.Round((dataItem.TotalSyntheticCrudeOilM3.Value + dataItem.TotalMiningBitumenM3.Value + dataItem.TotalThermalInSituBitumenM3.Value + dataItem.TotalConventionalBitumenM3.Value + dataItem.TotalPrimaryBitumenM3.Value) / 1000000, 2)%></td>
        <td><%=Math.Round(dataItem.TotalSyntheticCrudeOilM3.Value / 1000000, 2)%> </td>      
        <td><%=Math.Round((dataItem.TotalMiningBitumenM3.Value + dataItem.TotalThermalInSituBitumenM3.Value + dataItem.TotalConventionalBitumenM3.Value + dataItem.TotalPrimaryBitumenM3.Value) / 1000000, 2)%></td>
        <td><%=Math.Round(dataItem.TotalMiningBitumenM3.Value / 1000000, 2)%> </td>      
        <td><%=Math.Round(dataItem.TotalThermalInSituBitumenM3.Value / 1000000, 2)%> </td>      
        <td><%=Math.Round((dataItem.TotalConventionalBitumenM3.Value + dataItem.TotalPrimaryBitumenM3.Value) / 1000000, 2)%></td>   
         
        <td><%=Math.Round((dataItem.TotalSyntheticCrudeOilBBL.Value + dataItem.TotalMiningBitumenBBL.Value + dataItem.TotalThermalInSituBitumenBBL.Value + dataItem.TotalConventionalBitumenBBL.Value + dataItem.TotalPrimaryBitumenBBL.Value) / 1000000, 2)%></td>
        <td><%=Math.Round(dataItem.TotalSyntheticCrudeOilBBL.Value / 1000000, 2)%> </td>      
        <td><%=Math.Round((dataItem.TotalMiningBitumenBBL.Value + dataItem.TotalThermalInSituBitumenBBL.Value + dataItem.TotalConventionalBitumenBBL.Value + dataItem.TotalPrimaryBitumenBBL.Value) / 1000000, 2)%></td>
        <td><%=Math.Round(dataItem.TotalMiningBitumenBBL.Value / 1000000, 2)%> </td>      
        <td><%=Math.Round(dataItem.TotalThermalInSituBitumenBBL.Value / 1000000, 2)%> </td>      
        <td><%=Math.Round((dataItem.TotalConventionalBitumenBBL.Value + dataItem.TotalPrimaryBitumenBBL.Value) / 1000000, 2)%></td>    
    </tr>       
<%  
    alt = Not alt
Next
%>
    <tr>
        <td colspan="13"> <%=frothTreatmentMessage%></td>
    </tr>
</table>
<%  Html.RenderPartial("Grids/PagerEnd", pagerModel)%>
