﻿<%@ Control Language="VB" Inherits="System.Web.Mvc.ViewUserControl(Of GoA.Environment.OSIP.DataLibrary.Models.GridModel)" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models.ProviderObjects" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.WaterQualityService" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Models" %>
<%
    Dim data As StationWaterQualityIndexHistory = CType(Model.Data, StationWaterQualityIndexHistory)
    Dim records As List(Of WaterQualityRecord) = data.Records
    Dim pageSize As Integer = 15
    Dim pagerModel As New PagerModel(Model.Page, records.Count, pageSize)
    records = records.Skip(pageSize * (Model.Page - 1)).Take(pageSize).ToList()
    Dim alt As Boolean = False
%>
<table>
    <tr>
        <%For Each r As WaterQualityRating In data.Ratings%>
        <td style="background-color:#<%=r.WebColor%>"><%=r.Name%> (<%=r.MinValue %> - <%=r.MaxValue%>)</td>
        <%Next%>
    </tr>
</table>
<%  Html.RenderPartial("Grids/PagerStart", pagerModel)%>
<table cellspacing="1">
    <tr class="Header">        
        <th>Station</th>
        <th>Period</th>
        <th>Water Quality Index</th>
        <th>Bacterial Index</th>
        <th>Metals Index</th>
        <th>Nutrient Index</th>
        <th>Pesticide Index</th>
    </tr>
<%  For Each dataItem As WaterQualityRecord In records%>
    <tr <%=iif(alt,"class=""Alternate""","") %>>
        <td><%=data.StationName%></td>
        <td><%=dataItem.Period%></td>
        <td><% If dataItem.WaterQualityIndex.HasValue Then %><%=dataItem.WaterQualityIndex.Value.ToString()%><%End If%></td>
        <td><% If dataItem.BacterialIndex.HasValue Then%><%=dataItem.BacterialIndex.Value.ToString()%><%End If%></td>
        <td><% If dataItem.MetalsIndex.HasValue Then %><%=dataItem.MetalsIndex.Value.ToString()%><%End If%></td>
        <td><% If dataItem.NutrientsIndex.HasValue Then%><%=dataItem.NutrientsIndex.Value.ToString()%><%End If%></td>
        <td><% If dataItem.PesticidesIndex.HasValue Then%><%=dataItem.PesticidesIndex.Value.ToString()%><%End If%></td>
    </tr>       
<%  
    alt = Not alt
Next
%>
</table>
<%  Html.RenderPartial("Grids/PagerEnd", pagerModel)%>
