﻿<%@ Page Language="VB" Inherits="System.Web.Mvc.ViewPage" MasterPageFile="~/Views/Shared/Modal.Master" CodeBehind="SpeciesDetails.aspx.vb" %>
<%@ Import Namespace="Newtonsoft.Json" %>
<%@ Import Namespace="GoA.Environment.OSIP.DataLibrary.Data.ODataClientCode" %>

<asp:Content ID="Content1" ContentPlaceHolderID="cphHeadSection" runat="server">

    <script>

        require([
                "dojo/parser",
                "dijit/layout/TabContainer",
                "dijit/layout/ContentPane",
                "dojox/charting/Chart",
                "dojox/charting/themes/MiamiNice",
                "dojox/charting/plot2d/StackedColumns",
                "dojox/charting/plot2d/Grid",
                "dojox/charting/action2d/Tooltip",
                "dojox/charting/widget/Legend",
                "dojox/charting/action2d/MouseZoomAndPan",
                "dojox/charting/action2d/TouchZoomAndPan",
                "dojox/charting/action2d/Highlight",
                "dojo/dom-style",
                "dojox/charting/plot2d/Lines",
                "dojox/charting/plot2d/MarkersOnly",
                "dojox/charting/Series",
                "dojo/on",
                "dojo/has",
                "dojox/charting/axis2d/Default",
                "dojo/domReady!"
        ], function (parser, TabContainer, ContentPane, Chart, theme, StackedColumns, Grid, Tooltip, Legend, MouseZoomAndPan, TouchZoomAndPan, Highlight, domStyle, Lines, MarkersOnly, Series, on, has) {

            var speciesPopulationData = JSON.parse('<%=JsonConvert.SerializeObject(Model.SpeciesPopulationData).Replace("\r\n", "\\r\\n") %>');
            var speciesName = '<%=Model.SpeciesName%>';
            var speciesPopulationsYears = [];
            var speciesPopulations = [];
            var maxSpeciesPopulation = 0;
            var speciesPopulationCsv = "Species,Year,Status,Population,Source\r\n";

            var herdData = JSON.parse('<%=JsonConvert.SerializeObject(Model.SpeciesHerdData)%>');
            var herdPopulationData = JSON.parse('<%=JsonConvert.SerializeObject(Model.SpeciesHerdPopulationData)%>');
            var herdPopulationsYears = [];
            var herdPopulations = [];
            var maxHerdPopulation = 0;
            var herdPopulationCsv = "Species,Herd,Year,Status,Population,Source\r\n";
            var speciesMarker = '<%=JsonConvert.SerializeObject(Model.SpeciesIconSvgPath)%>';

            speciesPopulationData.forEach(function (item, index) {
                speciesPopulations.push(item.Population);
                speciesPopulationsYears.push({ value: index + 1, text: item.PopulationYear });
                if (item.Population > maxSpeciesPopulation) {
                    maxSpeciesPopulation = item.Population;
                }
                var populationSource = '';
                if (item.Source !== null) {
                    // remove ',' from population source
                    populationSource = item.Source.replace(/\,/g, ' ');
                }
                speciesPopulationCsv += item.SpeciesName + "," + item.PopulationYear + "," + item.COSEWICStatus + "," + item.Population + "," + populationSource + "\r\n";
            });

            if (herdPopulationData !== null) {
                herdPopulationData.forEach(function (item, index) {
                    herdPopulations.push(item.Population);
                    herdPopulationsYears.push({ value: index + 1, text: item.PopulationYear });
                    if (item.Population > maxHerdPopulation) {
                        maxHerdPopulation = item.Population;
                    }
                    var herdPopulationSource = '';
                    if (item.Source !== null) {
                        // remove ',' from population source
                        herdPopulationSource = item.Source.replace(/\,/g, ' ');
                    }
                    herdPopulationCsv += speciesName + "," + item.HerdName + "," + item.PopulationYear + "," + item.COSEWICStatus + "," + item.Population + "," + herdPopulationSource + "\r\n";
                });
            }

            var defaultStatusColor = "#00AAF0";

            if (speciesMarker === 'null') {
                // no icon if its not defined 
                // The first element in the m command is where to start drawing so it’s an x,y coordinate.)
                speciesMarker = "m-0,-0 0,0 0,0 -0,0z";
            }

            // function for download link
            var createDownloadLink = function (link, downloadFilename, csvData) {
                if (navigator.appVersion.toString().indexOf('.NET') > 0) {
                    //IE
                    if (typeof Blob === "undefined" || typeof navigator.msSaveBlob === "undefined") {
                        //IE 9 doesn't support Blob and msSaveBlob, disable the download link
                        link.style.visibility = "hidden";
                    } else {
                        link.href = "#";
                        var blob = new Blob([csvData], { type: 'text/csv' });
                        on(link, "click", function () {
                            window.navigator.msSaveBlob(blob, downloadFilename);
                            return false;
                        });
                    }
                } else {
                    // Firefox or Chrome
                    var blob = new Blob([csvData], { type: 'text/csv' });
                    link.download = downloadFilename;
                    link.href = URL.createObjectURL(blob);
                    if (has("touch")) {
                        link.target = "_blank";
                    }
                }
            };

            // provicial population status chart
            if (maxSpeciesPopulation > 0) {
                maxSpeciesPopulation *= 1.2; // add extra space for Species Icon

                // Create the chart within it's "holding" node
                var chartProvincial = new Chart("chartNodeProvincial");

                // Set theme
                chartProvincial.setTheme(theme);

                // Add the default plot
                chartProvincial.addPlot("default", {
                    type: "Columns",
                    markers: true,
                    gap: 5,
                    maxBarSize: 50
                });

                // Add Species Marker Plot
                chartProvincial.addPlot("plot_markers", { type: MarkersOnly });

                // Add axes
                chartProvincial.addAxis("x", {
                    labels: speciesPopulationsYears,
                    title: "Year",
                    titleOrientation: "away",
                    majorTickStep: 1,
                    minorTickStep: 0
                });

                chartProvincial.addAxis("y", {
                    vertical: true,
                    max: maxSpeciesPopulation,
                    min: 0,
                    title: "Population",
                    fixed: false, natural: true,
                    minorTicks: false, minorLabels: false, microTicks: false,
                    majorTickStep: 200
                });

                // Add the series of data
                //chartProvincial.addSeries("Population", speciesPopulations, {
                //    stroke: { color: "#1F6EA4" },
                //    fill: "#1F6EA4"
                //});

                // add series for population status
                speciesPopulationData.forEach(function (item, index) {
                    // add a series for each iteam so we can assign the fill color to match the item's StatusColourCode
                    var iconColor = item.StatusColourCode;
                    if (iconColor == null)
                        iconColor = defaultStatusColor;

                    chartProvincial.addSeries("Population" + item.PopulationYear,
                        [{ x: index + 1, y: item.Population }],
                    {
                        stroke: { color: iconColor },
                        fill: iconColor
                    });

                    chartProvincial.addSeries("series_markers" + item.PopulationYear,
                    [{ x: index + 1, y: item.Population }],
                    {
                        plot: "plot_markers",
                        stroke: { color: iconColor, width: 0 },
                        fill: iconColor,
                        marker: speciesMarker
                    });
                });

                // Tooltip
                var tooltipSpecies = new Tooltip(chartProvincial, "default");

                // Highlight
                //var highlightSpecies = new Highlight(chartProvincial, "default", { highlight: "#01A8EB" });

                // Zoom
                var zoomAndPanSpecies = new MouseZoomAndPan(chartProvincial, "default", { axis: "x", scaleFactor: 1, maxScale: 4, enableScroll: true, enableDoubleClickZoom: true, keyZoomModifier: "shift" }); //switched to use shift key instead of default ctrl to avoid conflict with browser zooming

                // Render the chart!
                chartProvincial.render();

                //update download data URL
                createDownloadLink(document.getElementById("provincialDownloadLink"),
                                   speciesName + ' Provincial Status.csv', speciesPopulationCsv);
            }

            // herd population status chart
            if (maxHerdPopulation > 0) {
                maxHerdPopulation *= 1.2; // add extra space for Species Icon
                // Create the chart within it's "holding" node
                var chartHerdPopulation = new Chart("chartNodePopulation");

                // Set theme
                chartHerdPopulation.setTheme(theme);

                // Add the default plot
                chartHerdPopulation.addPlot("default", {
                    type: "Columns",
                    markers: true,
                    gap: 5,
                    maxBarSize: 50
                });

                // Add Species Marker Plot
                chartHerdPopulation.addPlot("herdplot_markers",
                    { type: MarkersOnly });

                // Add axes
                chartHerdPopulation.addAxis("x", {
                    labels: herdPopulationsYears,
                    title: "Year",
                    titleOrientation: "away",
                    majorTickStep: 1,
                    minorTickStep: 0
                });

                chartHerdPopulation.addAxis("y", {
                    vertical: true,
                    max: maxHerdPopulation,
                    min: 0,
                    title: "Population",
                    fixed: false, natural: true,
                    minorTicks: false, minorLabels: false, microTicks: false,
                    majorTickStep: 200
                });

                // Add the series of data
                //chartHerdPopulation.addSeries("Population", herdPopulations, {
                //    stroke: { color: "#1F6EA4" },
                //    fill: "#1F6EA4"
                //});

                // add series for herd population status
                herdPopulationData.forEach(function (item, index) {
                    // add a series for each iteam so we can assign the fill color to match the item's StatusColourCode
                    var iconColor = item.StatusColourCode;
                    if (iconColor == null)
                        iconColor = "#FFFF00";

                    chartHerdPopulation.addSeries("Population" + item.PopulationYear,
                    [{ x: index + 1, y: item.Population }],
                    {
                        stroke: { color: iconColor },
                        fill: iconColor
                    });

                    chartHerdPopulation.addSeries("series_markers" + item.PopulationYear,
                    [{ x: index + 1, y: item.Population }],
                    {
                        plot: "herdplot_markers",
                        stroke: { color: iconColor, width: 0 },
                        fill: iconColor,
                        marker: speciesMarker
                    });
                });

                // Tooltip
                var tooltipHerd = new Tooltip(chartHerdPopulation, "default");

                // Highlight
                // var highlightHerd = new Highlight(chartHerdPopulation, "default", { highlight: "#01A8EB" });

                // Zoom
                var zoomAndPanHerd = new MouseZoomAndPan(chartHerdPopulation, "default", { axis: "x", scaleFactor: 1, maxScale: 4, enableScroll: true, enableDoubleClickZoom: true, keyZoomModifier: "shift" }); //switched to use shift key instead of default ctrl to avoid conflict with browser zooming

                // Render the chart!
                chartHerdPopulation.render();
            }

            parser.parse();

            //hide Loader
            dojo.fadeOut({
                node: "preloader",
                onEnd: function () {
                    domStyle.set("preloader", "display", "none");
                }
            }).play();

            // remove herd population tab when herd data is not available
            if (herdData === null) {
                dijit.byId('tabContainer').removeChild(dijit.byId('population'));
            } else {
                //update download data URL
                createDownloadLink(document.getElementById("populationDownloadLink"),
                                   herdData.HerdName + ' - ' + speciesName + ' Population Status.csv', herdPopulationCsv);

            }

            // change chart heading based on selected tab ( this is valid only for caribou )
            var tabContainer = dijit.byId("tabContainer");
            dojo.connect(tabContainer, "_transition", function (selectedTab) {
                var speciesTitle = dojo.byId("speciesName");
                if (speciesTitle !== null && speciesTitle !== undefined) {
                    if (selectedTab.id != 'population') {
                        speciesTitle.textContent = speciesName;
                    } else {
                        speciesTitle.textContent = herdData.HerdName + ' ' + speciesName + ' Population';
                    }
                }
            });

        });
    </script>

</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">

    <div id="preloader"></div>

    <%If Model.SpeciesHerdData IsNot Nothing Then%>
    <span id="speciesName" class="title"><%=Model.SpeciesHerdData.HerdName%> <%=Model.SpeciesName%> Population</span>
    <%Else%>
    <span class="title"><%=Model.SpeciesName%></span>
    <%End If%>

    <div id="detailsPageContent">
        <div data-dojo-type="dijit/layout/TabContainer" id="tabContainer">

            <div data-dojo-type="dijit/layout/ContentPane" id="population" title="Population Status" data-dojo-props="selected:true">
                <%If Model.SpeciesHerdData IsNot Nothing Then%>
                <div class="chartHeadings">
                    <div class="headingYear"><%=Model.SpeciesHerdData.AlbertaMostRecentStatusYear%></div>
                    <div class="headingDescription">Alberta Status for the <%=Model.SpeciesHerdData.HerdName%> <%=Model.SpeciesName%> Population : <span class="titleChart"><%=Model.SpeciesHerdData.AlbertaMostRecentStatus%></span></div>
                    <br />
                    <%If Model.HerdLatestPopulationYear > 0 Then%>
                    <div class="headingYear"><%=If(Model.HerdLatestPopulationYear > 0, Model.HerdLatestPopulationYear, Nothing)%></div>
                    <div class="headingDescription">Estimated Population : <span class="titleChart"><%=Model.HerdLatestPopulation%></span></div>
                    <%Else%>
                    <div class="headingDataNotAvailable">Population data not available</div>
                    <%End If%>
                </div>

                <br />

                <table>
                    <tr>
                        <td>
                            <div id="chartNodePopulation"></div>
                        </td>
                        <td class="legendColumn">
                            <%If Model.SpeciesHerdPopulationData.Count > 0 Then%>
                                <%For Each colourCode As Status In Model.HerdPopulationStatusColourCodes%>
                                <div class="statuslinks">
                                    <span class="square" style="background: <%=colourCode.StatusColourCode%> !important"></span>
                                    <span class="statusDescription"><%=colourCode.StatusName%></span>
                                </div>
                                <br />
                                <% Next%>
                            <%End If%>

                            <ul class="downloadDataSpecies">
                                <li>
                                    <a id="populationDownloadLink" class="linksDownloadData">Download this data</a>
                                </li>
                                <%For Each shapeFileLink As SpeciesEducationLink In Model.SpeciesShapeFileLinksData%>
                                <li>
                                    <a href="<%=shapeFileLink.Url%>" target="_blank" class="linksDownloadData"><%=shapeFileLink.LinkName%></a>
                                </li>
                                <% Next%>
                            </ul>
                        </td>
                    </tr>
                </table>

                <%End If%>
            </div>

            <div data-dojo-type="dijit/layout/ContentPane" id="provincial" title="Provincial Status" data-dojo-props="selected:true">

                <div class="chartHeadings">
                    <div class="headingYear"><%=Model.SpeciesData.AlbertaMostRecentStatusYear%></div>
                    <div class="headingDescription">Alberta Status : <span class="titleChart"><%=Model.SpeciesData.AlbertaMostRecentStatus%></span></div>
                    <br />
                    <div class="headingYear"><%=If(Model.SpeciesLatestPopulationYear > 0, Model.SpeciesLatestPopulationYear, Nothing)%></div>
                    <div class="headingDescription">Canada (COSEWIC) Status : <span class="titleChart"><%=Model.SpeciesLatestCosewicStatus%></span></div>
                    <br />
                    <div class="headingYear"><%=If(Model.SpeciesLatestPopulationYear > 0, Model.SpeciesLatestPopulationYear, Nothing)%></div>
                    <div class="headingDescription">Population : <span class="titleChart"><%=Model.SpeciesLatestPopulation%></span></div>
                </div>

                <br />

                <table>
                    <tr>
                        <td>
                            <div id="chartNodeProvincial"></div>
                        </td>
                        <td class="legendColumn" >
                            <%For Each colourCode As Status In Model.SpeciesPopulationStatusColourCodes%>
                            <div class="statuslinks">
                                <div class="square" style="background: <%=colourCode.StatusColourCode%> !important"></div>
                                <div class="statusDescription"><%=colourCode.StatusName%></div>
                            </div>
                            <br />
                            <% Next%>

                            <ul class="downloadDataSpecies">
                                <li>
                                    <a id="provincialDownloadLink" class="linksDownloadData">Download this data</a>
                                </li>
                                <%For Each shapeFileLink As SpeciesEducationLink In Model.SpeciesShapeFileLinksData%>
                                <li>
                                    <a href="<%=shapeFileLink.Url%>" target="_blank" class="linksDownloadData"><%=shapeFileLink.LinkName%></a>
                                </li>
                                <% Next%>
                            </ul>

                        </td>
                    </tr>
                </table>
                <%If Not String.IsNullOrEmpty(Model.SpeciesData.GraphSource) Then%>
                <table>
                    <tr>
                        <td class="speciesGraphSource">
                            <span class="speciesGraphSourceLabel">Source: </span><%=Model.SpeciesData.GraphSource%>
                        </td>
                    </tr>
                </table>
                <%End If%>
            </div>

            <div data-dojo-type="dijit/layout/ContentPane" id="education" title="Education">
                <div id="edContent">
                    <div class="edLinks">
                        <div id="educationInformationLinks">
                            <ul class="educationlinks">
                                <%For Each educationInforLink As SpeciesEducationLink In Model.SpeciesInformationLinksData%>
                                <li class="educationLinkListItem">
                                    <img title="<%=educationInforLink.LinkName%>" src="<%= ResolveClientUrl("~/Content/" + educationInforLink.DisplayIconName)%>" style="width: 20px" />
                                    <a href="<%=educationInforLink.Url%>" target="_blank" class="links"><%=educationInforLink.LinkName%></a>
                                </li>
                                <% Next%>
                            </ul>
                        </div>
                    </div>
                    <div class="edReportLinks">
                        <div id="educationReportAndViewLinks">
                            <ul class="educationlinks">
                                <%For Each educationReportViewLink As SpeciesEducationLink In Model.SpeciesReportAndViewLinksData%>
                                <li class="educationLinkListItem">
                                    <img title="<%=educationReportViewLink.LinkName%>" src="<%= ResolveClientUrl("~/Content/" + educationReportViewLink.DisplayIconName)%>" style="width: 20px" />
                                    <a href="<%=educationReportViewLink.Url%>" target="_blank" class="links"><%=educationReportViewLink.LinkName%></a>
                                </li>
                                <% Next%>
                            </ul>
                        </div>
                    </div>
                    <div class="edVideos">
                            <% If Model.SpeciesVideoLinksData.Count > 1 Then%>
                             <ul id="videoLinks">
                                <%For Each videoLink As SpeciesEducationLink In Model.SpeciesVideoLinksData%>
                                <li class="videoWrapper">
                                    <div class="videoEmbed">
                                        <%=videoLink.EmbedLink%>
                                    </div>
                                    <span class="videoTitle">
                                        <%=videoLink.LinkName%>
                                    </span>
                                </li>
                                <% Next%>
                             </ul>
                             <%ElseIf Model.SpeciesVideoLinksData.Count = 1 Then%>   
                                <ul class="singleVideoWrapper">
                                    <li class="singleVideoWrapper">
                                    <div class="videoEmbed">
                                        <%=Model.SpeciesVideoLinksData(0).EmbedLink%>
                                    </div>
                                    <span class="singleVideoTitle">
                                        <%=Model.SpeciesVideoLinksData(0).LinkName%>
                                    </span>
                                    </li>
                                </ul>
                             <%End If%>
                    </div>
                </div>
            </div>
        </div>
    </div>
</asp:Content>
