/*property
    HYBRID, LatLng, LatLngBounds, MAP_STYLE_GRAY, MAP_STYLE_LIGHT_GRAY,
    MAP_STYLE_NIGHT, MAP_TYPE_HYBRID, MAP_TYPE_ROADMAP, MAP_TYPE_SATELLITE,
    MAP_TYPE_TERRAIN, Map, MapTypeId, ROADMAP, SATELLITE, TERRAIN, _apiOptions,
    _checkZoomLevel, _connects, _controlDiv, _element,
    _esriExtentToLatLngBounds, _esriPointToLatLng, _extentChangeHandle,
    _extentChangeHandler, _getGMapTypeId, _gmap, _gmapDiv,
    _gmapTiltChangeHandle, _gmapTypeChangeHandle, _googleLayers, _initGMap,
    _isZoomSliderDefault, _latLngBoundsToEsriExtent, _map, _mapOptions,
    _mapTiltChangeHandler, _mapTypeChangeHandler, _moveControls, _mvHandle,
    _onGalleryClickExt, _onGalleryClickListenerExt, _onLoadExt,
    _onLoadListenerExt, _onSelectionChangeExt, _onSelectionChangeListenerExt,
    _opacityChangeHandler, _original_postMixInProperties, _original_startup,
    _panHandle, _panHandler, _resizeHandle, _resizeHandler, _rotateMoved,
    _setExtent, _setMap, _startupCalled, _streetView,
    _streetViewVisibilityChangeHandler, _styleOptions, _svMoved,
    _svVisibleHandle, _toggleEsriControl, _topDiv, _unsetMap,
    _visibilityChangeHandler, addListener, after, agsjs, alpha, apiOptions,
    appendChild, basemaps, basemapsGroup, body, center, cols, connect,
    constructor, create, createElement, destroy, disableMapNavigation, domNode,
    dpi, enableMapNavigation, event, every, expand, extend, extent,
    featureType, filter, filters, fitBounds, floor, forEach, fullExtent,
    geographicToWebMercator, getBounds, getCenter, getElementsByTagName,
    getGoogleMapInstance, getLevel, getMapTypeId, getNorthEast, getSouthWest,
    getStreetView, getTilt, getVisible, google, height, hide, hideZoomSlider,
    hitch, id, indexOf, initialExtent, invert_lightness, isZoomSlider, keys,
    lat, layers, left, length, level, lightness, lng, loaded, location, lods,
    mapOptions, mapTypeControl, mapTypeId, mapTypes, maps, max, maxZoom, min,
    minZoom, mixin, offsetHeight, offsetWidth, onGMapsApiLoad, onLoad,
    onMapTypeChange, onStreetViewVisibilityChange, opacity, origin, panControl,
    parentNode, place, position, postMixInProperties, protocol, prototype,
    push, remove, removeChild, removeListener, resolution, rows, saturation,
    scale, sensor, set, setCenter, setExtent, setLevel, setMapStyles,
    setMapTypeId, setOpacity, setOptions, setVisible, show, showArcGISBasemaps,
    showZoomSlider, spatialReference, src, startup, style, stylers, styles,
    thumbnailUrl, tileInfo, title, toLowerCase, toUrl, toggleReference, top,
    trigger, type, visible, webMercatorToGeographic, width, wkid, x, xmax,
    xmin, y, ymax, ymin, zoom, zoomControl
*/



/*global 
    google agsjs
*/
/**
* @name Google Maps Layer for ArcGIS Server JavaScript API
* @author: Nianwei Liu
* @fileoverview
* <p>Use Google Maps in application built on ESRI ArcGIS Server JavaScript API.
*  </p>
*/
// Change log:
//2012-07-15: v2.0, update to jsapi3.0/dojo1.7, simplified.
// drop features related to sublayers for google maps, client code can do it after get reference to gmap instance.
// constructor parameter syntax changed slightly for BasemapGallery.
// streetview control is on by default.
// no xbuilt. issues with  loading the xdomain built from googlecode.com while loading jsapi from arcgisonline.
//2011-12-15: v1.07, update to jsapi2.6, oblique rotation, work with esri BasemapGallery, delayed of loading of API until set as visible
//2011-10-24: v1.05, working with basemapcontrol, styled options
//2011-10-18: v1.04, xd built
//2011-10-17: v1.03, added support for StreetView, Sub layers (Traffic, Point of Interest etc)
//2011-10-05: fixed issues with Chrome, IE7, IE8
//2011-08-11: updated for JSAPI 2.4. changed package.

define(
[
    "dojo/aspect", "dojo/_base/connect", "dojo/_base/declare", "dojo/_base/lang", "dojo/_base/array", "dojo/query", "dojo/dom-construct", "dojo/dom-class", "dojo/dom-style", "esri/layers/layer", "esri/layers/TileInfo", "esri/domUtils", "esri/geometry/webMercatorUtils", "esri/geometry/Extent", "esri/dijit/Basemap", "esri/dijit/BasemapLayer"
],
function (aspect, connect, declare, lang, array, query, domConstruct, domClass, domStyle, Layer, TileInfo, domUtils, webMercatorUtils, Extent, Basemap, BasemapLayer) {
    'use/strict';
    var GoogleMapsLayer = declare("GoogleMapsLayer", [Layer], {
        /**
        * @name GoogleMapsLayerOptions
        * @class This is an object literal that specify the option to construct a {@link GoogleMapsLayer}.
        * @property {String} [id] layerId.
        * @property {Boolean} [visible] default visibility
        * @property {Number} [opacity] opacity (0-1)
        * @property {GoogleMapsAPIOptions} [apiOptions] The options to load Google API. Include property: v, client, sensor, language etc,see {@link GoogleMapsAPIOptions}
        * @property {google.maps.MapOptions} [mapOptions] optional. The options for construct Google Map instance. See <a href=http://code.google.com/apis/maps/documentation/javascript/reference.html#MapOptions>MapOptions</a>.
        */
        /**
        * @name GoogleMapsAPIOptions
        * @class This is an object literal that specify the option to load Google Maps API V3. See <a href=http://code.google.com/apis/maps/documentation/javascript/basics.html>Google documentation</a> for more information.
        * @property {Boolean} [sensor] whether GPS device is used. default to false;
        * @property {Number} [v] API version, 3, 3.1 etc. default to 3.
        * @property {String} [client] client ID for Google Maps Premier license.
        * @property {String} [language] language to use for text such as the names for controls, etc, e.g. cn, ja
        * @property {String} [dir] Bi-directional (Bidi) text. rtl or ltr;
        * @property {String} [libraries] Additonal libraries (geometry|places|adsense);
        *
        */
        /**
        * Create a GoogleMapsLayer using config {@link GoogleMapsLayerOptions}
        * @name GoogleMapsLayer
        * @constructor
        * @class This class allows Google Maps been used in ESRI ArcGIS JavaScript API.
        * @param {GoogleMapsLayerOptions} opts
        */
        constructor: function (opts) {
            opts = opts || {};
            // this tileInfo does not actually do anything. It simply tricks nav control to
            // show a slider bar if only gmaps are used, which should be a rare case.
            this.tileInfo = new TileInfo({
                rows: 256,
                cols: 256,
                dpi: 96,
                origin: {
                    x: -20037508.342787,
                    y: 20037508.342787
                },
                spatialReference: {
                    wkid: 102100
                },
                lods: [{
                    level: 0,
                    resolution: 156543.033928,
                    scale: 591657527.591555
                }, {
                    level: 1,
                    resolution: 78271.5169639999,
                    scale: 295828763.795777
                }, {
                    level: 2,
                    resolution: 39135.7584820001,
                    scale: 147914381.897889
                }, {
                    level: 3,
                    resolution: 19567.8792409999,
                    scale: 73957190.948944
                }, {
                    level: 4,
                    resolution: 9783.93962049996,
                    scale: 36978595.474472
                }, {
                    level: 5,
                    resolution: 4891.96981024998,
                    scale: 18489297.737236
                }, {
                    level: 6,
                    resolution: 2445.98490512499,
                    scale: 9244648.868618
                }, {
                    level: 7,
                    resolution: 1222.99245256249,
                    scale: 4622324.434309
                }, {
                    level: 8,
                    resolution: 611.49622628138,
                    scale: 2311162.217155
                }, {
                    level: 9,
                    resolution: 305.748113140558,
                    scale: 1155581.108577
                }, {
                    level: 10,
                    resolution: 152.874056570411,
                    scale: 577790.554289
                }, {
                    level: 11,
                    resolution: 76.4370282850732,
                    scale: 288895.277144
                }, {
                    level: 12,
                    resolution: 38.2185141425366,
                    scale: 144447.638572
                }, {
                    level: 13,
                    resolution: 19.1092570712683,
                    scale: 72223.819286
                }, {
                    level: 14,
                    resolution: 9.55462853563415,
                    scale: 36111.909643
                }, {
                    level: 15,
                    resolution: 4.77731426794937,
                    scale: 18055.954822
                }, {
                    level: 16,
                    resolution: 2.38865713397468,
                    scale: 9027.977411
                }, {
                    level: 17,
                    resolution: 1.19432856685505,
                    scale: 4513.988705
                }, {
                    level: 18,
                    resolution: 0.597164283559817,
                    scale: 2256.994353
                }, {
                    level: 19,
                    resolution: 0.298582141647617,
                    scale: 1128.497176
                }, {
                    level: 20,
                    resolution: 0.149291070823808,
                    scale: 564.248588
                }]
            });

            this.fullExtent = new Extent({
                xmin: -20037508.34,
                ymin: -20037508.34,
                xmax: 20037508.34,
                ymax: 20037508.34,
                spatialReference: {
                    wkid: 102100
                }
            });
            this.initialExtent = new Extent({
                xmin: -20037508.34,
                ymin: -20037508.34,
                xmax: 20037508.34,
                ymax: 20037508.34,
                spatialReference: {
                    wkid: 102100
                }
            });
            this.opacity = opts.opacity || 1;
            this._mapOptions = opts.mapOptions || {};
            this._apiOptions = lang.mixin({
                sensor: false
            }, opts.apiOptions || {});

            //   if (this._mapOptions.streetViewControl == undefined) {
            //     this._mapOptions.streetViewControl = false;
            //   }
            this._gmap = null;
            this.loaded = true;// it seems _setMap will only get called if loaded = true, so set it here first.
            this.onLoad(this);
        },

        /**
        * get the wrapped <code>google.maps.Map</code> for further customization.
        * @function
        * @name GoogleMapsLayer#getGoogleMapInstance
        * @return {google.maps.Map}
        */
        getGoogleMapInstance: function () {
            return this._gmap;
        },
        // override parent class abstract method
        /**********************
        * @see http://help.arcgis.com/en/webapi/javascript/arcgis/samples/exp_rasterlayer/javascript/RasterLayer.js
        * Internal Properties
        *
        * _map
        * _element
        * _context
        * _mapWidth
        * _mapHeight
        * _connects
        *
        **********************/
        _setMap: function (map, container) {
            // This overrides an undocumented private method from ESRI API.
            // It's possible not to do this, but it requires
            // map instance implicitly set to the layer instance, which is a little bit inconvenient.
            // this is likely called inside esriMap.addLayer()
            this._map = map;
            // this style is used to style 0 size divs, mainly for holding it's DOM position but not obstructing events.
            var style = {
                position: 'absolute',
                top: '0px',
                left: '0px',
                width: '0px',
                height: '0px'
            };
            var element = domConstruct.create('div', {}, container);
            if (this.id) {
                element.id = this.id;
            }
            domStyle.set(element, style);
            this._element = element;
            var div = domConstruct.create('div', {}, element);
            domStyle.set(div, style);
            domStyle.set(div, 'width', (map.width || container.offsetWidth) + 'px');
            domStyle.set(div, 'height', (map.height || container.offsetHeight) + 'px');
            this._gmapDiv = div;

            // topDiv is used to mask all esri events in oblique mode.
            var tdiv = domConstruct.create('div', {}, map.id);
            tdiv.id = 'gmaps_top_' + div.id;
            domStyle.set(tdiv, style);
            this._topDiv = tdiv;
            // controlDiv is used to hold pegman and oblique rotater.
            var cdiv = domConstruct.create('div', {}, map.id);
            cdiv.id = 'gmaps_controls_' + div.id;
            domStyle.set(cdiv, lang.mixin(style, {
                // width: '0px',
                // height: '0px',
                top: '5px',
                left: '5px'
            }));
            this._controlDiv = cdiv;

            //this._container = layersDiv;
            // Event connections
            this._connects = [];
            //this._connects.push(on(this, 'visibility-change', lang.hitch(this, this._visibilityChangeHandler)));
            this._connects.push(connect.connect(this, 'onVisibilityChange', this, this._visibilityChangeHandler));
            //this._connects.push(on(this, 'opacity-change', lang.hitch(this, this._opacityChangeHandler)));
            this._connects.push(connect.connect(this, 'onOpacityChange', this, this._opacityChangeHandler));

            this.visible = (this.visible === undefined) ? true : this.visible;
            if (this.visible) {
                this._initGMap();
            }
            return element;
        },
        _unsetMap: function () {//(map, layersDiv) {
            // see _setMap. Undocumented method, but probably should be public.
            array.forEach(this._connects, function (handle) { handle.remove(); });
            if (this._streetView) {
                this._streetView.setVisible(false);
            }
            if (google !== undefined && google.maps && google.maps.event) {
                if (this._gmapTypeChangeHandle) {
                    google.maps.event.removeListener(this._gmapTypeChangeHandle);
                }
                if (this._svVisibleHandle) {
                    google.maps.event.removeListener(this._svVisibleHandle);
                }
            }
            if (this._element) {
                this._element.parentNode.removeChild(this._element);
            }
            domConstruct.destroy(this._element);
            if (this._controlDiv) {
                this._controlDiv.parentNode.removeChild(this._controlDiv);
            }
            domConstruct.destroy(this._controlDiv);
            if (this._topDiv) {
                this._topDiv.parentNode.removeChild(this._topDiv);
            }
            domConstruct.destroy(this._topDiv);
            this._element = null;
            this._gmapDiv = null;
            this._controlDiv = null;

        },

        // delayed init and Api loading.
        _initGMap: function () {
            window.google = window.google || {}; // somehow IE needs this, otherwise complain google.maps namespace;
            if (window.google && google.maps) {
                var ext = this._map.extent;
                var center = this._mapOptions.center || this._esriPointToLatLng(ext.getCenter());
                var level = this._map.getLevel();
                var myOptions = lang.mixin({
                    //disableDefaultUI: true,
                    center: center,
                    zoom: (level > -1) ? level : 1,
                    panControl: false,
                    mapTypeControl: false,
                    zoomControl: false
                }, this._mapOptions);

                if (myOptions.mapTypeId) {
                    myOptions.mapTypeId = this._getGMapTypeId(myOptions.mapTypeId);
                } else {
                    myOptions.mapTypeId = google.maps.MapTypeId.ROADMAP;
                }
                var gmap = new google.maps.Map(this._gmapDiv, myOptions);
                if (level < 0) {
                    //on(this._map, 'load', lang.hitch(this, function () {
                    connect.connect(this._map, 'onLoad', this, function () {
                        this._setExtent(ext);
                    });
                    //}));
                }
                this._gmap = gmap;
                this._setExtent(ext);

                //this._extentChangeHandle = on(this._map, 'extent-change', lang.hitch(this, this._extentChangeHandler));
                this._extentChangeHandle = connect.connect(this._map, 'onExtentChange', this, this._extentChangeHandler);
                //this._panHandle = on(this._map, 'pan', lang.hitch(this, this._panHandler));
                this._panHandle = connect.connect(this._map, 'onPan', this, this._panHandler);
                //this._resizeHandle = on(this._map, 'resize', lang.hitch(this, this._resizeHandler));
                this._resizeHandle = connect.connect(this._map, 'onResize', this, this._resizeHandler);
                // 45 deg need move up regardless of streetview
                //this._mvHandle = on(this._map, 'mouse-move', lang.hitch(this, this._moveControls));
                this._mvHandle = connect.connect(this._map, 'onMouseMove', this, this._moveControls);
                this._gmapTypeChangeHandle = google.maps.event.addListener(this._gmap, 'maptypeid_changed', lang.hitch(this, this._mapTypeChangeHandler));
                this._gmapTiltChangeHandle = google.maps.event.addListener(this._gmap, 'tilt_changed', lang.hitch(this, this._mapTiltChangeHandler));
                this.onLoad();
            } else if (window.agsjs !== undefined && agsjs.onGMapsApiLoad) {
                // did another instance already started loading agsjs API but not done?
                // this should be very very rare because one instance of this layer would be sufficient with setMapTypeId.
                aspect.after(agsjs, 'onGMapsApiLoad', lang.hitch(this, this._initGMap));
                //connect.connect(agsjs, 'onGMapsApiLoad', this, this._initGMap);
            } else {
                // this is the first instance that tries to load agsjs API on-demand
                agsjs = {};
                agsjs.onGMapsApiLoad = function () {
                    // do nothing, just needed to dispatch event.
                };
                aspect.after(agsjs, 'onGMapsApiLoad', lang.hitch(this, this._initGMap));
                //connect.connect(agsjs, 'onGMapsApiLoad', this, this._initGMap);
                var script = document.createElement('script');
                script.type = 'text/javascript';
                var pro = window.location.protocol;
                if (pro.toLowerCase().indexOf('http') === -1) {
                    pro = 'http:';
                }
                var src = pro + '//maps.googleapis.com/maps/api/js?callback=agsjs.onGMapsApiLoad';
                Object.keys(this._apiOptions).forEach(function(key) {
                    src += '&' + key + '=' + this._apiOptions[key];
                }, this);
                script.src = src;
                if (document.getElementsByTagName('head').length > 0) {
                    document.getElementsByTagName('head')[0].appendChild(script);
                } else {
                    document.body.appendChild(script);
                }
            }
        },

        /**
        * Sets Opacity
        * @name GoogleMapsLayer#setOpacity
        * @function
        * @param {Number} opacity from 0-1
        */
        setOpacity: function (opacity) {
            // dojo core should have something do this
            if (this._gmapDiv) {
                opacity = Math.min(Math.max(opacity, 0), 1);
                var st = this._gmapDiv.style;
                if (st.opacity !== undefined) {
                    st.opacity = opacity;
                } else if (st.filters !== undefined) {
                    st.filters.alpha.opacity = Math.floor(100 * opacity);
                } else if (st.filter !== undefined) {
                    st.filter = "alpha(opacity:" + Math.floor(opacity * 100) + ")";
                }
            }
            this.opacity = opacity;
        },
        /**
        * set map type id. e.g <code>GoogleMapsLayer.MAP_TYPE_ROADMAP</code>
        *
        * @name GoogleMapsLayer#setMapTypeId
        * @function
        * @param {String} mapTypeId one of GoogleMapsLayer.MAP_TYPE_ROADMAP|MAP_TYPE_HYBRID|MAP_TYPE_STELLITE|MAP_TYPE_TERRIAN
        */
        setMapTypeId: function (mapTypeId) {
            if (this._gmap) {
                this._gmap.setMapTypeId(this._getGMapTypeId(mapTypeId));
                this._mapTypeChangeHandler();
            } else {
                this._mapOptions.mapTypeId = mapTypeId;
            }
            return;
        },
        /**
        * set map style for customized base map. The style specs are available at <a href="http://code.google.com/apis/maps/documentation/javascript/styling.html">Google Documentation</a>.
        * This class privide a few pre-defined styles: MAP_STYLE_GRAY|MAP_STYLE_NIGHT.
        * @name GoogleMapsLayer#setMapStyle
        * @function
        * @param {Object[]} styles
        */
        setMapStyles: function (styles) {
            if (this._styleOptions) {
                // if has _styleOptions, set it null means clear it.
                styles = styles || [];
            }
            if (styles) {
                if (this._gmap) {
                    this._styleOptions = styles;
                    this._gmap.setOptions({
                        styles: styles
                    });
                } else {
                    this._mapOptions.styles = styles;
                }
            }
            return;
        },
        /**
        * Fired when Google Map Type (ROAD, SATERLLITE etc) changed
        * @name GoogleMapsLayer#onMapTypeChange
        * @param {String} mapTypeId
        * @event
        */
        onMapTypeChange: function (mapTypeId) {
            // event
        },
        _getGMapTypeId: function (type) {
            // typically the constants is same, however, if google changes,
            // and API is loaded dynamically but map type is specified before API load,
            // there is a slight chance they are out of sync, so fix here.
            if (google && google.maps) {
                switch (type) {
                    case GoogleMapsLayer.MAP_TYPE_ROADMAP:
                        return google.maps.MapTypeId.ROADMAP;
                    case GoogleMapsLayer.MAP_TYPE_HYBRID:
                        return google.maps.MapTypeId.HYBRID;
                    case GoogleMapsLayer.MAP_TYPE_SATELLITE:
                        return google.maps.MapTypeId.SATELLITE;
                    case GoogleMapsLayer.MAP_TYPE_TERRAIN:
                        return google.maps.MapTypeId.TERRAIN;
                }
            }
            return type;
        },
        _opacityChangeHandler: function (opacity) {
            // this probably should be handled in the core ESRI API using the div returned from _setMap().
            this.setOpacity(opacity);
        },

        _visibilityChangeHandler: function (v) {
            if (v) {
                domUtils.show(this._gmapDiv);
                //if (!this._svDisabled) {
                domUtils.show(this._controlDiv);
                //}
                this.visible = true;
                if (this._gmap) {
                    google.maps.event.trigger(this._gmap, 'resize');
                    //this._panHandle = this._panHandle || on(this._map, "pan", lang.hitch(this, this._panHandler));
                    this._panHandle = this._panHandle || connect.connect(this._map, "onPan", this, this._panHandler);
                    //this._extentChangeHandle = this._extentChangeHandle || on(this._map, "extent-change", lang.hitch(this, this._extentChangeHandler));
                    this._extentChangeHandle = this._extentChangeHandle || connect.connect(this._map, "onExtentChange", this, this._extentChangeHandler);
                    this._setExtent(this._map.extent);
                } else {
                    this._initGMap();
                }
            } else {
                if (this._gmapDiv) {
                    domUtils.hide(this._gmapDiv);
                    domUtils.hide(this._controlDiv);
                    this.visible = false;
                    if (this._gmap) {
                        this._map.setExtent(this._latLngBoundsToEsriExtent(this._gmap.getBounds()));
                    }
                    if (this._streetView) {
                        this._streetView.setVisible(false);
                    }
                    if (this._panHandle) {
                        this._panHandle.remove();
                        this._panHandle = null;
                    }
                    if (this._extentChangeHandle) {
                        this._extentChangeHandle.remove();
                        this._extentChangeHandle = null;
                    }
                }
            }
        },
        _resizeHandler: function (extent, height, width) {
            if (this._gmapDiv) {
                domStyle.set(this._gmapDiv, {
                    width: this._map.width + "px",
                    height: this._map.height + "px"
                });
            }
            google.maps.event.trigger(this._gmap, 'resize');
        },
        _extentChangeHandler: function (extent, delta, levelChange, lod) {
            if (levelChange) {
                this._setExtent(extent);
            } else {
                this._gmap.setCenter(this._esriPointToLatLng(extent.getCenter()));
            }
        },
        _panHandler: function (extent, delta) {
            //console.log('pan:'+extent.xmin+','+extent.ymin+','+extent.xmax+','+extent.ymax);
            if (this._gmap.getTilt() == 0) {
                this._gmap.setCenter(this._esriPointToLatLng(extent.getCenter()));
            }
        },
        _mapTypeChangeHandler: function () {
            this._checkZoomLevel();
            this.onMapTypeChange(this._gmap.getMapTypeId());
        },

        _checkZoomLevel: function () {
            var id = this._gmap.getMapTypeId();
            var types = this._gmap.mapTypes;
            var maptype = null;
            Object.keys(types).every(function(key) {
                if (key === id) {
                    maptype = types[key];
                    return false;
                }
                return true;
            }, this);
            //for (var x in types) {
            //    if (types.hasOwnProperty(x) && x == id) {
            //        maptype = types[x];
            //        break;
            //    }
            //}
            // prevent the case when switch to terrain causing misalignment because terrain only up to level 15.
            if (maptype != null) {
                var mi = maptype.minZoom;
                var mx = maptype.maxZoom;
                var z = this._map.getLevel();
                if (mx !== undefined && z > mx) {
                    this._map.setLevel(mx);
                }
                if (mi != undefined && z < mi) {
                    this._map.setLevel(mi);
                }
            }
        },
        _setExtent: function (extent) {
            var ct = this._esriPointToLatLng(extent.getCenter());
            var lv = this._map.getLevel();


            // if (lv >= 0) {
            //   this._gmap.setZoom(lv);
            //
            // } else {
            //
            // }

            // esrimap.getLevel is not reliable. result differnt if first layer is Bing Map vs arcgis tile layer.
            // Google maps fit always get a smaller zoom.
            this._gmap.fitBounds(this._esriExtentToLatLngBounds(extent.expand(0.5)));
            this._gmap.setCenter(ct);
            this._checkZoomLevel();

            //console.log('gmaps fit:'+this._gmap.getZoom()+' emap:'+lv);
        },
        // move the street view control on top of map container.
        // Esri API prevents mouse event progaginate to lower divs inside map container
        // this method sort of move it up so it can be dragged. A little bit hack,
        // but as long as stick to a certain version, should still be workable.
        _moveControls: function () {
            if (this._mvHandle) {
                if (!this._gmap) {
                    this._mvHandle.remove();
                    this._mvHandle = null;
                } else {
                    if (!this._svMoved) {
                        this._streetView = this._gmap.getStreetView();
                        if (this._streetView) {
                            var sv = query('.gmnoprint img[src*="cb_scout_sprite"]', this._gmapDiv);
                            if (sv.length > 0) {
                                array.forEach(sv, function (s, idx) {
                                    domConstruct.place(s.parentNode.parentNode, this._controlDiv);
                                }, this);

                                this._svMoved = true;
                                this._svVisibleHandle = google.maps.event.addListener(this._streetView, 'visible_changed', lang.hitch(this, this._streetViewVisibilityChangeHandler));
                            }
                        } else {
                            this._svMoved = true;
                        }
                    }
                    if (!this._rotateMoved) {
                        var ob = query('.gmnoprint img[src*="rotate"]', this._gmapDiv);
                        if (ob.length > 0) {
                            array.forEach(ob, function (s, idx) {
                                domConstruct.place(s.parentNode.parentNode, this._controlDiv);
                                domStyle.set(s, 'position', 'absolute');
                                domStyle.set(s, 'left', '20px');
                            }, this);
                            this._rotateMoved = true;
                        }
                    }
                    if (this._rotateMoved && this._svMoved) {
                        this._mvHandle.remove();
                        this._mvHandle = null;
                    }
                }
            }
        },
        _streetViewVisibilityChangeHandler: function () {
            //console.log('_streetViewVisibilityChangeHandler');
            if (this._streetView) {
                var vis = this._streetView.getVisible();
                this._toggleEsriControl(vis);
                this.onStreetViewVisibilityChange(vis);
            }

        },
        // when oblique is shown, we should disable esri mouse events because the projection changes.
        _mapTiltChangeHandler: function () {
            //console.log('_mapTiltChangeHandler');
            var t = this._gmap.getTilt();
            if (t == 45) {
                //this._toggleEsriControl(true);
                //this._map._isPanGMaps = this._map.isPan;
                //this._map.disablePan();
                domConstruct.place(this._gmapDiv, this._topDiv);
                this._map.disableMapNavigation();
            } else if (t == 0) {
                //this._toggleEsriControl(false);
                //if (this._map._isPanGMaps) this._map.enablePan();
                domConstruct.place(this._gmapDiv, this._element);
                this._map.enableMapNavigation();
            }

        },
        _toggleEsriControl: function (turnOff) {
            if (turnOff) {
                this._isZoomSliderDefault = this._map.isZoomSlider;
                this._map.hideZoomSlider();
                // gmaps (as of v3.6) still dispatch events even street view is visible. so we disable it here.
                this._map.disableMapNavigation();

            } else {
                if (this._isZoomSliderDefault) {
                    this._map.showZoomSlider();
                }
                this._map.enableMapNavigation();
            }
        },
        /**
        * Fired when Street View visibility changed.
        * @name GoogleMapsLayer#onStreetViewVisibilityChange
        * @param {boolean} visibility
        * @event
        */
        onStreetViewVisibilityChange: function (vis) {
            // attach events
        },
        /**
        * Fired when Street View visibility changed.
        * @name GoogleMapsLayer#onStreetViewVisibilityChange
        * @param {boolean} visibility
        * @event
        */
        onLoad: function () {

        },
        _esriPointToLatLng: function (pt) {
            var ll = webMercatorUtils.webMercatorToGeographic(pt);
            return new google.maps.LatLng(ll.y, ll.x);
        },
        _esriExtentToLatLngBounds: function (ext) {
            var llb = webMercatorUtils.webMercatorToGeographic(ext);
            return new google.maps.LatLngBounds(new google.maps.LatLng(llb.ymin, llb.xmin, true), new google.maps.LatLng(llb.ymax, llb.xmax, true));
        },
        _latLngBoundsToEsriExtent: function (bounds) {
            var ext = new Extent(bounds.getSouthWest().lng(), bounds.getSouthWest().lat(), bounds.getNorthEast().lng(), bounds.getNorthEast().lat());
            return webMercatorUtils.geographicToWebMercator(ext);
        }

    });

    lang.mixin(GoogleMapsLayer, {
        MAP_TYPE_SATELLITE: "satellite",
        MAP_TYPE_HYBRID: "hybrid",
        MAP_TYPE_ROADMAP: "roadmap",
        MAP_TYPE_TERRAIN: "terrain",
        MAP_STYLE_GRAY: [{
            featureType: 'all',
            stylers: [{
                saturation: -80
            }, {
                lightness: 20
            }]
        }],
        MAP_STYLE_LIGHT_GRAY: [{
            featureType: 'all',
            stylers: [{
                saturation: -80
            }, {
                lightness: 60
            }]
        }],
        MAP_STYLE_NIGHT: [{
            featureType: 'all',
            stylers: [{
                invert_lightness: 'true'
            }]
        }]
    });


    // extend Esri gallery
    // note: should not use dojo.ready here because it will not run until all outstanding dojo.require resolved.
    // that maybe too late to construct a BasemapGallery manually.
    require(["dojo/_base/lang", "esri/dijit/BasemapGallery"], function (lang, BasemapGallery) {
        //console.log('has esri.dijit.BasemapGallery');
        BasemapGallery.prototype._original_postMixInProperties = BasemapGallery.prototype.postMixInProperties;
        BasemapGallery.prototype._original_startup = BasemapGallery.prototype.startup;
        lang.extend(BasemapGallery, {
            google: null,
            _googleLayers: [],
            toggleReference: false,
            postMixInProperties: function () {
                if (!this._onSelectionChangeListenerExt) {
                    //this._onSelectionChangeListenerExt = on(this, 'selection-change', lang.hitch(this, this._onSelectionChangeExt));
                    this._onSelectionChangeListenerExt = connect.connect(this, 'onSelectionChange', this, this._onSelectionChangeExt);
                }
                if (this.google != undefined && (this.showArcGISBasemaps || this.basemapsGroup)) {
                    this.basemaps.push(new Basemap({
                        id: 'google_road',
                        layers: [new BasemapLayer({
                            type: 'GoogleMapsRoad'
                        })],
                        title: "Google Road",
                        thumbnailUrl: require.toUrl("agsjs/dijit/images/googleroad.png")
                    }));
                    this.basemaps.push(new Basemap({
                        id: 'google_satellite',
                        layers: [new BasemapLayer({
                            type: 'GoogleMapsSatellite'
                        })],
                        title: "Google Satellite",
                        thumbnailUrl: require.toUrl("agsjs/dijit/images/googlesatellite.png")
                    }));
                    this.basemaps.push(new Basemap({
                        id: 'google_hybrid',
                        layers: [new BasemapLayer({
                            type: 'GoogleMapsHybrid'
                        })],
                        title: "Google Hybrid",
                        thumbnailUrl: require.toUrl("agsjs/dijit/images/googlehybrid.png")
                    }));

                }
                if (this.loaded) {
                    this._onLoadExt();
                } else {
                    //this._onLoadListenerExt = on(this, 'load', lang.hitch(this, this._onLoadExt));
                    this._onLoadListenerExt = connect.connect(this, 'onLoad', this, this._onLoadExt);
                }
                if (this._original_postMixInProperties) {
                    this._original_postMixInProperties();
                }
                //console.log('dom' + this.domNode);
            },
            startup: function () {
                // user have option of not calling startup for custom UI.
                // _startupCalled is used to flag if we need refresh UI for toggle reference layer
                this._startupCalled = true;
                this._original_startup();
                
                // move from _processReferenceLayersExt because domNode may not be available at the time if manual mode.
                if (!this._onGalleryClickListenerExt) {
                    //this._onGalleryClickListenerExt = on(this.domNode, 'click', lang.hitch(this, this._onGalleryClickExt));
                    this._onGalleryClickListenerExt = connect.connect(this.domNode, 'onClick', this, this._onGalleryClickExt);
                }
            },
            _onLoadExt: function () {
                //console.log('inside _onLoad ');
                if (this._onLoadListenerExt) {
                    this._onLoadListenerExt.remove();
                }
                if (this.toggleReference) {
                    array.forEach(this.basemaps, function (basemap) {
                        var layers = basemap.getLayers();
                        if (layers.length) {
                            this._processReferenceLayersExt(basemap);
                        } else {
                            layers.then(lang.hitch(this, this._processReferenceLayersExt, basemap));
                        }
                    }, this);
                }
            },
            _processReferenceLayersExt: function (basemap) {
                var layers = basemap.getLayers();
                var hasRef = false, vis = true;
                array.forEach(layers, function (layer) {
                    if (layer.isReference) {
                        hasRef = true;
                        if (layer.visibility === false) {
                            vis = false;
                        }
                    }
                });

                if (hasRef && this.toggleReference) {
                    basemap.title += '<input type="checkbox"  disabled ' + (vis ? 'checked' : '') + '/>';
                    basemap._hasReference = true;
                } else {
                    basemap._hasReference = false;
                }

                var needsRefresh = 0;
                array.forEach(this.basemaps, function (b) {
                    // make sure all basemaps are processed. it is decided by each basemap has a _hasReference property, regardless true or false.
                    // if there is any basemap not processed, should not refresh.
                    // if there are at least one ref layers for that basemap, will refresh.
                    if (b._hasReference == undefined) {
                        needsRefresh -= this.basemaps.length;
                    }
                    if (b._hasReference) {
                        needsRefresh++;
                    }
                }, this);
                if (needsRefresh >= 0) {
                    if (needsRefresh > 0 && this._startupCalled) {
                        // if startup is executed before all basemap are processed, need recall it. if not called yet, does not matter.
                        this.startup();
                    }
                }
            },
            _onSelectionChangeExt: function () {
                var selected = this.getSelected();
                var layer;
                if (selected) {
                    if (this._googleLayers.length > 0) {
                        array.forEach(this._googleLayers, function (lay) {
                            this.map.removeLayer(lay);
                        }, this);
                        this._googleLayers.length = 0;
                    }
                    query('input', this.domNode).forEach(function (m) {
                        m.disabled = true;
                    });
                    var layers = selected.getLayers();
                    array.forEach(layers, function (blay) {
                        if (blay.type && blay.type.indexOf("GoogleMaps") > -1) {
                            var mtype = GoogleMapsLayer.MAP_TYPE_ROADMAP;
                            if (blay.type == "GoogleMapsSatellite") {
                                mtype = GoogleMapsLayer.MAP_TYPE_SATELLITE;
                            } else if (blay.type == "GoogleMapsHybrid") {
                                mtype = GoogleMapsLayer.MAP_TYPE_HYBRID;
                            }
                            this.google = this.google || {};
                            this.google.mapOptions = this.google.mapOptions || {};
                            this.google.mapOptions.mapTypeId = mtype;

                            layer = new GoogleMapsLayer(this.google);
                            this.map.addLayer(layer, 0);
                            this._googleLayers.push(layer);
                        }
                    }, this);
                }
                // when the first basemap is selected, UI may already built, but at that time,
                // nothing to mark as selected node because first onSelectionChange has not been fired yet.
                var hasSelectedNode = this._checkSelectedNode();
                if (!hasSelectedNode && this._startupCalled) {
                    // mark selected basemap in UI.
                    this.startup();
                    // this enables checkbox;
                    this._checkSelectedNode();
                }

            },
            _checkSelectedNode: function () {
                var hasSelectedNode = false;
                var layers = this.getSelected().getLayers();
                query('.esriBasemapGallerySelectedNode', this.domNode).forEach(function (n) {
                    hasSelectedNode = true;
                    query('input', n).forEach(function (m) {
                        m.disabled = false;
                        // jsapi fires onSelectionChange before reference layer updates, (should be a bug) so we can not set vis directly.
                        //this._setReferenceVis(m.checked);
                        array.forEach(layers, function (blay) {
                            if (blay.isReference) {
                                blay.visibility = m.checked;
                            }
                        }, this);

                    }, this);
                }, this);
                return hasSelectedNode;
            },
            _onGalleryClickExt: function (evt) {
                var t = evt.target;
                if (t.tagName.toLowerCase() == 'input') {
                    this._setReferenceVis(t.checked);
                } else if (domClass.contains(t.parentNode, 'esriBasemapGalleryLabelContainer')) {
                    // this allows basemap switch by clicking on label.
                    t.parentNode.parentNode.firstChild.click();
                }
            },
            _setReferenceVis: function (visible) {
                //arcgis API does not associate the actual created esri Layer and BasemapLayer
                // so have to use undocumented _basemapGalleryLayerType.
                array.forEach(this.map.layerIds, function (id) {
                    var layer = this.map.getLayer(id);
                    if (layer._basemapGalleryLayerType == "reference") {
                        if (visible) {
                            layer.show();
                        } else {
                            layer.hide();
                        }

                    }
                }, this);
            },
            /**
            * get array of active google layers. Typically there is only one layer in the array.
            * @return {GoogleMapsLayer[]}
            */
            getGoogleLayers: function () {
                return this._googleLayers;
            }
        });
    });
    return GoogleMapsLayer; 
});
