﻿define([
    "app/content/FirstNationContent",
    "app/content/MetisSettlements",
    "app/content/FirstNationCooperativesContent"
], function (
    FirstNationContent,
    MetisSettlements,
    FirstNationCooperativesContent
    ) {
    'use strict';
    return {
        id: 'FirstNations',
        title: 'First Nations and M&eacute;tis Boundaries',
        description: 'First Nations and M&eacute;tis Boundaries',
        iconClass: "icon-empty blue-txt",
        operationalLayers: [
            {
                type: 'dynamic',
                url: 'https://geospatial.alberta.ca/titan/rest/services/boundary/federal_land/MapServer',
                title: 'Treaty Areas',
                layerOrder: 1,
                options: {
                    id: 'treatyAreas',
                    opacity: 1,
                    visibleLayers: [19,20],
                    visible: false
                },
                legendIcons: [{ iconName: siteConfig.rootUrl + 'scripts/app/content/images/operational/TreatyBoundary.png', label: 'Treaty Areas' }]
            },
            {
                type: 'dynamic',
                url: 'https://geospatial.alberta.ca/titan/rest/services/boundary/first_nations_land/MapServer',
                title: 'First Nation Reserves',
                layerOrder: 1,
                options: {
                    id: 'firstNationReserves',
                    opacity: 0.6,
                    visibleLayers: [0,1,2,3,4],
                    visible: false
                },
                //customModule: new FirstNationContent(),
                legendIcons: [{ iconName: siteConfig.rootUrl + 'scripts/app/content/images/operational/indian_reserve.png', label: 'First Nation Reserves' }]
            },
            {
                type: 'feature',
                url: 'https://geospatial.alberta.ca/titan/rest/services/boundary/urban_and_rural_municipality/MapServer/29',
                title: 'First Nation Cooperatives',
                layerOrder: 1,
                options: {
                    id: 'firstNationCooperatives',
                    opacity: 2,
                    outFields: ['*'],
                    visible: false
                },
                zoomToLevel: 7,
                customModule: new FirstNationCooperativesContent(),
                legendIcons: [{ iconName: siteConfig.rootUrl + 'scripts/app/content/images/operational/settlement.png', label: 'First Nation Cooperatives' }]
            },
            {
                type: 'dynamic',
                url: 'https://geospatial.alberta.ca/titan/rest/services/boundary/first_nations_land/MapServer',
                title: 'M&eacute;tis Settlements',
                layerOrder: 1,
                options: {
                    id: 'metisSettlement',
                    opacity: 0.6,
                    visibleLayers: [5, 6, 7, 8, 9,10,11,12,13,14,15],
                    visible: false
                },
                //customModule: new MetisSettlements(),
                legendIcons: [{ iconName: siteConfig.rootUrl + 'scripts/app/content/images/operational/metis_settlement.png', label: 'M&eacute;tis Settlements' }]
            }
        ]
    };
});