﻿define([], function () {
    'use strict';
    return {
        id: 'Land',
        title: 'LAND',
        description: 'Land',
        iconClass: "icon-land blue-txt",
        focusElementId: 'parksAndProtectedArea',
        operationalLayers: [
            {
                type: 'dynamic',
                url: siteConfig.osipMapServer + '',
                title: 'Parks and Protected Areas',
                layerOrder: 1,
                options: {
                    id: 'protectedAreaData',
                    opacity: 1,
                    visible: false,
                    multiLayers: [
                    {
                        id: 'naturalRegionsSubRegions2005',
                        title: 'Natural Regions and Sub-Regions',
                        visibleLayersIds: [29],
                        legendIcons: [{ iconGroupId: 'naturalRegions', iconGroupName: '2005 Natural Regions and Subregions' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/central_mixed_wood.png', label: 'Central Mixedwood' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/dry_mixed_wood.png', label: 'Dry Mixedwood' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/northern_mixed_wood.png', label: 'Northern Mixedwood' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/boreal_subarctic.png', label: 'Boreal Subarctic' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/peace_athabasca_delta.png', label: 'Peace-Athabasca Delta' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/lower_boreal_highlands.png', label: 'Lower Boreal Highlands' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/upper_boreal_highlands.png', label: 'Upper Boreal Highlands' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/athabasca_plain.png', label: 'Athabasca Plain' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/alpine.png', label: 'Alpine' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/subalpine.png', label: 'Subalpine' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/montane.png', label: 'Montane' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/lower_foothills.png', label: 'Lower Foothills' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/kazan_uplands.png', label: 'Kazan Uplands' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/upper_foothills.png', label: 'Upper Foothills' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/foothills_parkland.png', label: 'Foothills Parkland' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/peace_river_parkland.png', label: 'Peace River Parkland' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/central_parkland.png', label: 'Central Parkland"' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/dry_mixed_grass.png', label: 'Dry Mixedgrass' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/foothills_fescue.png', label: 'Foothills Fescue' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/northern_fescue.png', label: 'Northern Fescue' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/mixed_grass.png', label: 'Mixedgrass' }
                        ]
                    },
                    {
                        id: 'parksAndProtectedArea',
                        title: 'Parks and Protected Areas',
                        visibleLayersIds: [10,12,13,14, 15, 16, 20, 22, 25, 26],
                        legendIcons: [{ iconGroupId: 'parksProtectedArea', iconGroupName: 'Parks and Protected Areas' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/chrs_clearwater.png', label: 'CHRS Clearwater' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/Sanctuary_Corridor_Wildlife.png', label: 'Sanctuary Corridor Wildlife' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/Sanctuary_Game_Bird.png', label: 'Sanctuary Game Bird' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/Sanctuary_Restricted_Area.png', label: 'Sanctuary Restricted Area' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/Sanctuary_Seasonal.png', label: 'Sanctuary Seasonal' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/Sanctuary_Wildlife.png', label: 'Sanctuary Wildlife' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/National_Park.png', label: 'National Park' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/Provincial_Park.png', label: 'Provincial Park' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/Wildland_Parks.png', label: 'Wildland Parks' },
                                      { iconName: siteConfig.rootUrl + 'scripts/app/content/images/wildlife/Wilderness_Parks.png', label: 'Wilderness Parks' }]
                    }
                    ]
                }
            }
        ]
    };
});