﻿define([
    "app/content/RiverFlowAndLakeLevelContent",
    "app/content/RiverQualityContent",
    "app/content/LakeQualityContent"
], function (
    RiverFlowAndLakeLevelContent,
    RiverQualityContent,
    LakeQualityContent
) {
    'use strict';
    return {
        id: 'Water',
        title: 'WATER',
        description: 'Water',
        iconClass: "icon-water blue-txt",
        focusElementId: 'lakeQualityStations',
        operationalLayers: [
            {
                type: 'feature',
                url: siteConfig.osipMapServer + '35',
                title: 'River Level/Flow Stations',
                layerOrder: 3,
                defaultIconforRenderer: '/RiverFlow.png',
                options: {
                    id: 'riverFlowStations',
                    outFields: ['*'],
                    opacity: 1,
                    visible: false
                },
                customModule: new RiverFlowAndLakeLevelContent({dataUrl: siteConfig.dataUrl, stationType: "River"}),
                legendIcons: [{ iconName: siteConfig.rootUrl + 'scripts/app/content/images/water/RiverFlow.png', label: 'River Level/Flow Stations', glossaryAnchorTage: 'River_Flow_Index' }]
            },
            {
                type: 'feature',
                url: siteConfig.osipMapServer + '36',
                title: 'Lake Level Stations',
                layerOrder: 3,
                defaultIconforRenderer: '/LakeLevel.png',
                options: {
                    id: 'lakeLevelStations',
                    outFields: ['*'],
                    opacity: 1,
                    visible: false
                },
                customModule: new RiverFlowAndLakeLevelContent({ dataUrl: siteConfig.dataUrl, stationType: "Lake" }),
                legendIcons: [{ iconName: siteConfig.rootUrl + 'scripts/app/content/images/water/LakeLevel.png', label: 'Lake Level Stations', glossaryAnchorTage: 'Lake_Level' }]
            },
            {
                type: 'feature',
                url: siteConfig.osipMapServer + '33',
                title: 'River Quality Stations',
                layerOrder: 3,
                options: {
                    id: 'riverQualityStations',
                    outFields: ['*'],
                    opacity: 1,
                    visible: false
                },
                customModule: new RiverQualityContent(),
                legendIcons: [{ iconName: siteConfig.rootUrl + 'scripts/app/content/images/water/River.png', label: 'Non-Indexed Water Quality Stations' },
                              { iconName: siteConfig.rootUrl + 'scripts/app/content/images/water/River_Excellent.png', label: 'Indexed Water Quality Stations' }
                    ]
            },
            {
                type: 'feature',
                url: siteConfig.osipMapServer + '32',
                title: 'Lake Water Quality Stations',
                layerOrder: 3,
                options: {
                    id: 'lakeQualityStations',
                    outFields: ['*'],
                    opacity: 1,
                    visible: false
                },
                customModule: new LakeQualityContent(),
                legendIcons: [{ iconName: siteConfig.rootUrl + 'scripts/app/content/images/water/LakeQuality.png', label: 'Lake Water Quality Stations' }]
            }
        ]
    };
});