﻿/*property
    FN_Name, IRES_NAME, TOOLTIP_DIALOG_ID, _hideInfoTemplate,
    _loadFirstNationNames, attributes, closeToolTipDialog, constructor,
    firstNationNames, firstNationNamesFile, forEach, graphic, handleAs, hitch,
    mouseOutHandler, showGraphicTooltip, showToolTipDialog, sync, then, toUrl
*/

define([
    'dojo/_base/declare',
    'dojo/_base/lang',
    'dojo/request/xhr',
    'dojo/_base/array',
    'require', //this is a context-sensitive require   
    './_BaseContent',
    'app/mapping/Utils'
], function (declare, lang, xhr, array, require, _BaseContent, mapUtils) {
    'use strict';
    var _FirstNationContent = declare("FirstNationContent", [_BaseContent], {
        TOOLTIP_DIALOG_ID: "firstNationsTooltipDialog",
        _hideInfoTemplate: true,
        firstNationNamesFile: require.toUrl("./data/firstnation-names.json"),
        firstNationNames: null,
        constructor: function (ignore) {
            if (this.firstNationNames === null) {
                //load names from json file
                this._loadFirstNationNames();
            }
        },       

        // show tooltip
        showGraphicTooltip: function (event) {
            var toolTipContent = event.graphic.attributes.IRES_NAME;
            if (this.firstNationNames !== null) {
                array.forEach(this.firstNationNames, lang.hitch(this, function (item, ignore) {

                    if (event.graphic.attributes.IRES_NAME === item.IRES_NAME )
                    {
                        toolTipContent += "<br/>"  + item.FN_Name;
                        return;
                    }
                }));
            }

            mapUtils.showToolTipDialog(event, this.TOOLTIP_DIALOG_ID, toolTipContent);
        },

        mouseOutHandler: function () {
            mapUtils.closeToolTipDialog(this.TOOLTIP_DIALOG_ID);
        },

        // load First Nation Names
        _loadFirstNationNames: function () {
            xhr(this.firstNationNamesFile, {
                sync: false,
                handleAs: "json"
            }).then(lang.hitch(this, function (data) {
                this.firstNationNames = data.firstNationNames;
            }));
        }

    });

    return _FirstNationContent;
});