﻿/*property
    SETTLE_NAME, STYLE_SOLID, TOOLTIP_DIALOG_ID, _hideInfoTemplate, attributes,
    closeToolTipDialog, constructor, firstNationNames, getDefinitionExpression,
    getRenderer, graphic, indexOf, mouseOutHandler, showGraphicTooltip,
    showToolTipDialog, substr, symbol, type
*/
define([
    'dojo/_base/declare',
    'dojo/_base/Color',
    './_BaseContent',
    'esri/symbols/SimpleLineSymbol',
    'esri/symbols/SimpleFillSymbol',
    'esri/renderers/SimpleRenderer',
    'app/mapping/Utils'    
], function (declare, Color, _BaseContent, SimpleLineSymbol, SimpleFillSymbol, SimpleRenderer, mapUtils) {
    'use strict';
    var _FirstNationCooperativesContent = declare("FirstNationCooperativesContent", [_BaseContent], {
        TOOLTIP_DIALOG_ID: "firstNationsCooperativeTooltipDialog",
        _hideInfoTemplate: true,
        firstNationNames: null,        
        
        getRenderer: function()
        {
            var defaultSymbol = new SimpleFillSymbol(SimpleFillSymbol.STYLE_SOLID,
                                new SimpleLineSymbol(SimpleLineSymbol.STYLE_SOLID, new Color([99, 102, 106]), 2), new Color([188, 190, 196, 0.6]));

            return new SimpleRenderer({ type: 'simple', symbol: defaultSymbol });
        },

        // display only these settlement codes
        getDefinitionExpression: function () {
            //Grande Cache Lake Settlement
            //Joachim Settlement
            //Muskeeg-Seepee Settlement
            //Susa Creek Settlement 
            //Victor Lake Settlement
            //Wanyandie Flats East Settlement
            //Wanyandie Flats West Settlement

            return 'SETTLE_CODE in (30013, 30014, 30017, 30028, 30041,30043, 30046, 30047)';
        },

        // show tooltip
        showGraphicTooltip: function (event) {
            var settlementName = event.graphic.attributes.SETTLE_NAME;
            if (settlementName.indexOf('Settlement') > -1)
            {
                settlementName = settlementName.substr(0, settlementName.indexOf('Settlement'));
            }
            mapUtils.showToolTipDialog(event, this.TOOLTIP_DIALOG_ID, settlementName + '<br/> Aseniwuche Winewak Nation');
        },

        mouseOutHandler: function () {
            mapUtils.closeToolTipDialog(this.TOOLTIP_DIALOG_ID);
        }
        

    });

    return _FirstNationCooperativesContent;
});