﻿/*property
    AERLinks, ApiId, AverageInSituBrackishWaterPerBarrelBitumen,
    AverageInSituBrackishWaterPerBarrelBitumenYear,
    AverageInSituFreshWaterPerBarrelBitumen,
    AverageInSituFreshWaterPerBarrelBitumenYear,
    AverageMineFreshWaterPerBarrelCrude,
    AverageMineFreshWaterPerBarrelCrudeYear,
    AverageUpgraderFreshWaterPerBarrelCrude,
    AverageUpgraderFreshWaterPerBarrelCrudeYear, Barrels, Cleared,
    CompleteEIALinks, ConfidentialityExpiryDate, CurrentProductionYear,
    DataYearDisplay, Disturbed, DocumentLink, EPEAApprovalLinks,
    EmissionsIntensityKilogramsPerBarrelDisplay, EmissionsPerformanceCredits,
    EmissionsPerformanceCreditsDisplay, EmissionsReportingStatus, FEANLinks,
    FullNumber, getProjectStatuses, Id, IndustryType, Industry_Type,
    InprogressEIALinks, IsCoGen, IsInSitu, IsSGRR, LandReclamationValue,
    Latitude, Longitude, NPRILinks, Name, Operator_Name, OSP_NO, OperatorName,
    PhaseStatuses, PowerCompanyDisplay, ProductionType, ProjectDisplay,
    ProjectDisplayName, ProjectId, ProjectIdentifier, ProjectMessage,
    ProjectSpecificURL, Project_Name, Project_Status, Reclaimed,
    RequiredReductionDisplay, SGERIDs, SGRRIDs, SecurityFundGroupProjects,
    SecurityWithheld, SecurityWithheldYear, SharedDataProjectNames, Status,
    StatusGroup, TOOLTIP_DIALOG_ID, TonnesGHGFromBitumenCrudeOilDisplay,
    TonnesGHGFromCoGenerationDisplay, TonnesTotalGHGDisplay, Type,
    WaterActApprovalLinks, WaterActLicenseLinks, WaterQualityValue, Website,
    Year, _convertUnit, _createListOfApprovalLinks, _createProjectGraphic,
    _getAirInfoWindowContent, _getEmissionsInfoWindowContent,
    _getEmissionsIntensityInfo, _getEnforcementTypesByOperator,
    _getInfoWindowContent, _getInfoWindowTabs, _getInfoWindowTitle,
    _getLandInfoWindowContent, _getProjectData, _getProjectIds,
    _getProjectInfoWindowContent, _getProjectSymbol,
    _getWaterInfoWindowContent, _productionBarrelsToCubicMeters,
    _productionFormatBarrels, _toggleLandInfoUnitsDisplayed, add, _addGraphics,
    addValue, angle, attributes, byId, class, closeToolTipDialog, constructor,
    contentType, createInfoWindowSection, dataUrl, display, forEach, format,
    geographicToWebMercator, get, _createDefinitionExpression, 
    _createRenderer, glossaryUrl, graphic, handleAs,
    headers, height, hideSpinner, hitch, icon, indexOf,
    infoWindowHandlerContent, infoWindowHandlerTitle, label, lastIndexOf, length,
    libraryUrl, log, mouseOutHandler, newProjects, oilSandsContent, options,
    places, projectIconsPath, projectIds, projectInfoData, projectStatusGroup,
    projectsData, push, replace, round, rounds, selectedIndex,
    showGraphicTooltip, showToolTipDialog, some, split, style, substring,
    symbol, sync, then, toLowerCase, toUrl, type, url, value, width, xoffset,
    yoffset, create, initInfoWindowModal, dialogueId, style, link, 
    createInfoWindowAnchor, parentNode, pos, href, innerHTML, infoGlyphSign, className, onclickFunc, dataToggle, roleName, newWindowGlyphSign,
    targetName, createGlossaryAnchor, id, _createInfoWindowTab, infoWindowPopupId, infoWindowMessagePopupId, messageDialogueId, message, dialogueTitle,
    onchange, layer, isHistoricalLayer, _addDataToLayer, performTasksAfterLayerCreated, setRenderer, setDefinitionExpression,
    subscribe, remove, enforcementTypes, projectsEmission, projectStatuesHandler, getProjectsInfo,
    projectsInfoHandler, getEnforcementTypes, enforcementTypesHandler, getProjectsEmission, projectsEmissionHandler,
    _getProjectInfoData, _getEnforcementType, accountableParty, _getProjectEmission, hasClassification, visibilityChangeHandler,
    layerVisible, isDataAddedToLayer, show, mapControl, hide, visible, mapServerUrl
*/
define([
    'dojo/_base/declare',
    'require', //this is a context-sensitive require
    'dojo/_base/lang',
    'dojo/_base/array',
    'dojo/dom',
    'dojo/number',
    'dojo/query',
    'dojo/Deferred',
    'dojo/DeferredList',
    'dojo/dom-construct',
    'dojo/topic',
    './_BaseContent',
    'esri/symbols/PictureMarkerSymbol',
    'esri/renderers/UniqueValueRenderer',
    'esri/geometry/webMercatorUtils',
    'esri/geometry/Point',
    'esri/graphic',
    'app/content/WebServiceData',
    'app/mapping/Utils',
    'app/utils/Common',
    'dojo-bootstrap/Tab'
], function (declare, require, lang, array, dom, number, query, Deferred, DeferredList, domConstruct, topic, _BaseContent,
    PictureMarkerSymbol, UniqueValueRenderer, webMercatorUtils, Point,
    Graphic, WebServiceData, mapUtils, commonUtils) {
        'use strict';
        var _OilSandsContent = declare("OilSandsContent",
            [_BaseContent],
            {
                dataUrl: '',
                libraryUrl: '',
                projectsData: null,
                projectInfoData: null,
                enforcementTypes: null,
                projectsEmission: null,
                projectIconsPath: require.toUrl("./images/projects"),
                TOOLTIP_DIALOG_ID: "oilSandsTooltipDialog",
                landTotalHectares: null,
                clearedHectares: 0,
                reclaimedHectares: 0,
                disturbedHectares: 0,
                landClearedYear: null,
                constructor: function (options) {
                    this.newProjects = [];
                    this.projectIds = '';
                    this.layer = null;
                    this.layerVisible = false;
                    this.isDataAddedToLayer = false;
                    this.landTotalHectares = ((options && options.landTotalHectares) ? options.landTotalHectares : null);
                    this.dataUrl = ((options && options.dataUrl) ? options.dataUrl : siteConfig.dataUrl);
                    this.libraryUrl = ((options && options.libraryUrl) ? options.libraryUrl : siteConfig.libraryUrl);
                    this.isHistoricalLayer = ((options && options.isHistoricalLayer) ? options.isHistoricalLayer : false);
                    this.projectStatusGroup = ((options && options.projectStatusGroup) ? options.projectStatusGroup : ['OilSandsMine-Active', 'InSitu-Active', 'Upgrader-Active',
                        'OilSandsMine-IU-Active', 'InSitu-IU-Active', 'OilSandsMine-Approved', 'InSitu-Approved', 'Upgrader-Approved', 'OilSandsMine-IU-Approved',
                        'InSitu-IU-Approved', 'InSitu-Proposed', 'InSitu-IU-Proposed', 'OilSandsMine-Proposed', 'OilSandsMine-IU-Proposed', 'Upgrader-Proposed',
                        'Upgrader-IU-Proposed', 'InSitu-Inactive', 'InSitu-IU-Inactive', 'OilSandsMine-Inactive', 'OilSandsMine-IU-Inactive', 'Upgrader-Inactive',
                        'Upgrader-IU-Inactive']);

                    this.projectStatuesHandler = topic.subscribe("getProjectStatuses/DataIsReady", lang.hitch(this, function (data) {
                        this.projectStatuesHandler.remove();
                        this.projectsData = data;
                        this._getProjectIds();

                        if (this.layer) { // layer is ready
                            this._addDataToLayer();
                        }
                    }));
                    WebServiceData.getProjectStatuses();

                    this.projectsInfoHandler = topic.subscribe("getProjectsInfo/DataIsReady", lang.hitch(this, function (data) {
                        this.projectsInfoHandler.remove();
                        this.projectInfoData = data;
                    }));
                    WebServiceData.getProjectsInfo();

                    this.enforcementTypesHandler = topic.subscribe("getEnforcementTypes/DataIsReady", lang.hitch(this, function (data) {
                        this.enforcementTypesHandler.remove();
                        this.enforcementTypes = data;
                    }));
                    WebServiceData.getEnforcementTypes();

                    this.projectsEmissionHandler = topic.subscribe("getProjectsEmission/DataIsReady", lang.hitch(this, function (data) {
                        this.projectsEmissionHandler.remove();
                        this.projectsEmission = data;
                    }));
                    WebServiceData.getProjectsEmission();
                },

                performTasksAfterLayerCreated: function (layer) {
                    this.layer = layer;

                    if (this.projectsData) { // data is ready
                        this._addDataToLayer();
                    }
                },

                _addDataToLayer: function () {
                    this.layer.setRenderer(this._createRenderer());
                    this.layer.setDefinitionExpression(this._createDefinitionExpression());
                    if (!this.isHistoricalLayer) { // only add new projects when it's not a historical layer
                        this._addGraphics(this.layer);
                    }
                    this.isDataAddedToLayer = true;
                    if (this.layerVisible) {
                        this.layer.show();
                    }
                },

                // assign project icon based on status group
                _createRenderer: function () {
                    var i,
                        projectSymbol,
                        defaultProjectSymbol = new PictureMarkerSymbol({
                            angle: 0,
                            xoffset: 0,
                            yoffset: 0,
                            type: "esriPMS",
                            url: this.projectIconsPath + '/esriBusinessMarker_68_White.png',
                            contentType: "image/png",
                            width: 15,
                            height: 13
                        }),
                        oilSandsProjectsRenderer = new UniqueValueRenderer(defaultProjectSymbol, "OSP_NO");

                    for (i = 0; i < this.projectsData.length; i += 1) {
                        if (this.projectStatusGroup.indexOf(this.projectsData[i].StatusGroup) > -1) {
                            // get project icon and label
                            projectSymbol = this._getProjectSymbol(this.projectsData[i].StatusGroup);

                            if (projectSymbol !== null) {
                                oilSandsProjectsRenderer.addValue({ value: this.projectsData[i].Id, symbol: projectSymbol[0].icon, label: projectSymbol[0].label });
                            }
                        }
                    }
                    return oilSandsProjectsRenderer;
                },

                // get project id's to filter from layer
                _createDefinitionExpression: function () {
                    var selectProjectIds = this.projectIds;

                    if (this.projectIds.lastIndexOf(',') === this.projectIds.length - 1) {
                        selectProjectIds = this.projectIds.substring(0, this.projectIds.lastIndexOf(','));
                    }
                    return 'OSP_NO in (' + selectProjectIds + ')';
                },

                // add additional project icons (new projects that are not available in layer)
                _addGraphics: function (layer) {
                    array.forEach(this.newProjects, lang.hitch(this, function (item) {
                        if (this.projectStatusGroup.indexOf(item.StatusGroup) > -1) {
                            var feature = this._createProjectGraphic(item);
                            layer.add(feature);
                        }
                    }));
                },

                // show tooltip
                showGraphicTooltip: function (event) {
                    var tipText, project;
                    this.clearedHectares = 0;
                    this.reclaimedHectares = 0;
                    this.disturbedHectares = 0;
                    this.landClearedYear = null;

                    // get land data for in-situ projects
                    if (event.graphic.attributes.hasOwnProperty("Industry_Type")) {
                        if (event.graphic.attributes.Industry_Type === "02" || event.graphic.attributes.Industry_Type === "03") {
                            this._getInSituLandData(event.graphic.attributes.OSP_NO);
                        }
                    }

                    if (event.graphic.attributes.ApiId) {
                        tipText = event.graphic.attributes.Operator_Name + ' - ' + event.graphic.attributes.Project_Name;
                    } else {
                        project = this._getProjectData(event.graphic.attributes.OSP_NO);
                        tipText = project.OperatorName + ' - ' + project.ProjectDisplayName;
                    }

                    mapUtils.showToolTipDialog(event, this.TOOLTIP_DIALOG_ID, tipText);
                },

                // hide tooltip
                mouseOutHandler: function () {
                    mapUtils.closeToolTipDialog(this.TOOLTIP_DIALOG_ID);
                },

                visibilityChangeHandler: function (visible) {
                    this.layerVisible = visible;
                    if (visible && !this.isDataAddedToLayer) {
                        this.layer.visible = false; // shouldn't use hide() since it will trigger this handler again
                    }
                },

                // set info-window title
                infoWindowHandlerTitle: function (graphic) {
                    var apiId, project;

                    if (graphic.attributes.ApiId === undefined) {
                        project = this._getProjectData(graphic.attributes.OSP_NO);
                        apiId = project.ApiId;
                    } else {
                        apiId = graphic.attributes.ApiId;
                    }

                    return this._getInfoWindowTitle(apiId);
                },

                // set info-window content
                infoWindowHandlerContent: function (graphic) {
                    var content, apiId, project, operatorName;

                    if (graphic.attributes.ApiId === undefined) {
                        project = this._getProjectData(graphic.attributes.OSP_NO);
                        apiId = project.ApiId;
                        operatorName = project.OperatorName;
                    } else {
                        apiId = graphic.attributes.ApiId;
                        operatorName = graphic.attributes.Operator_Name;
                    }

                    content = this._getInfoWindowContent(apiId, operatorName);
                    this.hideSpinner();
                    return content;
                },

                // get project info from 'projectsData'
                _getProjectData: function (OilSandsProjectId) {
                    var project = null;
                    //using array.some prevents the loop from continuing after a match has been found.
                    array.some(this.projectsData, function (item) {
                        //console.log(item.ApiId + ": " + item.OperatorName + " " + item.ProjectDisplayName + " ID: " + item.Id);
                        if (item.Id === OilSandsProjectId) {
                            //console.info("MATCH: " + item.ApiId + ": " + item.OperatorName + " " + item.ProjectDisplayName + " ID: " + item.Id);
                            project = item;
                            return true;
                        }
                    });
                    return project;
                },

                _getProjectInfoData: function (OilSandsProjectId) {
                    var project = null;
                    array.some(this.projectInfoData, function (item) {
                        if (item.ProjectId === OilSandsProjectId) {
                            project = item;
                            return true;
                        }
                    });
                    return project;
                },

                _getEnforcementType: function (operatorName) {
                    var enforcementType = null;
                    array.some(this.enforcementTypes, function (item) {
                        if (item.accountableParty.toLowerCase().indexOf(operatorName.toLowerCase()) > -1) {
                            enforcementType = item;
                            return true;
                        }
                    });
                    return enforcementType;
                },

                _getProjectEmission: function (OilSandsProjectId) {
                    var projectEmission = null;
                    array.some(this.projectsEmission, function (item) {
                        if (item.ProjectId === OilSandsProjectId) {
                            projectEmission = item;
                            return true;
                        }
                    });
                    return projectEmission;
                },

                // create graphic point with symbol and attributes
                _createProjectGraphic: function (projectStatusData) {
                    var point = webMercatorUtils.geographicToWebMercator(new Point(projectStatusData.Longitude, projectStatusData.Latitude)),
                        projectSymbol = this._getProjectSymbol(projectStatusData.StatusGroup),
                        attributes = {
                            ApiId: projectStatusData.ApiId,
                            OSP_NO: "",
                            Operator_Name: projectStatusData.OperatorName,
                            Project_Name: projectStatusData.ProjectDisplayName,
                            Industry_Type: projectStatusData.IndustryType,
                            Project_Status: projectStatusData.Status
                        };
                    return new Graphic(point, projectSymbol[0].icon, attributes);
                },

                // get project icon and label based on project status group
                _getProjectSymbol: function (statusGroup) {

                    switch (statusGroup) {
                        case "OilSandsMine-Active":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/Mine.png', 20, 18)), label: 'Operating Oil Sands Mines' }];
                        case "InSitu-Active":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/InSitu.png', 18, 15)), label: "Operating In Situ Facilities" }];
                        case "Upgrader-Active":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/Upgrader.png', 20, 18)), label: "Operating Stand Alone Upgraders" }];
                        case "OilSandsMine-IU-Active":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/Mine_IU.png', 20, 18)), label: "Operating Oil Sands Mines" }];
                        case "InSitu-IU-Active":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/InSitu_IU.png', 18, 15)), label: "Operating In Situ Facilities" }];
                        case "OilSandsMine-Approved":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/Mine_Grey.png', 20, 18)), label: "Approved Oil Sands Mines" }];
                        case "InSitu-Approved":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/InSitu_Grey.png', 18, 15)), label: "Approved In Situ Facilities" }];
                        case "Upgrader-Approved":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/Upgrader_Grey.png', 20, 18)), label: "Approved Stand Alone Upgraders" }];
                        case "OilSandsMine-IU-Approved":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/Mine_IU_Grey.png', 20, 18)), label: "Approved Oil Sands Mines" }];
                        case "InSitu-IU-Approved":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/InSitu_IU_Grey.png', 18, 15)), label: "Approved In Situ Facilities" }];
                        case "InSitu-Proposed":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/InSitu_Orange.png', 18, 15)), label: "Proposed In Situ Facilities" }];
                        case "InSitu-IU-Proposed":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/InSitu_IU_Orange.png', 18, 15)), label: "Proposed In Situ Facilities" }];
                        case "OilSandsMine-Proposed":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/Mine_Orange.png', 20, 18)), label: "Proposed Oil Sands Mine" }];
                        case "OilSandsMine-IU-Proposed":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/Mine_IU_Orange.png', 20, 18)), label: "Proposed Oil Sands Mine" }];
                        case "Upgrader-Proposed":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/Upgrader_Orange.png', 20, 18)), label: "Proposed Stand Alone Upgraders" }];
                        case "Upgrader-IU-Proposed":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/Upgrader_IU_Orange.png', 20, 18)), label: "Proposed Stand Alone Upgraders" }];
                        case "InSitu-Inactive":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/InSitu_Red.png', 18, 15)), label: "Inactive In Situ Facilities" }];
                        case "InSitu-IU-Inactive":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/InSitu_IU_Red.png', 18, 15)), label: "Inactive In Situ Facilities" }];
                        case "OilSandsMine-Inactive":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/Mine_Red.png', 20, 18)), label: "Inactive Oil Sands Mine" }];
                        case "OilSandsMine-IU-Inactive":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/Mine_IU_Red.png', 20, 18)), label: "Inactive Oil Sands Mine" }];
                        case "Upgrader-Inactive":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/Upgrader_Red.png', 20, 18)), label: "Inactive Stand Alone Upgraders" }];
                        case "Upgrader-IU-Inactive":
                            return [{ icon: new PictureMarkerSymbol(new PictureMarkerSymbol(this.projectIconsPath + '/Upgrader_IU_Red.png', 20, 18)), label: "Inactive Stand Alone Upgraders" }];
                        default:
                            console.log("status not available " + statusGroup);
                            return null;
                    }
                },

                // get info-window content
                _getInfoWindowContent: function (projectId, operatorName) {
                    var contentNode = domConstruct.create("div", {}, null),
                        tabContent = null, tabPane = null,
                        project = this._getProjectInfoData(projectId),
                        enforcement = this._getEnforcementType(operatorName),
                        emission = this._getProjectEmission(projectId);

                    // get tabs
                    this._getInfoWindowTabs(contentNode, project, emission);

                    // set tab content
                    tabContent = domConstruct.create('div', { id: 'tabContent', 'class': 'tab-content' }, contentNode, 'last');

                    // get project content
                    tabPane = domConstruct.create('div', { id: 'project', 'class': 'tab-pane fade in active' }, tabContent, 'last');
                    this._getProjectInfoWindowContent(tabPane, project, enforcement);

                    // get emissions content
                    if ((emission.SGERIDs.length > 0 || emission.SGRRIDs.length > 0) && emission.TonnesTotalGHGDisplay !== 'XX') {
                        tabPane = domConstruct.create('div', { id: 'emissions', 'class': 'tab-pane fade' }, tabContent, 'last');
                        this._getEmissionsInfoWindowContent(tabPane, emission);
                    }

                    // get water content
                    if (project.WaterQualityValue) {
                        tabPane = domConstruct.create('div', { id: 'water', 'class': 'tab-pane fade' }, tabContent, 'last');
                        this._getWaterInfoWindowContent(tabPane, project);
                    }

                    // get air content
                    if (project.NPRILinks.length > 0) {
                        tabPane = domConstruct.create('div', { id: 'air', 'class': 'tab-pane fade' }, tabContent, 'last');
                        this._getAirInfoWindowContent(tabPane, project);
                    }

                    // get land content
                    if (project.IsInSitu || project.LandReclamationValue.Year > 0) {
                        tabPane = domConstruct.create('div', { id: 'land', 'class': 'tab-pane fade' }, tabContent, 'last');
                        this._getLandInfoWindowContent(tabPane, project);
                    }


                    return contentNode;
                },

                _createInfoWindowTab: function (parentNode, href, innerHtml, isActive) {
                    var liNode = null;
                    if (isActive) {
                        liNode = domConstruct.create("li", { 'class': "active" }, parentNode, "last");
                    } else {
                        liNode = domConstruct.create("li", {}, parentNode, "last");
                    }

                    this.createInfoWindowAnchor({
                        parentNode: liNode,
                        pos: "last",
                        href: href,
                        innerHTML: innerHtml,
                        className: "infoWindowTab",
                        dataToggle: "tab"
                    });
                },

                // get inforwindow tabs bases on data
                _getInfoWindowTabs: function (parentNode, project, emission) {
                    var tabNode = domConstruct.create("ul", { 'class': "nav nav-tabs" }, parentNode, "last");
                    this._createInfoWindowTab(tabNode, "#project", "Project", true);

                    // add emissions tab when emissions data is available
                    if ((emission.SGERIDs.length > 0 || emission.SGRRIDs.length > 0) && emission.TonnesTotalGHGDisplay !== 'XX') {
                        this._createInfoWindowTab(tabNode, "#emissions", "GHG Emissions");
                    }

                    // add water tab when water data is available
                    if (project.WaterQualityValue) {
                        this._createInfoWindowTab(tabNode, "#water", "Water");
                    }

                    // add air tab when water data is available
                    if (project.NPRILinks.length > 0) {
                        this._createInfoWindowTab(tabNode, "#air", "Air");
                    }

                    // add land tab when land data is available or if the project industry type is In-Situ
                    if (project.IsInSitu || project.LandReclamationValue.Year > 0) {
                        this._createInfoWindowTab(tabNode, "#land", "Land");
                    }

                    return tabNode;
                },

                // get land data from layer (Layer: RISOilSands.GDB.SumOfHectares)
                _getInSituLandData: function (osipNo) {

                    if (this.landTotalHectares !== null) {

                        mapUtils.queryFeatureLayer(lang.hitch(this, this._landData),
                            commonUtils.aewError,
                            siteConfig.osipMapServer + this.landTotalHectares.layerId,
                            null,
                            null,
                            this.landTotalHectares.ospNoField+ "=" + osipNo);
                    }
                },

                _landData: function (data) {
                    for (var i = 0; i < data.features.length; i += 1) {
                        if (data.features[i].attributes.hasOwnProperty(this.landTotalHectares.landCoverField)) {
                            if (data.features[i].attributes[this.landTotalHectares.landCoverField] === "3") // disturbed
                            {
                                this.disturbedHectares = data.features[i].attributes[this.landTotalHectares.hectaresField];
                                // All In-situ projects have disturbed data therefore we take year from the disturbed record
                                this.landClearedYear = data.features[i].attributes[this.landTotalHectares.yearField];
                            }
                            else if (data.features[i].attributes[this.landTotalHectares.landCoverField] === "2") // cleared
                            {
                                this.clearedHectares = data.features[i].attributes[this.landTotalHectares.hectaresField];
                            }
                            else if (data.features[i].attributes[this.landTotalHectares.landCoverField] === "4") // reclaimed
                            {
                                this.reclaimedHectares = data.features[i].attributes[this.landTotalHectares.hectaresField];
                            }
                        }
                    }
                },
                

                // get project infowindow content
                _getProjectInfoWindowContent: function (tabPane, projectData, enforcementsData) {
                    domConstruct.create('div', { innerHTML: '<div class="icon-oilsands dark-grey-txt"></div>', 'class': 'tab-icon' }, tabPane, 'first');

                    var noProduction = "Production data unavailable for the Project.",
                        sectionDiv = null,
                        sectionContent = "",
                        statusList = "",
                        i,
                        prodTypes,
                        disclaimerText = "Enforcement Actions are presented on a company-wide basis. Enforcement Actions listed may include oil sands and non-oil sands related events. <br />",
                        onclickFunc = null;

                    if (projectData.SharedDataProjectNames) {
                        if (projectData.SharedDataProjectNames.length > 0) {
                            sectionContent = "* This project shares some reporting with ";
                            for (i = 0; i < projectData.SharedDataProjectNames.length; i += 1) {
                                sectionContent += projectData.SharedDataProjectNames[i];
                                if (i !== projectData.SharedDataProjectNames.length - 1) {
                                    sectionContent += " and ";
                                }
                            }
                            this.createInfoWindowSection(tabPane, "last", null, sectionContent);
                        }
                    }

                    if (projectData.Status === "Applied") {
                        sectionContent = "The " + projectData.ProjectDisplay + " applications are being reviewed. This project is not producing bitumen/ synthetic crude oil commercially at this time.";
                        this.createInfoWindowSection(tabPane, "last", null, sectionContent);

                        sectionDiv = this.createInfoWindowSection(tabPane, 'last');
                        this.createInfoWindowAnchor({
                            parentNode: sectionDiv,
                            pos: 'last',
                            href: "http://esrd.alberta.ca/lands-forests/land-industrial/programs-and-services/environmental-assessment/current-projects.aspx",
                            innerHTML: this.newWindowGlyphSign + "Application to Alberta Environment and Sustainable Resource Development",
                            targetName: "_blank"
                        });
                    } else if (projectData.Status === "Exploration") {
                        sectionContent = "This project is currently approved by the Alberta Energy Regulator to operate as an experimental, confidential scheme. While this confidentiality is in effect, the project's production, and water and steam use is not released publically.";
                        sectionContent += "This project's confidentiality is due to expire on " + projectData.ConfidentialityExpiryDate + ".";
                        this.createInfoWindowSection(tabPane, "last", null, sectionContent);
                    } else if (projectData.Status === "Withdrawn") {
                        this.createInfoWindowSection(tabPane, "last", null, "This project has been withdrawn by the operator.");
                    } else if (projectData.Status === "Announced") {
                        sectionContent = projectData.OperatorName + " has announced its intention to develop the " + projectData.ProjectDisplay + " project in this location.";
                        this.createInfoWindowSection(tabPane, "last", null, sectionContent);
                    } else if (projectData.Status === "Not active") {
                        this.createInfoWindowSection(tabPane, "last", null, "This project is not currently active.");
                    } else if (projectData.Status === "Closed") {
                        this.createInfoWindowSection(tabPane, "last", null, "This project’s application has been closed.");
                    } else if (projectData.Status === "Denied") {
                        this.createInfoWindowSection(tabPane, "last", null, "This project will not proceed as the application has been denied after reviews by the Alberta Energy Regulator, Alberta Environment and Sustainable Resource Development and/ or the Canadian Environmental Assessment Agency.");
                    }

                    if (projectData.Status === "Active" || projectData.Status === "Approved" || projectData.Status === "Suspended") {

                        for (i = 0; i < projectData.PhaseStatuses.length; i += 1) {
                            statusList += projectData.PhaseStatuses[i] + "<br />";
                        }
                        if (statusList !== "") {
                            this.createInfoWindowSection(tabPane, "last", null, statusList);
                        }

                        // project message
                        if (projectData.ProjectMessage !== '') {
                            this.createInfoWindowSection(tabPane, "last", null, projectData.ProjectMessage);
                        }
                        // company enforcement
                        if (enforcementsData && enforcementsData.hasClassification) {
                            sectionDiv = this.createInfoWindowSection(tabPane, 'last');
                            onclickFunc = lang.hitch(this, function () {
                                this.initInfoWindowModal({
                                    dialogueId: this.infoWindowPopupId,
                                    messageDialogueId: this.infoWindowMessagePopupId,
                                    style: 'modal-content xsm modalContentMax',
                                    link: this.dataUrl + "/projectsLB/getenforcements?cssPage=White.css&companyName=" + projectData.OperatorName,
                                    message: disclaimerText,
                                    dialogueTitle: "Company Enforcement Actions - " + projectData.OperatorName
                                });
                            });

                            this.createInfoWindowAnchor({
                                parentNode: sectionDiv,
                                pos: 'last',
                                href: "#" + this.infoWindowMessagePopupId,
                                innerHTML: this.newWindowGlyphSign + "Company Enforcement Actions",
                                className: "btn-link",
                                onclickFunc: onclickFunc,
                                dataToggle: "modal",
                                roleName: "button"
                            });
                        }
                    }

                    if (projectData.Status === "Active" || projectData.Status === "Approved" || projectData.Status === "Applied" || projectData.Status === "Suspended") {

                        //aer application links
                        if (projectData.AERLinks) {
                            if (projectData.AERLinks.length > 0) {
                                sectionDiv = this.createInfoWindowSection(tabPane, "last");
                                this._createListOfApprovalLinks(sectionDiv, projectData.AERLinks, "Applications to the Alberta Energy Regulator");
                            }
                        }

                        //fean link 
                        if (projectData.FEANLinks) {
                            if (projectData.FEANLinks.length > 0) {
                                sectionDiv = this.createInfoWindowSection(tabPane, 'last');
                                this.createInfoWindowAnchor({
                                    parentNode: sectionDiv,
                                    pos: 'last',
                                    href: projectData.FEANLinks[0].DocumentLink,
                                    innerHTML: this.newWindowGlyphSign + "Federal Environmental Assessment",
                                    targetName: "_blank"
                                });
                            }
                        }

                        //Water Act Approvals
                        if (projectData.WaterActApprovalLinks) {
                            if (projectData.WaterActApprovalLinks.length > 0) {
                                sectionDiv = this.createInfoWindowSection(tabPane, "last");
                                this._createListOfApprovalLinks(sectionDiv, projectData.WaterActApprovalLinks, "Water Act Approvals");
                            }
                        }
                        //Water act license
                        if (projectData.WaterActLicenseLinks) {
                            if (projectData.WaterActLicenseLinks.length > 0) {
                                sectionDiv = this.createInfoWindowSection(tabPane, "last");
                                this._createListOfApprovalLinks(sectionDiv, projectData.WaterActLicenseLinks, "Water Act Licenses");
                            }
                        }

                        //epea links
                        if (projectData.EPEAApprovalLinks) {
                            if (projectData.EPEAApprovalLinks.length > 0) {
                                sectionDiv = this.createInfoWindowSection(tabPane, "last");
                                this._createListOfApprovalLinks(sectionDiv, projectData.EPEAApprovalLinks, "Environmental Protection and Enhancements Act Approvals");
                            }
                        }

                        // completed eia links
                        if (projectData.CompleteEIALinks) {
                            if (projectData.CompleteEIALinks.length > 0) {
                                sectionDiv = this.createInfoWindowSection(tabPane, "last");
                                this._createListOfApprovalLinks(sectionDiv, projectData.CompleteEIALinks, "Completed Environmental Impact Assessments");
                            }
                        }

                        //in-progress eia link (always 1 link)
                        if (projectData.InprogressEIALinks) {
                            if (projectData.InprogressEIALinks.length > 0) {
                                sectionDiv = this.createInfoWindowSection(tabPane, "last");
                                this.createInfoWindowAnchor({
                                    parentNode: sectionDiv,
                                    pos: 'last',
                                    href: projectData.InprogressEIALinks[0].DocumentLink,
                                    innerHTML: this.newWindowGlyphSign + "In Progress Environmental Impact Assessments",
                                    targetName: "_blank"
                                });
                            }
                        }
                    }

                    //show production history graph only for Active projects
                    if (projectData.Status === "Active") {
                        if (projectData.CurrentProductionYear) {
                            if (projectData.CurrentProductionYear > 0) {
                                if (projectData.Barrels > 0) {
                                    sectionContent = this._productionFormatBarrels(projectData.Barrels) + " barrels (" + this._productionBarrelsToCubicMeters(projectData.Barrels) + " m3) of ";
                                    sectionDiv = this.createInfoWindowSection(tabPane, "last", null, sectionContent);

                                    prodTypes = projectData.ProductionType.split(" and/or ");
                                    prodTypes.forEach(lang.hitch(this, function (prodType, i) {
                                        this.createGlossaryAnchor(sectionDiv, 'last', prodType.replace(/\s/g, "_"), prodType.toLowerCase(), false);
                                        if (prodType.length > 0 && i < prodType.length - 1) {
                                            domConstruct.create("span", { innerHTML: " and/or " }, sectionDiv, "last");
                                        }
                                    }));

                                    sectionContent = " were produced by this project in " + projectData.CurrentProductionYear + ".<br />";
                                    domConstruct.create("span", { innerHTML: sectionContent }, sectionDiv, "last");

                                    // set production history chart link
                                    sectionDiv = this.createInfoWindowSection(tabPane, 'last');
                                    onclickFunc = lang.hitch(this, function () {
                                        this.initInfoWindowModal({
                                            dialogueId: this.infoWindowPopupId,
                                            style: 'modal-content sm modalContentSmallCharts',
                                            link: this.libraryUrl + 'DataSet/ChartByNumber?Number=C25&ProjectId=' + projectData.ProjectId
                                        });
                                    });

                                    this.createInfoWindowAnchor({
                                        parentNode: sectionDiv,
                                        pos: 'last',
                                        href: "#" + this.infoWindowPopupId,
                                        innerHTML: this.infoGlyphSign + "View production history graph",
                                        className: "btn-link",
                                        onclickFunc: onclickFunc,
                                        dataToggle: "modal",
                                        roleName: "button"
                                    });
                                } else {
                                    this.createInfoWindowSection(tabPane, "last", null, noProduction);
                                }
                            } else {
                                this.createInfoWindowSection(tabPane, "last", null, noProduction);
                            }
                        } else {
                            this.createInfoWindowSection(tabPane, "last", null, noProduction);
                        }
                    } else if (projectData.Status === "Approved") {
                        this.createInfoWindowSection(tabPane, "last", null, noProduction);
                    }
                    return tabPane;
                },

                // get emissions infowindow content
                _getEmissionsInfoWindowContent: function (tabPane, emissionsData) {
                    domConstruct.create('div', { innerHTML: '<div class="icon-climate-change orange-txt"></div>', 'class': 'tab-icon' }, tabPane, 'first');


                    var sectionContent = null,
                        sectionDiv = null,
                        onclickFunc = null,
                        gasEmittersRegs = 'http://aep.alberta.ca/climate-change/programs-and-services/industrial-emissions-management.aspx', // for bug #388
                        gasReportingRegs = 'http://www.qp.alberta.ca/574.cfm?page=2004_251.cfm&leg_type=Regs&isbncln=9780779748631&display=html';

                    sectionDiv = this.createInfoWindowSection(tabPane, "last");

                    domConstruct.create('div', { innerHTML: "Oil Sands Operator: " + emissionsData.OperatorName }, sectionDiv, 'last');

                    if (emissionsData.IsCoGen) {

                        if (emissionsData.PowerCompanyDisplay) {
                            sectionContent = "Co-Generation Operator: " + emissionsData.PowerCompanyDisplay;
                            domConstruct.create('div', { innerHTML: sectionContent }, sectionDiv, 'last');
                        }

                        if (emissionsData.TonnesGHGFromCoGenerationDisplay !== 'XX') {
                            sectionContent = "<tr><td class='infoWindowNumberCol'>" + emissionsData.TonnesTotalGHGDisplay + "</td><td class='infoWindowDescCol'>tonnes total on-site greenhouse gas emissions (" + emissionsData.DataYearDisplay + ")</td></tr>";
                            sectionContent += "<tr><td class='infoWindowNumberCol'>" + emissionsData.TonnesGHGFromCoGenerationDisplay + "</td><td class='infoWindowDescCol'>tonnes greenhouse gas from on-site co-generation electicity production</td></tr>";
                            sectionContent += "<tr><td class='infoWindowNumberCol'>" + emissionsData.TonnesGHGFromBitumenCrudeOilDisplay + "</td><td class='infoWindowDescCol'>tonnes greenhouse gas from " + emissionsData.ProductionType + " production</td></tr>";

                            domConstruct.create('table', { innerHTML: sectionContent, 'class': 'infoWindowNumberTable' }, sectionDiv, 'last');
                        } else {
                            sectionContent = emissionsData.TonnesTotalGHGDisplay + " tonnes total on-site greenhouse gas emissions (" + emissionsData.DataYearDisplay + ")";
                            domConstruct.create('div', { innerHTML: sectionContent }, sectionDiv, 'last');
                        }
                    } else {
                        sectionContent = emissionsData.TonnesTotalGHGDisplay + " tonnes total on-site greenhouse gas emissions (" + emissionsData.DataYearDisplay + ")";
                        domConstruct.create('div', { innerHTML: sectionContent }, sectionDiv, 'last');
                    }

                    if (emissionsData.EmissionsReportingStatus < 2) {
                        // set emissions history chart link
                        sectionDiv = this.createInfoWindowSection(tabPane, "last");
                        onclickFunc = lang.hitch(this, function () {
                            this.initInfoWindowModal({
                                dialogueId: this.infoWindowPopupId,
                                style: 'modal-content md modalContentMax',
                                link: this.dataUrl + 'ClimateChangeLB/GetGHGGraph?cssPage=White.css&isCogen=1&projectId=' + emissionsData.ProjectId
                            });
                        });

                        this.createInfoWindowAnchor({
                            parentNode: sectionDiv,
                            pos: 'last',
                            href: "#" + this.infoWindowPopupId,
                            innerHTML: this.infoGlyphSign + "View emissions history graph",
                            className: "btn-link",
                            onclickFunc: onclickFunc,
                            dataToggle: "modal",
                            roleName: "button"
                        });
                    }

                    if (emissionsData.EmissionsIntensityKilogramsPerBarrelDisplay !== "XX") {
                        sectionContent = "Emissions intensity = " + emissionsData.EmissionsIntensityKilogramsPerBarrelDisplay + " kg CO2e / barrel of " + emissionsData.ProductionType + " (" + emissionsData.DataYearDisplay + ")<br />";
                        // set ghg emissions history chart link
                        sectionDiv = this.createInfoWindowSection(tabPane, "last", null, sectionContent);
                        sectionDiv = this.createInfoWindowSection(tabPane, "last");
                        onclickFunc = lang.hitch(this, function () {
                            this.initInfoWindowModal({
                                dialogueId: this.infoWindowPopupId,
                                style: 'modal-content md modalContentMax',
                                link: this.libraryUrl + 'DataSet/ChartByNumber?Number=C31&Width=755&Height=545&ProjectId=' + emissionsData.ProjectId
                            });
                        });
                        this.createInfoWindowAnchor({
                            parentNode: sectionDiv,
                            pos: 'last',
                            href: "#" + this.infoWindowPopupId,
                            innerHTML: this.infoGlyphSign + "View the GHG emissions intensity history graph",
                            className: "btn-link",
                            onclickFunc: onclickFunc,
                            dataToggle: "modal",
                            roleName: "button"
                        });
                    } else if (emissionsData.IsSGRR || emissionsData.ProjectId === 16 || emissionsData.ProjectId === 19 || emissionsData.ProjectId === 27) {
                        this.createInfoWindowSection(tabPane, "last", null, "GHG emissions intensity data is unavailable for this Project.");
                    }

                    if (emissionsData.EmissionsReportingStatus === 0) {
                        sectionContent = "This facility was required to submit " + emissionsData.RequiredReductionDisplay + " tonnes of compliance to meet their " + emissionsData.DataYearDisplay;
                        sectionContent += " target for the <a href='" + gasEmittersRegs + "' target='_blank'>Specified Gas Emitters Regulation. This was done through offset retirement, emissions performance credit </a>";
                        sectionContent += "retirement, credit for cogeneration efficiency or fund contribution.</a><br/><br/>SGRR data has been posted up to and including " + emissionsData.DataYearDisplay +" but has been overridden with applicable SGER information if available. Only SGER data current as of 2012 has been used and does not reflect subsequent revisions.";
                        this.createInfoWindowSection(tabPane, "last", null, sectionContent);

                        if (emissionsData.EmissionsPerformanceCredits > 0) {
                            sectionContent = "This facility generated " + emissionsData.EmissionsPerformanceCreditsDisplay + " emissions performance credits beyond their reduction target.";
                            this.createInfoWindowSection(tabPane, "last", null, sectionContent);
                        }

                        if (emissionsData.ProjectIdentifier === 16 || emissionsData.ProjectIdentifier === 19 || emissionsData.ProjectIdentifier === 27) {
                            this.createInfoWindowSection(tabPane, "last", null, "Compliance History data is unavailable for this Project.");
                        } else {
                            // set Compliance history chart link
                            sectionDiv = this.createInfoWindowSection(tabPane, "last");
                            onclickFunc = lang.hitch(this, function () {
                                this.initInfoWindowModal({
                                    dialogueId: this.infoWindowPopupId,
                                    style: 'modal-content md modalContentMax',
                                    link: this.dataUrl + 'ClimateChangeLB/GetComplianceHistoryGraph?cssPage=White.css&projectId=' + emissionsData.ProjectId
                                });
                            });
                            this.createInfoWindowAnchor({
                                parentNode: sectionDiv,
                                pos: 'last',
                                href: "#" + this.infoWindowPopupId,
                                innerHTML: this.infoGlyphSign + "View Compliance History Graph",
                                className: "btn-link",
                                onclickFunc: onclickFunc,
                                dataToggle: "modal",
                                roleName: "button"
                            });
                        }
                    } else if (emissionsData.EmissionsReportingStatus === 1) {
                        sectionContent = "This facility is reporting its emissions under the <a href=\'" + gasReportingRegs + "' target='_blank'>Specified Gas Reporting Regulation</a>. There is no reduction target set for this facility.</a>";
                        this.createInfoWindowSection(tabPane, "last", null, sectionContent);
                    }
                    // link to DL
                    sectionDiv = this.createInfoWindowSection(tabPane, 'last');
                    this.createInfoWindowAnchor({
                        parentNode: sectionDiv,
                        pos: 'last',
                        href: this.libraryUrl + "Browser#Category=CLCNG",
                        innerHTML: this.newWindowGlyphSign + "More data on greenhouse gas emissions",
                        targetName: "_blank"
                    });

                    return tabPane;
                },

                // get water infowindow content
                _getWaterInfoWindowContent: function (tabPane, projectData) {
                    var sectionDiv = null, onclickFunc = null, createChartLink = false;

                    domConstruct.create('div', { innerHTML: '<div class="icon-water dark-blue-txt"></div>', 'class': 'tab-icon' }, tabPane, 'first');

                    //show water use history link if there is water use
                    switch (projectData.Type) {
                        case "Oil Sands Mine":
                        case "Oil Sands Mine, Upgrader":
                            if (projectData.WaterQualityValue.AverageMineFreshWaterPerBarrelCrude > 0) {
                                this.createInfoWindowSection(tabPane, "last", null, projectData.WaterQualityValue.AverageMineFreshWaterPerBarrelCrude + " barrels of Fresh Water / Barrel " + projectData.ProductionType + " (" + projectData.WaterQualityValue.AverageMineFreshWaterPerBarrelCrudeYear + ")");
                                createChartLink = true;
                            } else {
                                this.createInfoWindowSection(tabPane, 'last', null, "Water use data unavailable for this Project.");
                            }
                            break;
                        case "In Situ":
                            if (projectData.WaterQualityValue.AverageInSituFreshWaterPerBarrelBitumen > 0 || projectData.WaterQualityValue.AverageInSituBrackishWaterPerBarrelBitumen > 0) {
                                this.createInfoWindowSection(tabPane, "last", null, projectData.WaterQualityValue.AverageInSituFreshWaterPerBarrelBitumen + " barrels of Fresh Water / Barrel " + projectData.ProductionType + " (" + projectData.WaterQualityValue.AverageInSituFreshWaterPerBarrelBitumenYear + ")");
                                this.createInfoWindowSection(tabPane, "last", null, projectData.WaterQualityValue.AverageInSituBrackishWaterPerBarrelBitumen + " barrels of Brackish Water / Barrel " + projectData.ProductionType + " (" + projectData.WaterQualityValue.AverageInSituBrackishWaterPerBarrelBitumenYear + ")");
                                createChartLink = true;
                            } else {
                                this.createInfoWindowSection(tabPane, 'last', null, "Water use data unavailable for this Project.");
                            }
                            break;
                        case "Upgrader":
                            if (projectData.WaterQualityValue.AverageUpgraderFreshWaterPerBarrelCrude > 0) {
                                this.createInfoWindowSection(tabPane, "last", null, projectData.WaterQualityValue.AverageUpgraderFreshWaterPerBarrelCrude + " barrels of Fresh Water / Barrel " + projectData.ProductionType + " (" + projectData.WaterQualityValue.AverageUpgraderFreshWaterPerBarrelCrudeYear + ")");
                                createChartLink = true;
                            } else {
                                this.createInfoWindowSection(tabPane, 'last', null, "Water use data unavailable for this Project.");
                            }
                            break;
                    }

                    if (createChartLink) {
                        // set water history chart link
                        sectionDiv = this.createInfoWindowSection(tabPane, 'last');
                        onclickFunc = lang.hitch(this, function () {
                            this.initInfoWindowModal({
                                dialogueId: this.infoWindowPopupId,
                                style: 'modal-content md modalContentMediumCharts',
                                link: this.libraryUrl + 'DataSet/ChartByNumber?Number=C4&ProjectId=' + projectData.ProjectId
                            });
                        });
                        this.createInfoWindowAnchor({
                            parentNode: sectionDiv,
                            pos: 'last',
                            href: "#" + this.infoWindowPopupId,
                            innerHTML: this.infoGlyphSign + "View Water Use History",
                            className: "btn-link",
                            onclickFunc: onclickFunc,
                            dataToggle: "modal",
                            roleName: "button"
                        });
                    }

                    // link to DL
                    sectionDiv = this.createInfoWindowSection(tabPane, 'last');
                    this.createInfoWindowAnchor({
                        parentNode: sectionDiv,
                        pos: 'last',
                        href: this.libraryUrl + "Browser#Category=WATER&Page=1&Sort=Title",
                        innerHTML: this.newWindowGlyphSign + "More data on water use",
                        targetName: "_blank"
                    });

                    return tabPane;
                },

                // get air infowindow content
                _getAirInfoWindowContent: function (tabPane, projectData) {
                    domConstruct.create('div', { innerHTML: '<div class="icon-air blue-txt"></div>', 'class': 'tab-icon' }, tabPane, 'first');
                    var sectionDiv = this.createInfoWindowSection(tabPane, 'last');
                    this._createListOfApprovalLinks(sectionDiv, projectData.NPRILinks, "National Pollutant Release Inventory", "canadaflag_icon");

                    // link to DL
                    sectionDiv = this.createInfoWindowSection(tabPane, 'last');
                    this.createInfoWindowAnchor({
                        parentNode: sectionDiv,
                        pos: 'last',
                        href: this.libraryUrl + "Browser#Category=AIR",
                        innerHTML: this.newWindowGlyphSign + "More data on Air",
                        targetName: "_blank"
                    });

                    return tabPane;
                },

                // get land infowindow content
                _getLandInfoWindowContent: function (tabPane, projectData) {
                    var year = "", cleared = "", disturbed = "", reclaimed = "", withheld = "", withheldYear = "",
                        unitsFlag = false, unitAbbr, options = ["Km2", "Hectares", "Acres", "Mi2"], historicalYear = false, n,
                        sectionDiv = null, onclickFunc = null;

                    domConstruct.create('div', { innerHTML: '<div class="icon-land dark-green-txt"></div>', 'class': 'tab-icon' }, tabPane, 'first');

                    query('[data-layer-name="landHistory"]').forEach(function (node) {
                        if (node) {
                            if (node.attributes['class'].value.indexOf('active') > -1) {
                                historicalYear = true;
                                return false;
                            }
                        }
                    });

                    if (historicalYear !== true) {
                        for (n = 0; n < options.length; n += 1) {
                            unitAbbr = options[n];

                            if (unitAbbr === "Km2") {
                                sectionDiv = domConstruct.create('div', { id: 'divLandUnitOption' + unitAbbr }, tabPane, 'last'); //default view is Km2
                            } else {
                                sectionDiv = domConstruct.create('div', { id: 'divLandUnitOption' + unitAbbr, style: 'display:none' }, tabPane, 'last'); //hide these views until requested by the drop down
                            }

                            if (projectData.LandReclamationValue.Cleared || this.clearedHectares > 0) {
                                cleared = this._convertUnit(projectData.LandReclamationValue.Cleared !== null ? projectData.LandReclamationValue.Cleared : this.clearedHectares, "Hectares", unitAbbr) + " " + unitAbbr + " of land has been cleared by this project.<br />";
                                unitsFlag = true;
                            }

                            if (projectData.LandReclamationValue.Disturbed || this.disturbedHectares > 0) {
                                disturbed = this._convertUnit(projectData.LandReclamationValue.Disturbed !== null ? projectData.LandReclamationValue.Disturbed : this.disturbedHectares, "Hectares", unitAbbr) + " " + unitAbbr + " of land is disturbed by this project.<br />";
                                unitsFlag = true;
                            }

                            if (projectData.LandReclamationValue.Reclaimed || this.reclaimedHectares > 0) {
                                reclaimed = this._convertUnit(projectData.LandReclamationValue.Reclaimed !== null ? projectData.LandReclamationValue.Reclaimed : this.reclaimedHectares, "Hectares", unitAbbr) + " " + unitAbbr + " of disturbed land has been reclaimed by this project.<br />";
                                unitsFlag = true;
                            }

                            if (projectData.LandReclamationValue.SecurityWithheld) {
                                if (projectData.LandReclamationValue.SecurityWithheldYear) {
                                    withheldYear = projectData.LandReclamationValue.SecurityWithheldYear;
                                }
                                withheld = "In " + withheldYear + ", $" + projectData.LandReclamationValue.SecurityWithheld + " million was provided by " + projectData.OperatorName + " for " + projectData.LandReclamationValue.SecurityFundGroupProjects + " to the government for the Reclamation Securities Fund.";
                            }

                            if (projectData.LandReclamationValue.Year !== 0 || this.landClearedYear !== null) {
                                year = "(" + (projectData.LandReclamationValue.Year !== 0 ? projectData.LandReclamationValue.Year : this.landClearedYear) + ")";
                            }

                            if (cleared !== "" || disturbed !== "" || reclaimed !== "" || withheld !== "") {
                                domConstruct.create('div', { 'class': 'landReclamationTitle', innerHTML: projectData.LandReclamationValue.Name !== null ? projectData.LandReclamationValue.Name : projectData.ProjectDisplay + year }, sectionDiv, 'last');
                                this.createInfoWindowSection(sectionDiv, "last", null, cleared + disturbed + reclaimed + withheld);
                            }
                        }

                        if (unitsFlag) {
                            sectionDiv = this.createInfoWindowSection(tabPane, "last", null, "Select Units of Measure: <br />");
                            domConstruct.create('select', {
                                id: 'selLandInfoUnits',
                                'class': 'form-control',
                                onchange: this._toggleLandInfoUnitsDisplayed,
                                innerHTML: '<option>Km2</option><option>Hectares</option><option>Acres</option><option>Mi2</option>'
                            }, sectionDiv, 'last');
                        }

                        // land impacts by mine project chart
                        if (!projectData.IsInSitu) {
                            sectionDiv = this.createInfoWindowSection(tabPane, "last");
                            onclickFunc = lang.hitch(this, function () {
                                this.initInfoWindowModal({
                                    dialogueId: this.infoWindowPopupId,
                                    style: 'modal-content lg modalContentLargeCharts',
                                    link: this.libraryUrl + "Dataset/ChartByNumber?Number=C17&Unit=2"
                                });
                            });
                            this.createInfoWindowAnchor({
                                parentNode: sectionDiv,
                                pos: 'last',
                                href: "#" + this.infoWindowPopupId,
                                innerHTML: this.infoGlyphSign + "View Land Impacts by Mine Project",
                                className: "btn-link",
                                onclickFunc: onclickFunc,
                                dataToggle: "modal",
                                roleName: "button"
                            });
                        }
                        // land impacts by year chart
                        sectionDiv = this.createInfoWindowSection(tabPane, "last");
                        onclickFunc = lang.hitch(this, function () {
                            this.initInfoWindowModal({
                                dialogueId: this.infoWindowPopupId,
                                style: 'modal-content lg modalContentLargeCharts',
                                link: this.libraryUrl + "Dataset/ChartByNumber?Number=C18&Unit=2"
                            });
                        });
                        this.createInfoWindowAnchor({
                            parentNode: sectionDiv,
                            pos: 'last',
                            href: "#" + this.infoWindowPopupId,
                            innerHTML: this.infoGlyphSign + "View Regional Land Impacts by Year",
                            className: "btn-link",
                            onclickFunc: onclickFunc,
                            dataToggle: "modal",
                            roleName: "button"
                        });
                    }

                    // links to DL
                    sectionDiv = this.createInfoWindowSection(tabPane, 'last');
                    this.createInfoWindowAnchor({
                        parentNode: sectionDiv,
                        pos: 'last',
                        href: this.libraryUrl + "Browser#Category=LAND",
                        innerHTML: this.newWindowGlyphSign + "More Land Data",
                        targetName: "_blank"
                    });

                    sectionDiv = this.createInfoWindowSection(tabPane, 'last');
                    this.createInfoWindowAnchor({
                        parentNode: sectionDiv,
                        pos: 'last',
                        href: this.libraryUrl + "Browser#SearchByTitleORKeyword=disturbanceshapefiles&amp;Page=1&amp;Sort=Title",
                        innerHTML: this.newWindowGlyphSign + "Download Shape Files",
                        targetName: "_blank"
                    });

                    return tabPane;
                },

                // get info-window title
                _getInfoWindowTitle: function (projectId) {
                    var title = '', proj = this._getProjectInfoData(projectId);

                    if (proj) {
                        if (proj.Website === '') {
                            if (proj.OperatorName !== null) {
                                title += proj.OperatorName + " - ";
                            }
                        } else {
                            title += "<a href='" + proj.Website + "' target='_blank'>" + proj.OperatorName + "</a> - ";
                        }

                        if (proj.ProjectSpecificURL === '') {
                            title += proj.ProjectDisplay + "</h3>";
                        } else {
                            title += "<a href='" + proj.ProjectSpecificURL + "'target='_blank'>" + proj.ProjectDisplay + "</a>";
                        }
                    }

                    return title;
                },

                // list approval links horizontally
                _createListOfApprovalLinks: function (parentNode, urlArray, listTitle) {
                    var i, spanListNode = null, linkInnerHtml = null;

                    domConstruct.create('span', { 'class': "oilSandsProjectDescSpan", innerHTML: listTitle + ":" }, parentNode, "first");
                    spanListNode = domConstruct.create('span', { 'class': "oilSandsProjectlinkSpan" }, parentNode, "last");
                    for (i = 0; i < urlArray.length; i += 1) {
                        if (i === 0) {
                            linkInnerHtml = this.newWindowGlyphSign + urlArray[i].FullNumber;
                        } else {
                            linkInnerHtml = urlArray[i].FullNumber;
                        }

                        this.createInfoWindowAnchor({
                            parentNode: spanListNode,
                            pos: 'last',
                            href: urlArray[i].DocumentLink,
                            innerHTML: linkInnerHtml,
                            targetName: "_blank"
                        });

                        if (urlArray.length - 1 !== i) {
                            domConstruct.create('span', { innerHTML: ", " }, spanListNode, 'last');
                        }
                    }

                    return parentNode;
                },
                //round barrels to millions of cubic meters - one decimal place
                _productionBarrelsToCubicMeters: function (barrels) {
                    var cubes = barrels / 6.29295;
                    if (cubes > 1000000) {
                        return number.format((cubes / 1000000), { round: 0, places: 2 }) + " million";
                    }
                    if (cubes < 10000) {
                        return number.format(cubes, { round: 0, places: 0 }).replace(".", "");
                    }
                    return number.format((cubes / 1000000), { round: 0, places: 2 }) + " million";
                },

                // toggle land information to different units
                _toggleLandInfoUnitsDisplayed: function () {
                    var div = dom.byId("selLandInfoUnits").options[dom.byId("selLandInfoUnits").selectedIndex];
                    dom.byId("divLandUnitOptionKm2").style.display = "none";
                    dom.byId("divLandUnitOptionAcres").style.display = "none";
                    dom.byId("divLandUnitOptionHectares").style.display = "none";
                    dom.byId("divLandUnitOptionMi2").style.display = "none";
                    dom.byId("divLandUnitOption" + div.value).style.display = "block";
                },

                // convert to different units (used in land)
                _convertUnit: function (value, from, to) {
                    var converted;
                    switch (from) {
                        case "Hectares":
                            switch (to) {
                                case "Km2":
                                    converted = number.format(value / 100, { places: 2, rounds: 5 });
                                    break;
                                case "Mi2":
                                    converted = number.format(value * 0.00386102159, { places: 2, rounds: 5 });
                                    break;
                                case "Acres":
                                    converted = number.format(value * 2.47105381, { places: 2, rounds: 5 });
                                    break;
                                case "Hectares":
                                    converted = number.format(value, { places: 2, rounds: 5 });
                                    break;
                            }
                            break;
                    }
                    return converted;
                },

                //round barrels to millions - one decimal place
                _productionFormatBarrels: function (barrels) {
                    if (barrels > 1000000) {
                        return number.format((barrels / 1000000), { round: 0, places: 1 }) + " million";
                    }
                    if (barrels < 10000) {
                        return number.format(barrels, { round: 0, places: 0 }).replace(".", "");
                    }
                    return number.format((barrels / 1000000), { round: 0, places: 2 }) + " million";
                },
                // get project Id's to show in layer
                _getProjectIds: function () {
                    var i, projectSymbol;
                    if (this.projectIds === '') {
                        for (i = 0; i < this.projectsData.length; i += 1) {

                            if (this.projectStatusGroup.indexOf(this.projectsData[i].StatusGroup) > -1) {

                                if (this.projectsData[i].Id > -1) {
                                    if (i < this.projectsData.length - 1) {
                                        this.projectIds += this.projectsData[i].Id + ',';
                                    } else {

                                        this.projectIds += this.projectsData[i].Id;
                                    }
                                } else {
                                    // add to new projects array
                                    if (this.newProjects.indexOf(this.projectsData[i]) === -1) {
                                        this.newProjects.push(this.projectsData[i]);
                                    }
                                }

                                // get project icon and label
                                projectSymbol = this._getProjectSymbol(this.projectsData[i].StatusGroup);

                                if (projectSymbol === null) {

                                    // remove project id from the list when project group status not available 
                                    if (i < this.projectsData.length - 1) {
                                        this.projectIds = this.projectIds.replace(this.projectsData[i].Id + ',', '');
                                    } else {

                                        this.projectIds = this.projectIds.replace(this.projectsData[i].Id, '');
                                    }
                                }

                            }
                        }
                    }
                }
            });

        return _OilSandsContent;
    });