/*property
    _attachEventHandlers, _createLinkAnchorForRelatedLink, _hideDropdownNav,
    _setAemerisLinkAttr, _setHomeLinkAttr, _setLibraryLinkAttr,
    _setLogoImageMobileSrcAttr, _setLogoImageSrcAttr, _setSiteLinksAttr,
    _setTitleAttr, _setTitleLinkAttr, add, addClass, aemerisLink, aemerisUrl,
    click, collapseMenuToggleButton, collapseMenuToggleIcon, create, document,
    domNode, forEach, hitch, homeLink, homeUrl, href, inherited, innerHTML,
    length, libraryLink, libraryUrl, linksList, logoImage, logoImageMobile,
    logoSource, logoSourceMobile, on, own, postCreate, preventDefault, publish,
    remove, removeClass, searchBar, sidebarToggleButton, src, stopPropagation,
    strings, templateString, title, titleNode, titleUrl, type, url
*/
define([
  'dojo/_base/declare',
  'dojo/_base/lang',
  'dojo/query',
  'dojo/topic',
  'dojo/on',
  'dojo/dom-construct',
  'dojo/dom-class',

  'dijit/_WidgetBase',
  'dijit/_TemplatedMixin',

  'dojo/text!./templates/NavBar.html',
  'dojo/i18n!./nls/strings',
  'app/search/SearchBar',
  '../mapping/Utils',

  'dojo-bootstrap/Collapse',
  'dojo-bootstrap/Dropdown'
], function (
  declare, lang, query, topic, on, domConstruct, domClass,
  _WidgetBase, _TemplatedMixin,
  template, strings, SearchBar, mappingUtils
) {
    //'use strict';//can't use strict here because of use of special var arguments 
    return declare([_WidgetBase, _TemplatedMixin], {
        templateString: template,
        strings: strings,

        _setTitleAttr: function (newTitle) {
            this.title = newTitle;
            this.titleNode.innerHTML = this.title;
            window.document.title = this.title;
        },
        
        _setTitleLinkAttr: function (newTitleUrl) {
            this.titleUrl = newTitleUrl;
            this.titleNode.href = this.titleUrl;
        },

        _setLogoImageSrcAttr: function (imageSrc) {
            this.logoSource = imageSrc;
            this.logoImage.src = this.logoSource;
        },
        _setLogoImageMobileSrcAttr: function (imageSrc) {
            this.logoSourceMobile = imageSrc;
            this.logoImageMobile.src = this.logoSourceMobile;
        },
        _setHomeLinkAttr: function (newHomeUrl) {
            this.homeUrl = newHomeUrl;
            this.homeLink.href = this.homeUrl;
        },
        _setLibraryLinkAttr: function (newLibraryUrl) {
            this.libraryUrl = newLibraryUrl;
            this.libraryLink.href = this.libraryUrl;
        },
        _setSiteLinksAttr: function(links) {
            links.forEach(lang.hitch(this, function (link) {
                var listItem = domConstruct.create("li", {}, this.linksList, 'last');
                mappingUtils._createLinkAnchorForRelatedLink(link.title, link.url, listItem, "last", link.type, "navLinks", null);
            }));
        },
        _setAemerisLinkAttr: function (newUrl) {
            this.aemerisUrl = newUrl;
            this.aemerisLink.href = this.aemerisUrl;
        },
        postCreate: function () {
            this.inherited(arguments);
            //this.set('title', strings.appTitle);
            this._attachEventHandlers();
            this.searchBar = new SearchBar({}, 'searchBar');
        },

        _attachEventHandlers: function () {
            var self = this;
            // toggle sidebar
            this.own(on(this.sidebarToggleButton, 'click', function (e) {
                topic.publish('sidebar/toggle');
                self._hideDropdownNav(e);
            }));
            // show about modal
            query('a[href="#about"]', this.domNode).on('click', function (e) {
                e.preventDefault();
                topic.publish('about/show');
                self._hideDropdownNav(e);
            });
            query('#collapseLegend').on("show.bs.collapse", function () {
                query('#legendButton').addClass("active");
            });
            query('#collapseLegend').on("hide.bs.collapse", function () {
                query('#legendButton').removeClass("active");
            });
            query('.navbar-collapse').on("show.bs.collapse", lang.hitch(this, function () {
                domClass.remove(this.collapseMenuToggleIcon, "glyphicon-menu-down");
                domClass.add(this.collapseMenuToggleIcon, "glyphicon-menu-up");
            }));
            query('.navbar-collapse').on("hide.bs.collapse", lang.hitch(this, function () {
                domClass.remove(this.collapseMenuToggleIcon, "glyphicon-menu-up");
                domClass.add(this.collapseMenuToggleIcon, "glyphicon-menu-down");
            }));
        },

        _hideDropdownNav: function (e) {
            // hide nav dropdown on mobile
            if (query('.navbar-collapse.in', this.domNode).length > 0) {
                e.stopPropagation();
                this.collapseMenuToggleButton.click();
            }
        }
    });
});