﻿/*property
    _loadPortalGlossary, templateString, modalId, anchorId, glossaryUrl,
    postCreate, empty, glossaryKeywordLink, glossaryList, then, hitch,
    value, forEach, AnchorID, toUpperCase, pusj, create, id, innerHTML, Description,
    Name, length, onclick, publish, stopPropagation, byId, _scrollToNode, subscribe, modal,
    get, handleAs, headers, sync, smoothScroll, node, win, duration, play, highlight, 
    charAt, push, class, color, edwServiceUrl
*/
define([
  "dojo/_base/declare",
  "dojo/_base/lang",
  "dojo/topic",
  "dojo/query",
  "dojo/dom-construct",
  "dojo/request",
  "dojo/dom",
  "dojo/on",
  "dojox/fx",
  "dijit/_WidgetBase",
  "dijit/_TemplatedMixin",
  "dojo/text!./templates/PortalGlossaryModal.html",
  "dojo-bootstrap/Modal",
  "dojox/fx/scroll"
], function (declare, lang, topic, query, domConstruct, request, dom, on, fx,
  _WidgetBase, _TemplatedMixin, template
) {
    'use strict';
    return declare([_WidgetBase, _TemplatedMixin], {
        templateString: template,
        modalId: "glossaryModalDiv",
        anchorId: null,
        //glossaryUrl: "http://localhost/Services.WebApi/portalglossary/odata/Glossaries?$orderby=AnchorID",
        glossaryUrl: siteConfig.edwServiceUrl + "portalglossary/odata/Glossaries?$orderby=AnchorID",
        postCreate: function () {
            domConstruct.empty(this.glossaryKeywordLink);
            domConstruct.empty(this.glossaryList);

            this._loadPortalGlossary(this.glossaryUrl).then(lang.hitch(this, function (glossaryData) {
                var node = null, currentkeyword = null, newkeyword = null, keywords = [];
                glossaryData.value.forEach(lang.hitch(this, function (glossary) {
                    newkeyword = glossary.AnchorID.charAt(0).toUpperCase();
                    if (currentkeyword !== newkeyword) {
                        currentkeyword = newkeyword;
                        keywords.push(currentkeyword);
                        node = domConstruct.create("p", { 'class': 'glossaryItem name' }, this.glossaryList, "last");
                        domConstruct.create("a", {
                            id: currentkeyword,
                            innerHTML: "<b>" + currentkeyword + "</b>",
                            'class': "glossaryItem name"
                        }, node, "last");
                        node = domConstruct.create("ul", {}, this.glossaryList, "last");
                    }

                    if (node && glossary.AnchorID && glossary.Description) {
                        domConstruct.create("li", {
                            'class': 'glossaryItem',
                            innerHTML: '<a id="' + glossary.AnchorID + '" class="glossaryItem name"><b>' + glossary.Name + '</b></a> - ' + glossary.Description
                        }, node, "last");
                    }
                }));

                if (keywords.length) {
                    node = domConstruct.create("b", {}, this.glossaryKeywordLink, "last");

                    keywords.forEach(lang.hitch(this, function (keyword) {
                        domConstruct.create("a", {
                            innerHTML: keyword,
                            'class': 'glossaryKey',
                            onclick: function (e) {
                                topic.publish('PortalGlossary/ScrollToKeyword', keyword);
                                e.stopPropagation();
                            }
                        }, node, "last");
                    }));
                }

                on(dom.byId(this.modalId), "shown.bs.modal", lang.hitch(this, function () {
                    if (this.anchorId) {
                        this._scrollToNode(this.anchorId);
                    }
                }));
            }));

            topic.subscribe("PortalGlossary/ShowModal", lang.hitch(this, function (anchorId) {
                this.anchorId = anchorId;
                query("#" + this.modalId).modal("show");                
            }));

            topic.subscribe("PortalGlossary/ScrollToKeyword", lang.hitch(this, function (keyword) {
                if (keyword) {
                    this._scrollToNode(keyword);
                }
            }));
        },
        _loadPortalGlossary: function(url) {
            return request.get(url, {
                handleAs: "json",
                headers: { "X-Requested-With": null },
                sync: false
            });
        },
        _scrollToNode: function(nodeId) {
            fx.smoothScroll({
                node: dom.byId(nodeId),
                win: this.glossaryList,
                duration: 50
            }).play();

            fx.highlight({
                node: dom.byId(nodeId),
                color: '#97D700', // AEMERIS green
                duration: 800
            }).play();
        }
    });
});