﻿define([
  'dojo/topic',
  './SearchAggregator'
], function (topic, searchAggregator) {
    'use strict';
    topic.subscribe('SearchBar/SearchInvoked', function (searchText) {
        var deferredResults = searchAggregator.search(searchText);

        deferredResults.then(function(results) {
            var searchResultsModel = {
                searchText: searchText,
                searchResults: results
            };
            topic.publish('SearchEngine/ResultsReady', searchResultsModel);
        });
    });
    return {};
});