﻿define([
    'dojo/_base/declare',
    'dojo/string',
    './_configSearchBase',
    '../SearchableConfig',
    'dojo/i18n!app/layout/nls/strings'
], function (declare, string, searchBase, SearchableConfig, strings) {
    'use strict';
    return declare(searchBase, {

        constructor: function () {
            this.resultsType = strings.searchContentGroupLinkResultsTitle;
        },

        search: function (searchText) {
            var searchPattern = string.substitute("//contentGroups/group/links[contains(title, \"${searchText}\")]", { searchText: searchText });
            var results = JSON.search(new SearchableConfig(), searchPattern);
            return this.getResultModels(results, searchText);
        },

        searchModuleIdentifier: 'ContentGroupLink', 

        getResultModel: function (resultObject, ignore) {//ignoring searchText Parameter
            return {
                resultType: this.resultsType,
                title: resultObject.title,
                //navigateAction: function () {
                //    alert('Search result display logic for content group operational multi layers has not been implemented yet.');
                //},
                navigateUrl: resultObject.url,
                field: strings.searchFieldTitle,
                matchedValue: resultObject.title,
                glyphIconClass: 'glyphicon-new-window'
            };
        }
    });
});