﻿define([
    'dojo/topic',
    'dojo/_base/declare',
    'dojo/string',
    './_configSearchBase',
    '../SearchableConfig',
    'dojo/i18n!app/layout/nls/strings'
], function (topic, declare, string, searchBase, SearchableConfig, strings) {
    'use strict';
    return declare(searchBase, {
        expressionPath: null,
        searchModuleIdentifier: null,
        constructor: function (options) {
            this.expressionPath = options.expressionPath;
            this.searchModuleIdentifier = options.moduleIdentifier;
            this.resultsType = strings.searchContentGroupOperationalLayerMultiLayerResultsTitle;
        },

        search: function (searchText) {
            var searchPattern = string.substitute(this.expressionPath, { searchText: searchText });
            var results = JSON.search(new SearchableConfig(), searchPattern);
            return this.getResultModels(results, searchText);
        },

        getResultModel: function (resultObject, ignore) {// ignored searchText
            return {
                resultType: this.resultsType,
                title: resultObject.title,
                navigateAction: function () {
                    topic.publish('map/layers/show-by-layer-name', resultObject.id);
                },
                field: strings.searchFieldTitle,
                matchedValue: resultObject.title,
                glyphIconClass: 'glyphicon-eye-open'
            };
        }
    });
});