﻿define([
    'dojo/_base/declare',
    'dojo/string',
    './_configSearchBase',
    '../SearchableConfig',
    'dojo/i18n!app/layout/nls/strings'
], function (declare, string, searchBase, SearchableConfig, strings) {
    'use strict';
    return declare(searchBase, {
        expressionPath: null,
        searchModuleIdentifier: null,
        constructor: function (options) {
            this.expressionPath = options.expressionPath;
            this.searchModuleIdentifier = options.moduleIdentifier;
            this.resultsType = strings.searchContentGroupOperationalLayerRelatedLinkResultsTitle;
        },

        search: function (searchText) {
            var searchPattern = string.substitute(this.expressionPath, { searchText: searchText });
            var results = JSON.search(new SearchableConfig(), searchPattern);
            return this.getResultModels(results, searchText);
        },

        getResultModel: function (resultObject, ignore) {//ignored searchtText
            return {
                resultType: this.resultsType,
                title: resultObject.title,
                //navigateAction: function () {
                //    alert('Search result display logic for content group operational layer multi layers has not been implemented yet.');
                //},
                navigateUrl: resultObject.url,
                field: strings.searchFieldRelatedLink,
                matchedValue: resultObject.title,
                glyphIconClass: 'glyphicon-new-window'
            };
        }
    });
});