﻿define([
    'dojo/topic',
    'dojo/_base/declare',
    'dojo/_base/array',
    'dojo/string',
    './_configSearchBase',
    '../SearchableConfig',
    'dojo/i18n!app/layout/nls/strings'
], function (topic, declare, array, string, searchBase, SearchableConfig, strings) {
    'use strict';
    return declare(searchBase, {
        expressionPath: null,
        searchModuleIdentifier: null,
        constructor: function (options) {
            this.expressionPath = options.expressionPath;
            this.searchModuleIdentifier = options.moduleIdentifier;
            this.resultsType = strings.searchContentGroupOperationalLayerResultsTitle;
        },

        search: function (searchText) {
            var searchPattern = string.substitute(this.expressionPath, { searchText: searchText });
            var results = JSON.search(new SearchableConfig(), searchPattern);
            var filteredResults = array.filter(results, function (result) {
                return (result.options && (!result.options.multiLayers || result.options.multiLayers.length === 0));
            });
            return this.getResultModels(filteredResults, searchText);
        },        

        getResultModel: function (resultObject, ignore) {//ignored searchText
            return {
                resultType: this.resultsType,
                title: resultObject.title,
                navigateAction: function () {
                    topic.publish('map/layers/show-by-layer-name', resultObject.options.id);
                },
                //navigateUrl: 'http://www.google.com',
                field: strings.searchFieldTitle,
                matchedValue: resultObject.title,
                glyphIconClass: 'glyphicon-eye-open'
            };
        }
    });
});