﻿define([
    'dojo/topic',
    'dojo/_base/declare',
    'dojo/string',
    './_configSearchBase',
    '../SearchableConfig',
    'dojo/i18n!app/layout/nls/strings'
], function (topic, declare, string, searchBase, SearchableConfig, strings) {
    'use strict';
    return declare(searchBase, {

        constructor: function () {
            this.resultsType = strings.searchMapControlsOperationalLayersResultsTitle;
        },

        search: function (searchText) {
            var searchPattern = string.substitute("//mapControls/operationalLayers[contains(title, \"${searchText}\")]", { searchText: searchText });
            var results = JSON.search(new SearchableConfig(), searchPattern);
            return this.getResultModels(results, searchText);
        },

        searchModuleIdentifier: 'MapControlsOperationalLayerTitle',

        getResultModel: function (resultObject, ignore) {//ignored searchText
            return {
                resultType: this.resultsType,
                title: resultObject.title,
                navigateAction: function () {
                    topic.publish('map/layers/show-by-layer-name', resultObject.options.id);
                },
                //navigateUrl: 'http://www.google.com',
                field: strings.searchFieldTitle,
                matchedValue: resultObject.title,
                glyphIconClass: 'glyphicon-new-window'
            };
        }
    });
});