﻿define([
    'dojo/_base/declare',
    'dojo/_base/lang',
    'dojo/Deferred',
    'defiantjs'
], function (
    declare, lang, Deferred
    ) {
    'use strict';
    return declare(null, {

        constructor: function (/*Object*/ kwArgs) {
            lang.mixin(this, kwArgs);

            this.resultsType = "resultsTitle not defined";
        },

        searchAsync: function (searchText) {
            var deferred = new Deferred();
            deferred.resolve(this.search(searchText));
            return deferred;
        },

        search: function (searchText) {
            throw 'Search not implemented!';
        },

        getResultModel: function (resultObject, searchText) {
            throw 'getResultModel not implemented!';
        },

        getResultModels: function (resultObjects, searchText) {            
            return resultObjects.map(lang.hitch(this, function (resultObject) {
                return this.getResultModel(resultObject, searchText);
            }));
        }
    });
});