// This file in the main entry point for defining grunt tasks and using grunt plugins.
// Click here to learn more. http://go.microsoft.com/fwlink/?LinkID=513275&clcid=0x409
/*jslint 
    node: true
*/
module.exports = function (grunt) {
    'use strict';
    grunt.initConfig({
        bower: {
            install: {
                options: {
                    targetDir: "Scripts/lib",
                    layout: "byComponent",
                    cleanTargetDir: false,
                    cleanBowerDir: false,
                    verbose: true
                }
            }
        },
        intern: {
            dev: {
                options: {
                    runType: 'client',
                    config: 'tests/intern'
                }
            }
        },
        esri_slurp: {
            dev: {
                options: {
                    version: '3.20',
                    packageLocation: 'Scripts/lib/esri',
                    beautify: true
                },
                dest: 'Scripts/lib/esri'
            }
        },
        clean: {
            esri: ['Scripts/lib/esri']
        }
    });

    // This command registers the default task which will install bower packages into lib
    grunt.registerTask('default', ['bower:install', 'slurp']);
    grunt.registerTask('slurp', ['esri_slurp:dev']);
    grunt.registerTask('clean_esri', ['clean:esri']);
    grunt.registerTask('test', ['intern']);
    
    // The following line loads the grunt plugins.
    // This line needs to be at the end of this this file.
    grunt.loadNpmTasks("grunt-bower-task");
    grunt.loadNpmTasks('grunt-esri-slurp');
    grunt.loadNpmTasks('grunt-contrib-clean');
    grunt.loadNpmTasks('intern');
};