﻿var profile = {
    basePath: '../',
    action: 'release',
    cssOptimize: "comments",
    mini: true,
    optimize: 'closure',
    layerOptimize: 'closure',
    stripConsole: 'all',
    selectorEngine: 'lite',
    packages: [
        { name: "dojo", location: "Scripts/lib/dojo" },
        { name: "dojox", location: "Scripts/lib/dojox" },
        { name: "dijit", location: "Scripts/lib/dijit" },
        { name: "xstyle", location: "Scripts/lib/xstyle" },
        { name: "put-selector", location: "Scripts/lib/put-selector" },
        { name: "dgrid", location: "Scripts/lib/dgrid" },
        { name: "esri", location: "Scripts/lib/esri" },
        { name: "dojo-bootstrap", location: "Scripts/lib/dojo-bootstrap" },
        { name: "bootstrap-map-js", location: "Scripts/lib/bootstrap-map-js" },
        { name: "spin-js", location: "Scripts/lib/spin.js" },
        { name: "agsjs", location: "Scripts/agsjs" },
        { name: "history.js", location: "Scripts/lib/history.js/html4+html5" },//to support html4 browsers as well
        { name: "app", location: "Scripts/app" },
        { name: "defiantjs", location: "Scripts/lib/defiantjs", main: "defiant.min" }
    ],
    layers: {
        'dojo/dojo': {
            include: [
                // include the app
                'app/main',
                // dependencies of esri/map that will be requested if not included
                'dojox',
                'dojox/gfx/path',
                'dojox/gfx/svg',
                'dojox/gfx/shape',
                'esri/dijit/Attribution',
                // be sure to include the layer types used in your web map
                // otherwise they will be requested asyncronously
                'esri/layers/FeatureLayer',
                'esri/layers/GraphicsLayer',
                'esri/layers/WebTiledLayer',
                'esri/layers/ArcGISDynamicMapServiceLayer',
                'esri/layers/WMSLayer',
                'esri/geometry/geometryEngine',
                'esri/geometry/geometryEngineAsync',
                //'esri/geometry/geometryenginewebworker',

                'dojox/encoding/base64'
            ],
            boot: true,
            customBase: true,
            includeLocales: ['en-us']
        }
    },
    staticHasFeatures: {
        // The trace & log APIs are used for debugging the loader, so we do not need them in the build.
        'dojo-trace-api': false,
        'dojo-log-api': false,

        // This causes normally private loader data to be exposed for debugging. In a release build, we do not need
        // that either.
        'dojo-publish-privates': false,

        // This application is pure AMD, so get rid of the legacy loader.
        //'dojo-sync-loader': false,

        // `dojo-xhr-factory` relies on `dojo-sync-loader`, which we have removed.
        'dojo-xhr-factory': false,

        // We are not loading tests in production, so we can get rid of some test sniffing code.
        'dojo-test-sniff': false
    }
};
