﻿/*property
    AERLinks, ApiId, AverageInSituBrackishWaterPerBarrelBitumen,
    AverageInSituBrackishWaterPerBarrelBitumenYear,
    AverageInSituFreshWaterPerBarrelBitumen,
    AverageInSituFreshWaterPerBarrelBitumenYear,
    AverageIntegratedInSituBrackishWaterPerBarrelCrude,
    AverageIntegratedInSituBrackishWaterPerBarrelCrudeYear,
    AverageIntegratedInSituFreshWaterPerBarrelCrude,
    AverageMineFreshWaterPerBarrelCrude,
    AverageMineFreshWaterPerBarrelCrudeYear,
    AverageUpgraderFreshWaterPerBarrelCrude,
    AverageUpgraderFreshWaterPerBarrelCrudeYear, Barrels, BrackishWaterUse,
    BrackishWaterUseIntensity, Cleared, CogenEfficiencyCredit,
    CompleteEIALinks, ConfidentialityExpiryDate, CreditsRequired,
    CurrentProductionYear, DataYear, DataYearDisplay, Disturbed, DocumentLink,
    EPCsGenerated, EPCsRetired, EPEAApprovalLinks, ERCBFacilityIdentifier,
    EmissionsIntensityKilogramsPerBarrelDisplay,
    EmissionsIntensityTonnesPerBarrel,
    EmissionsIntensityTonnesPerBarrelDisplay, EmissionsNetCompliance,
    EmissionsPerformanceCredits, EmissionsPerformanceCreditsDisplay,
    EmissionsReportingStatus, EmissionsThreshold, EmissionsYear,
    Emissionsintensity, FEANLinks, FreshWaterUse, FreshWaterUseIntensity,
    FullNumber, FundCreditsPurchased, GHGFromElectricity, GHGFromProduction,
    HasNPRI, Id, IndustryType, InprogressEIALinks, IsActive, IsCoGen, IsInSitu,
    IsSGER, IsSGRR, LandReclamationValue, LatestEmissionSummary, Latitude,
    Longitude, NPRILinks, Name, NotOperating, NotReporting, Operator_Name, OSP_NO,
    OffsetsSubmitted, OperatorName, PhaseStatuses, Phases, PowerCompanyDisplay,
    Production, ProductionType, Project, ProjectCount, ProjectDisplay,
    ProjectDisplayName, ProjectId, ProjectIdentifier, ProjectKey,
    ProjectMessage, ProjectNames, ProjectSpecificURL, Project_Name, Reclaimed,
    RequiredReduction, RequiredReductionDisplay, SGERIDs,
    SecurityFundGroupProjects, SecurityWithheld, SecurityWithheldYear,
    SharedDataProjectNames, Status, StatusGroup, TonnesGHGFromBitumenCrudeOil,
    TonnesGHGFromBitumenCrudeOilDisplay, TonnesGHGFromCoGeneration,
    TonnesGHGFromCoGenerationDisplay, TonnesTotalGHG, TonnesTotalGHGDisplay,
    TonnesTotalGHGEmissions, TotalBitumen, TotalCompliance, TotalGHGEmissions,
    TotalInSituWaterUse, TotalInSituWaterUseYear, TotalMarketableInSituBitumen,
    TotalMarketableOilSandsProduction, TotalMineWaterUse,
    TotalMineWaterUseYear, TotalSyntheticCrudeOil, TotalUpgraderWaterUse,
    TotalUpgraderWaterUseYear, TotalWaterUseIntensity, Type,
    WaterActApprovalLinks, WaterActLicenseLinks, WaterDiversion,
    WaterQualityValue, WaterReturn, WaterUseBrackish, WaterUseBrackishYear,
    WaterUseFresh, WaterUseFreshYear, Website, Year, YearlySummaries,
    YearlySummaryId, _convertUnit, _createListOfApprovalLinks,
    _createProjectGraphic, _getAirInfoWindowContent,
    _getEmissionsInfoWindowContent, _getEmissionsIntensityInfo,
    _getEnforcementTypesByOperator, _getInfoWindowTabs,
    _getLandInfoWindowContent, _getProjectData, _getProjectInfo,
    _getProjectInfoWindowContent, _getProjectSymbol,
    _getWaterInfoWindowContent, _productionBarrelsToCubicMeters,
    _productionFormatBarrels, async, attributes, dataUrl, deepEqual, fail,
    filter, geographicToWebMercator, geometry, _createRenderer, icon, include,
    infoWindowHandlerContent, infoWindowHandlerTitle, infos, isIU, isNotNull,
    isObject, isString, isTrue, label, length, libraryUrl, log, name, notEqual,
    notInclude, push, reject, resolve, setup, strictEqual, symbol, then, url,
    value, create, innerHTML, childNodes, equal, projectsData, some, projectInfoData,
    accountableParty, hasClassification, projectsEmission, enforcementTypes
*/
define([
    'intern!object',
    'intern/chai!assert',
    'dojo/dom-construct',
    'dojo/query',
    'esri/geometry/webMercatorUtils',
    'esri/geometry/Point',
    'esri/renderers/UniqueValueRenderer',
    'app/content/OilSandsContent'
], function (registerSuite, assert, domConstruct, query, webMercatorUtils, Point, UniqueValueRenderer, OilSandsContent) {
    'use strict';
    var oilSandsmodule, projectData = {
            ProjectNames: [
            "Base Operations"
            ],
            WaterActLicenseLinks: [{ FullNumber: "00038538", DocumentLink: "https://avw.alberta.ca/ApprovalViewerResults.aspx?Click=Search&exapv_id=38538" }],
            WaterActApprovalLinks: [{ FullNumber: "00209502", DocumentLink: "https://avw.alberta.ca/ApprovalViewerResults.aspx?Click=Search&exapv_id=209502" }],
            AERLinks: [{ FullNumber: "1686327", DocumentLink: "http://www.aer.ca/applications-and-notices/notices/application-1686327" }],
            FEANLinks: [],
            CompleteEIALinks: [{ FullNumber: "Suncor Voyageur EIA", DocumentLink: "ftp://ftp.gov.ab.ca/env/fs/eia/2005-03-SuncorVoyageurProject/" }],
            InprogressEIALinks: [],
            NPRILinks: [{ FullNumber: "2230", DocumentLink: "http://www.ec.gc.ca/inrp-npri/donnees-data/index.cfm?do=facility_substance_summary&lang=en&opt_npri_id=0000002230&opt_report_year=2011" }],
            EPEAApprovalLinks: [{ FullNumber: "00000094", DocumentLink: "https://avw.alberta.ca/ApprovalViewerResults.aspx?Click=Search&exapv_id=94" }],
            YearlySummaries: [
                {
                    YearlySummaryId: 2035988,
                    Year: 2014,
                    ProjectId: 6,
                    ProjectIdentifier: 8,
                    BrackishWaterUse: null,
                    FreshWaterUse: 27438251.02,
                    WaterDiversion: 28885762.02,
                    WaterReturn: 1447511,
                    Production: 17180187,
                    FreshWaterUseIntensity: 1.5971,
                    BrackishWaterUseIntensity: 0,
                    TotalWaterUseIntensity: 1.5971,
                    TotalGHGEmissions: null,
                    GHGFromElectricity: null,
                    GHGFromProduction: null,
                    CogenEfficiencyCredit: null,
                    EPCsGenerated: null,
                    EPCsRetired: null,
                    FundCreditsPurchased: null,
                    OffsetsSubmitted: null,
                    CreditsRequired: null,
                    TotalCompliance: null,
                    EmissionsNetCompliance: null,
                    Emissionsintensity: null,
                    TotalBitumen: 15922184,
                    TotalSyntheticCrudeOil: 17180187,
                    TotalMarketableInSituBitumen: 0,
                    TotalMarketableOilSandsProduction: 17180187,
                    Project: null
                }
            ],
            Phases: [],
            LandReclamationValue: {
                Name: "Suncor Base Operations",
                Year: 2014,
                Reclaimed: 1905,
                Disturbed: 17778,
                Cleared: 2390,
                SecurityWithheld: 359.1,
                SecurityWithheldYear: 2014,
                SecurityFundGroupProjects: "Base Operations"
            },
            ProjectMessage: "",
            ConfidentialityExpiryDate: "",
            LatestEmissionSummary: "Emissions summary unavailable.",
            EmissionsYear: 0,
            TonnesTotalGHGEmissions: null,
            Barrels: 108114057.78,
            WaterQualityValue: {
                AverageMineFreshWaterPerBarrelCrude: 1.6,
                AverageMineFreshWaterPerBarrelCrudeYear: 2014,
                AverageUpgraderFreshWaterPerBarrelCrude: 1.6,
                AverageUpgraderFreshWaterPerBarrelCrudeYear: 2014,
                AverageInSituFreshWaterPerBarrelBitumen: 1.6,
                AverageInSituFreshWaterPerBarrelBitumenYear: 2014,
                AverageInSituBrackishWaterPerBarrelBitumen: 0,
                AverageInSituBrackishWaterPerBarrelBitumenYear: 2014,
                AverageIntegratedInSituFreshWaterPerBarrelCrude: 0,
                AverageIntegratedInSituBrackishWaterPerBarrelCrude: 0,
                AverageIntegratedInSituBrackishWaterPerBarrelCrudeYear: 0,
                WaterUseFresh: 27438251020,
                WaterUseFreshYear: 2014,
                WaterUseBrackish: 0,
                WaterUseBrackishYear: 0,
                TotalMineWaterUse: 0,
                TotalMineWaterUseYear: 0,
                TotalInSituWaterUse: 0,
                TotalInSituWaterUseYear: 0,
                TotalUpgraderWaterUse: 0,
                TotalUpgraderWaterUseYear: 0
            },
            SharedDataProjectNames: [],
            PhaseStatuses: [
            "Voyageur Upgrader withdrawn."
            ],
            Type: "Oil Sands Mine, Upgrader",
            ERCBFacilityIdentifier: "ABOS0077189",
            CurrentProductionYear: 2014,
            ProjectId: 6,
            ProjectKey: 6,
            OperatorName: "Suncor",
            Website: "http://www.suncor.com/default.aspx",
            ProjectSpecificURL: "http://www.suncor.com/en/about/257.aspx",
            Production: "Synthetic Crude Oil",
            HasNPRI: true,
            IsInSitu: false,
            ProductionType: "Synthetic Crude Oil",
            ProjectDisplay: "Base Operations",
            Status: "Active"
        },
        emissionsData = {
            DataYear: 2011,
            DataYearDisplay: "2011",
            EmissionsIntensityKilogramsPerBarrelDisplay: "72.7",
            EmissionsIntensityTonnesPerBarrel: 0.0727,
            EmissionsIntensityTonnesPerBarrelDisplay: "0.07",
            EmissionsPerformanceCredits: 0,
            EmissionsPerformanceCreditsDisplay: "0",
            EmissionsReportingStatus: 0,
            EmissionsThreshold: "50 KT CO2e/yr",
            IsCoGen: true,
            IsSGER: true,
            IsSGRR: false,
            NotOperating: false,
            NotReporting: false,
            OperatorName: "Suncor",
            PowerCompanyDisplay: "TransAlta Energy Corp.",
            ProductionType: "Synthetic Crude Oil",
            ProjectCount: 1,
            ProjectDisplay: "Base Operations",
            ProjectId: 6,
            ProjectIdentifier: 8,
            ProjectNames: ["Base Operations"],
            ProjectSpecificURL: "http://www.suncor.com/en/about/257.aspx",
            RequiredReduction: 238134.38,
            RequiredReductionDisplay: "238,134",
            SGERIDs: ["Fz4428", "G10558"],
            TonnesGHGFromBitumenCrudeOil: 7897218.88,
            TonnesGHGFromBitumenCrudeOilDisplay: "7,897,219",
            TonnesGHGFromCoGeneration: 598754.83,
            TonnesGHGFromCoGenerationDisplay: "598,755",
            TonnesTotalGHG: 8495973.71,
            TonnesTotalGHGDisplay: "8,495,974",
            Website: "http://www.suncor.com/default.aspx"
        };
    registerSuite({
        name: 'OilSands Content module tests',
        setup: function () {
            oilSandsmodule = new OilSandsContent({ dataUrl: 'http://aemeris.alberta.ca/data/', libraryUrl: 'http://aemeris.alberta.ca/library/' });
        },
        'Test Production to Barrels': function () {
            var expectedResult = '1.5 million', barrels;
            barrels = oilSandsmodule._productionFormatBarrels(1487351.32);
            assert.strictEqual(barrels, expectedResult, 'Unexpected result.');

            expectedResult = '0.02 million';
            barrels = oilSandsmodule._productionFormatBarrels(20810.79);
            assert.strictEqual(barrels, expectedResult, 'Unexpected result.');

            expectedResult = '9,000';
            barrels = oilSandsmodule._productionFormatBarrels(9000.12);
            assert.strictEqual(barrels, expectedResult, 'Unexpected result.');
        },

        'Test Production to Cubic Meters': function () {
            var expectedResult = '0.24 million', barrelsm3;
            barrelsm3 = oilSandsmodule._productionBarrelsToCubicMeters(1487351.32);
            assert.strictEqual(barrelsm3, expectedResult, 'Unexpected result.');

            expectedResult = '3,307';
            barrelsm3 = oilSandsmodule._productionBarrelsToCubicMeters(20810.79);
            assert.strictEqual(barrelsm3, expectedResult, 'Unexpected result.');

            expectedResult = '1,430';
            barrelsm3 = oilSandsmodule._productionBarrelsToCubicMeters(9000.12);
            assert.strictEqual(barrelsm3, expectedResult, 'Unexpected result.');
        },
        'Test Load Project Status Data': function () {
            var def = this.async(14000),
                hasValidData = false;

            setTimeout(function () {
                assert.isTrue(oilSandsmodule.projectsData.length > 0, "Constructor doesn't return project status data.");
                hasValidData = oilSandsmodule.projectsData.some(function (project) {
                    if (project.Id > 0) {
                        return true;
                    }
                });
                assert.isTrue(hasValidData, "Constructor doesn't contain valid project status.");
                def.resolve();
            }, 13000); // need to wait for webservice data  
        },
        'Test Load Project Info data': function () {
            var def = this.async(14000),
                hasValidData = false;

            setTimeout(function () {
                assert.isTrue(oilSandsmodule.projectInfoData.length > 0, "Constructor doesn't return project info data.");
                hasValidData = oilSandsmodule.projectInfoData.some(function (projectInfo) {
                    if (projectInfo.ProjectId > 0) {
                        return true;
                    }
                });
                assert.isTrue(hasValidData, "Constructor doesn't contain valid project info.");
                def.resolve();
            }, 13000); // need to wait for webservice data  
        },
        'Test Load Enforcement data': function () {
            var def = this.async(3000),
                hasValidData = false;

            setTimeout(function () {
                assert.isTrue(oilSandsmodule.enforcementTypes.length > 0, "Constructor doesn't return enforcement types.");
                hasValidData = oilSandsmodule.enforcementTypes.some(function (enforcementType) {
                    if (enforcementType.accountableParty && enforcementType.hasClassification) {
                        return true;
                    }
                });
                assert.isTrue(hasValidData, "Constructor doesn't contain valid enforcement type.");
                def.resolve();
            }, 2000); // need to wait for webservice data  
        },
        'Test Load Project Emission Data': function () {
            var def = this.async(3000),
                hasValidData = false;

            setTimeout(function () {
                assert.isTrue(oilSandsmodule.projectsEmission.length > 0, "Constructor doesn't return projects emissions.");
                hasValidData = oilSandsmodule.projectsEmission.some(function (projectsEmission) {
                    if (projectsEmission.ProjectId > 0) {
                        return true;
                    }
                });
                assert.isTrue(hasValidData, "Constructor doesn't contain valid projects emission.");

                def.resolve();
            }, 2000); // need to wait for webservice data  
        },
        'Test Get project data': function () {
            var expectedProject1 = {
                Id: 7,
                ApiId: 34,
                StatusGroup: "OilSandsMine-IU-Active",
                IsActive: true,
                isIU: false,
                Status: "Active",
                OperatorName: "Canadian Natural Resources Ltd.",
                ProjectDisplayName: "Horizon",
                Latitude: 57.3726641,
                Longitude: -111.8220156,
                IndustryType: "Oil Sands Mine"    
            },
            expectedProject2 = {
                ApiId: 35,
                Id: 27,
                IndustryType: "In Situ",
                IsActive: true,
                Latitude: 55.5313369,
                Longitude: -110.9690967,
                OperatorName: "Devon Canada",
                ProjectDisplayName: "Jackfish",
                Status: "Active",
                StatusGroup: "InSitu-Active",
                isIU: false
            },
            expectedProject3 = {
                Id: 44,
                ApiId: 5,
                StatusGroup: "Upgrader-Proposed",
                IsActive: false,
                isIU: false,
                Status: "Applied",
                OperatorName: "Value Creation",
                ProjectDisplayName: "Heartland Upgrader",
                Latitude: 53.8180486,
                Longitude: -113.0376224,
                IndustryType: "Upgrader"
            },
            projData;

            projData = oilSandsmodule._getProjectData(7);
            assert.deepEqual(projData, expectedProject1, 'Unexpected project data.');

            projData = oilSandsmodule._getProjectData(27);
            assert.deepEqual(projData, expectedProject2, 'Unexpected project data.');

            projData = oilSandsmodule._getProjectData(44);
            assert.deepEqual(projData, expectedProject3, 'Unexpected project data.');
        },

        'Test Get project symbol': function () {
            var expectedProjectIcon = '/Scripts/app/content/images/projects/Mine_IU.png', projectSymbol;
            projectSymbol = oilSandsmodule._getProjectSymbol('OilSandsMine-IU-Active');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/Mine.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('OilSandsMine-Active');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/InSitu.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('InSitu-Active');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/Upgrader.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('Upgrader-Active');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/InSitu_IU.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('InSitu-IU-Active');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/Mine_Grey.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('OilSandsMine-Approved');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/InSitu_Grey.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('InSitu-Approved');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/Upgrader_Grey.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('Upgrader-Approved');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/Mine_IU_Grey.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('OilSandsMine-IU-Approved');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/InSitu_IU_Grey.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('InSitu-IU-Approved');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/InSitu_Orange.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('InSitu-Proposed');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/InSitu_IU_Orange.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('InSitu-IU-Proposed');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/Mine_Orange.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('OilSandsMine-Proposed');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/Mine_IU_Orange.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('OilSandsMine-IU-Proposed');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/Upgrader_Orange.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('Upgrader-Proposed');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/Upgrader_IU_Orange.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('Upgrader-IU-Proposed');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/InSitu_Red.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('InSitu-Inactive');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/InSitu_IU_Red.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('InSitu-IU-Inactive');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/Mine_Red.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('OilSandsMine-Inactive');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/Mine_IU_Red.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('OilSandsMine-IU-Inactive');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/Upgrader_Red.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('Upgrader-Inactive');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');

            expectedProjectIcon = '/Scripts/app/content/images/projects/Upgrader_IU_Red.png';
            projectSymbol = oilSandsmodule._getProjectSymbol('Upgrader-IU-Inactive');
            assert.include(projectSymbol[0].icon.url, expectedProjectIcon, 'Unexpected project symbol.');


        },

        'Test Create project graphic': function () {
            var expectedOSPName = 'Canadian Natural Resources Ltd.', projData, feature, expectedProjectIcon = '/Scripts/app/content/images/projects/Mine_IU.png', expectedPoint;
            projData = oilSandsmodule._getProjectData(7);
            expectedPoint = webMercatorUtils.geographicToWebMercator(new Point(-111.8220156, 57.3726641));

            feature = oilSandsmodule._createProjectGraphic(projData);
            assert.strictEqual(feature.attributes.Operator_Name, expectedOSPName, 'Unexpected project.');
            assert.include(feature.symbol.url, expectedProjectIcon, 'Unexpected project symbol.');
            assert.deepEqual(feature.geometry, expectedPoint, 'Unexpected location.');
        },

        'Test Get approval links': function () {
            var dataLinks = [],
                parentNode = domConstruct.create('div', {}, null),
                contentNode = null,
                expectedLinkContent = '<span class="oilSandsProjectDescSpan">Water Act Licenses:</span><span class="oilSandsProjectlinkSpan"><a href="https://avw.alberta.ca/ApprovalViewerResults.aspx?Click=Search&amp;exapv_id=188229" target="_blank"><span class="glyphicon glyphicon-new-window"></span>00188229</a><span>, </span><a href="https://avw.alberta.ca/ApprovalViewerResults.aspx?Click=Search&amp;exapv_id=248646" target="_blank">00248646</a><span>, </span><a href="https://avw.alberta.ca/ApprovalViewerResults.aspx?Click=Search&amp;exapv_id=249470" target="_blank">00249470</a><span>, </span><a href="https://avw.alberta.ca/ApprovalViewerResults.aspx?Click=Search&amp;exapv_id=251163" target="_blank">00251163</a></span>';

            dataLinks.push({ DocumentLink: 'https://avw.alberta.ca/ApprovalViewerResults.aspx?Click=Search&exapv_id=188229', FullNumber: '00188229' });
            dataLinks.push({ DocumentLink: 'https://avw.alberta.ca/ApprovalViewerResults.aspx?Click=Search&exapv_id=248646', FullNumber: '00248646' });
            dataLinks.push({ DocumentLink: 'https://avw.alberta.ca/ApprovalViewerResults.aspx?Click=Search&exapv_id=249470', FullNumber: '00249470' });
            dataLinks.push({ DocumentLink: 'https://avw.alberta.ca/ApprovalViewerResults.aspx?Click=Search&exapv_id=251163', FullNumber: '00251163' });

            contentNode = oilSandsmodule._createListOfApprovalLinks(parentNode, dataLinks, 'Water Act Licenses', '../images/links/newpage_light.png');
            assert.strictEqual(contentNode.innerHTML, expectedLinkContent, 'Aprroval link error');
        },

        'Test Create renderer': function () {
            var renderer = oilSandsmodule._createRenderer(), projectId, expectedProjectIcon, expectedProjectLabel;
            assert.isTrue(renderer instanceof UniqueValueRenderer, "Get Renderer doesn't return expected object");
            assert.isObject(renderer, "expects an object");

            projectId = 24;
            expectedProjectIcon = '/Scripts/app/content/images/projects/Mine.png';
            expectedProjectLabel = 'Operating Oil Sands Mines';
            assert.strictEqual(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].label, expectedProjectLabel, 'project doesn\'t have expected lable');
            assert.include(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].symbol.url, expectedProjectIcon, 'project doesn\'t have expected icon');

            projectId = 48;
            expectedProjectIcon = '/Scripts/app/content/images/projects/InSitu.png';
            expectedProjectLabel = 'Operating In Situ Facilities';
            assert.strictEqual(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].label, expectedProjectLabel, 'project doesn\'t have expected lable');
            assert.include(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].symbol.url, expectedProjectIcon, 'project doesn\'t have expected icon');

            projectId = 42;
            expectedProjectIcon = '/Scripts/app/content/images/projects/Upgrader.png';
            expectedProjectLabel = 'Operating Stand Alone Upgraders';
            assert.strictEqual(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].label, expectedProjectLabel, 'project doesn\'t have expected lable');
            assert.include(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].symbol.url, expectedProjectIcon, 'project doesn\'t have expected icon');

            projectId = 7;
            expectedProjectIcon = '/Scripts/app/content/images/projects/Mine_IU.png';
            expectedProjectLabel = 'Operating Oil Sands Mines';
            assert.strictEqual(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].label, expectedProjectLabel, 'project doesn\'t have expected lable');
            assert.include(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].symbol.url, expectedProjectIcon, 'project doesn\'t have expected icon');

            projectId = 16;
            expectedProjectIcon = '/Scripts/app/content/images/projects/InSitu_IU.png';
            expectedProjectLabel = 'Operating In Situ Facilities';
            assert.strictEqual(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].label, expectedProjectLabel, 'project doesn\'t have expected lable');
            assert.include(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].symbol.url, expectedProjectIcon, 'project doesn\'t have expected icon');

            projectId = 2;
            expectedProjectIcon = '/Scripts/app/content/images/projects/Mine_Grey.png';
            expectedProjectLabel = 'Approved Oil Sands Mines';
            assert.strictEqual(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].label, expectedProjectLabel, 'project doesn\'t have expected lable');
            assert.include(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].symbol.url, expectedProjectIcon, 'project doesn\'t have expected icon');

            projectId = 15;
            expectedProjectIcon = '/Scripts/app/content/images/projects/Mine.png';
            expectedProjectLabel = 'Operating Oil Sands Mines';
            assert.strictEqual(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].label, expectedProjectLabel, 'project doesn\'t have expected lable');
            assert.include(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].symbol.url, expectedProjectIcon, 'project doesn\'t have expected icon');

            projectId = 45;
            expectedProjectIcon = '/Scripts/app/content/images/projects/Upgrader_Grey.png';
            expectedProjectLabel = 'Approved Stand Alone Upgraders';
            assert.strictEqual(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].label, expectedProjectLabel, 'project doesn\'t have expected lable');
            assert.include(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].symbol.url, expectedProjectIcon, 'project doesn\'t have expected icon');

            projectId = 52;
            expectedProjectIcon = '/Scripts/app/content/images/projects/InSitu_IU_Grey.png';
            expectedProjectLabel = 'Approved In Situ Facilities';
            assert.strictEqual(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].label, expectedProjectLabel, 'project doesn\'t have expected lable');
            assert.include(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].symbol.url, expectedProjectIcon, 'project doesn\'t have expected icon');

            projectId = 71;
            expectedProjectIcon = '/Scripts/app/content/images/projects/InSitu_Red.png';
            expectedProjectLabel = 'Inactive In Situ Facilities';
            assert.strictEqual(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].label, expectedProjectLabel, 'project doesn\'t have expected lable');
            assert.include(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].symbol.url, expectedProjectIcon, 'project doesn\'t have expected icon');

            projectId = 92;
            expectedProjectIcon = '/Scripts/app/content/images/projects/Mine_Grey.png';
            expectedProjectLabel = 'Approved Oil Sands Mines';
            assert.strictEqual(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].label, expectedProjectLabel, 'project doesn\'t have expected lable');
            assert.include(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].symbol.url, expectedProjectIcon, 'project doesn\'t have expected icon');

            projectId = 77;
            expectedProjectIcon = '/Scripts/app/content/images/projects/InSitu_Red.png';
            expectedProjectLabel = 'Inactive In Situ Facilities';
            assert.strictEqual(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].label, expectedProjectLabel, 'project doesn\'t have expected lable');
            assert.include(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].symbol.url, expectedProjectIcon, 'project doesn\'t have expected icon');

            projectId = 85;
            expectedProjectIcon = '/Scripts/app/content/images/projects/InSitu_IU_Orange.png';
            expectedProjectLabel = 'Proposed In Situ Facilities';
            assert.strictEqual(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].label, expectedProjectLabel, 'project doesn\'t have expected lable');
            assert.include(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].symbol.url, expectedProjectIcon, 'project doesn\'t have expected icon');

            projectId = 65;
            expectedProjectIcon = '/Scripts/app/content/images/projects/Mine_Red.png';
            expectedProjectLabel = 'Inactive Oil Sands Mine';
            assert.strictEqual(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].label, expectedProjectLabel, 'project doesn\'t have expected lable');
            assert.include(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].symbol.url, expectedProjectIcon, 'project doesn\'t have expected icon');

            projectId = 44;
            expectedProjectIcon = '/Scripts/app/content/images/projects/Upgrader_Orange.png';
            expectedProjectLabel = 'Proposed Stand Alone Upgraders';
            assert.strictEqual(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].label, expectedProjectLabel, 'project doesn\'t have expected lable');
            assert.include(renderer.infos.filter(function (obj) { return obj.value === projectId; })[0].symbol.url, expectedProjectIcon, 'project doesn\'t have expected icon');

        },

        'Test Unit Coversion': function () {
            var result, convertValue = 2390, expectedResultKm = "23.90", expectedResultHectares = "2,390.00", expectedResultAcres = "5,905.82", expectedResultMi2 = "9.23";
            result = oilSandsmodule._convertUnit(convertValue, "Hectares", "Km2");
            assert.strictEqual(result, expectedResultKm, 'Convertion error');

            result = oilSandsmodule._convertUnit(convertValue, "Hectares", "Hectares");
            assert.strictEqual(result, expectedResultHectares, 'Convertion error');

            result = oilSandsmodule._convertUnit(convertValue, "Hectares", "Acres");
            assert.strictEqual(result, expectedResultAcres, 'Convertion error');

            result = oilSandsmodule._convertUnit(convertValue, "Hectares", "Mi2");
            assert.strictEqual(result, expectedResultMi2, 'Convertion error');
        },

        'Test InfoWindow Title handler': function () {
            var title, graphicObject = { attributes: { ApiId: 2, OSP_NO: 53, Operator_Name: 'Grizzly Oil Sands', Project_Name: 'Algar Lake' } },
                expectedTitle = "<a href='http://www.grizzlyoilsands.com/' target='_blank'>Grizzly Oil Sands</a> - <a href='http://www.grizzlyoilsands.com/operations/algar-lake'target='_blank'>Algar Lake</a>";
            title = oilSandsmodule.infoWindowHandlerTitle(graphicObject);
            assert.strictEqual(title, expectedTitle, 'InfoWindowHandlerTitle error');
        },

        'Test InfoWindow Content handler': function () {
            var graphicObject = { attributes: { OSP_NO: 7, Operator_Name: 'Horizon', Project_Name: 'Canadian Natural Resources Ltd.' } },
                graphicObject2 = { attributes: { OSP_NO: 28, Operator_Name: 'Suncor', Project_Name: 'Meadow Creek' } },
                graphicObject3 = { attributes: { OSP_NO: 13, Operator_Name: 'Japan Canada Oil Sands', Project_Name: 'Hangingstone' } },
                contentNode = oilSandsmodule.infoWindowHandlerContent(graphicObject),
                sectionList = query('.infoWindowSection', contentNode);

            assert.equal(contentNode.childNodes.length, 2, 'child nodes number is wrong');
            assert.equal(sectionList.length, 23, 'section number is wrong');
            assert.equal(query(".tab-pane", contentNode).length, 4, 'tabs number is wrong');
            assert.isNotNull(query('[id="project"]', contentNode), 'project tab is missing');
            assert.isNotNull(query('[id="emissions"]', contentNode), 'emissions tab is missing');
            assert.isNotNull(query('[id="water"]', contentNode), 'water tab is missing');
            assert.isNotNull(query('[id="air"]', contentNode), 'air tab is missing');
            assert.isNotNull(query('[id="land"]', contentNode), 'land tab is missing');

            // project tab
            assert.include(sectionList[0].innerHTML, "Phases", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[2].innerHTML, "Company Enforcement Actions", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[3].innerHTML, "Federal Environmental Assessment", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[4].innerHTML, "Water Act Approvals:", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[5].innerHTML, "Water Act Licenses:", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[6].innerHTML, "Environmental Protection and Enhancements Act Approvals:", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[7].innerHTML, "Completed Environmental Impact Assessments:", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[8].innerHTML, "barrels", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[9].innerHTML, "View production history graph", 'infoWindowHandlerContent does not match');
            // other tab
            assert.include(sectionList[10].innerHTML, "Water use data unavailable for this Project", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[11].innerHTML, "More data on water use", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[12].innerHTML, "National Pollutant Release Inventory", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[13].innerHTML, "More data on Air", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[14].innerHTML, "land is disturbed by this project", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[15].innerHTML, "land has been cleared by this project", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[18].innerHTML, "Select Units of Measure:", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[19].innerHTML, "View Land Impacts by Mine Project", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[20].innerHTML, "View Regional Land Impacts by Year", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[21].innerHTML, "More Land Data", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[22].innerHTML, "Download Shape Files", 'infoWindowHandlerContent does not match');

            contentNode = oilSandsmodule.infoWindowHandlerContent(graphicObject2);
            assert.equal(query(".tab-pane", contentNode).length, 1, 'tabs number is wrong');
            assert.isNotNull(query('[id="project"]', contentNode), 'project tab is missing');

            contentNode = oilSandsmodule.infoWindowHandlerContent(graphicObject3);
            assert.equal(query(".tab-pane", contentNode).length, 3, 'tabs number is wrong');
            assert.isNotNull(query('[id="project"]', contentNode), 'project tab is missing');
            assert.isNotNull(query('[id="water"]', contentNode), 'water tab is missing');
            assert.isNotNull(query('[id="air"]', contentNode), 'air tab is missing');
        },

        'Test InfoWindow Tabs': function () {
            var parentNode = domConstruct.create("div", {}, null),
                tabsNode = oilSandsmodule._getInfoWindowTabs(parentNode, projectData, emissionsData);
            
            assert.isNotNull(query('[id="project"]', tabsNode), 'project tab is missing');
            assert.isNotNull(query('[id="emissions"]', tabsNode), 'emissions tab is missing');
            assert.isNotNull(query('[id="water"]', tabsNode), 'water tab is missing');
            assert.isNotNull(query('[id="air"]', tabsNode), 'air tab is missing');
            assert.isNotNull(query('[id="land"]', tabsNode), 'land tab is missing');
        },

        'Test Project InfoWindow Content': function () {
            var parentNode = domConstruct.create("div", {}, null),
                enforcementData = {
                    accountableParty: "110 Centre Ltd.",
                    hasClassification: true
                },
                contentNode = oilSandsmodule._getProjectInfoWindowContent(parentNode, projectData, enforcementData),
                iconNode = query('.tab-icon', contentNode),
                sectionList = query('.infoWindowSection', contentNode);

            assert.equal(contentNode.childNodes.length, 10, 'child nodes number is wrong');
            assert.equal(iconNode.length, 1, 'icon node does not exist');
            assert.equal(sectionList.length, 9, 'section number is wrong');
            
            assert.include(iconNode[0].innerHTML, "icon-oilsands dark-grey-txt", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[0].innerHTML, "Voyageur Upgrader", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[1].innerHTML, "Company Enforcement Actions", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[2].innerHTML, "Applications to the Alberta Energy Regulator", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[3].innerHTML, "Water Act Approvals:", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[4].innerHTML, "Water Act Licenses:", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[5].innerHTML, "Environmental Protection and Enhancements Act Approvals:", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[6].innerHTML, "Completed Environmental Impact Assessments:", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[7].innerHTML, "barrels", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[8].innerHTML, "View production history graph", 'infoWindowHandlerContent does not match');
        },

        'Test Emissions InfoWindow Content': function () {
            var parentNode = domConstruct.create("div", {}, null),
                contentNode = oilSandsmodule._getEmissionsInfoWindowContent(parentNode, emissionsData),
                iconNode = query('.tab-icon', contentNode),
                sectionList = query('.infoWindowSection', contentNode);

            assert.equal(contentNode.childNodes.length, 8, 'child nodes number is wrong');
            assert.equal(iconNode.length, 1, 'icon node does not exist');
            assert.equal(sectionList.length, 7, 'section number is wrong');

            assert.include(iconNode[0].innerHTML, "icon-climate-change orange-txt", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[0].innerHTML, "Oil Sands Operator:", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[1].innerHTML, "View emissions history graph", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[2].innerHTML, "Emissions intensity", 'infoWindowHandlerContent does not match');           
            assert.include(sectionList[3].innerHTML, "View the GHG emissions intensity history graph", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[4].innerHTML, "This facility was required to submit", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[5].innerHTML, "View Compliance History Graph", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[6].innerHTML, "More data on greenhouse gas emissions", 'infoWindowHandlerContent does not match');
        },

        'Test Water InfoWindow Content': function () {
            var parentNode = domConstruct.create("div", {}, null),
                contentNode = oilSandsmodule._getWaterInfoWindowContent(parentNode, projectData),
                iconNode = query('.tab-icon', contentNode),
                sectionList = query('.infoWindowSection', contentNode);

            assert.equal(contentNode.childNodes.length, 4, 'child nodes number is wrong');
            assert.equal(iconNode.length, 1, 'icon node does not exist');
            assert.equal(sectionList.length, 3, 'section number is wrong');

            assert.include(iconNode[0].innerHTML, "icon-water dark-blue-txt", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[0].innerHTML, "barrels", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[1].innerHTML, "View Water Use History", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[2].innerHTML, "More data on water use", 'infoWindowHandlerContent does not match');
        },

        'Test Air InfoWindow Content': function () {
            var parentNode = domConstruct.create("div", {}, null),
                contentNode = oilSandsmodule._getAirInfoWindowContent(parentNode, projectData),
                iconNode = query('.tab-icon', contentNode),
                sectionList = query('.infoWindowSection', contentNode);

            assert.equal(contentNode.childNodes.length, 3, 'child nodes number is wrong');
            assert.equal(iconNode.length, 1, 'icon node does not exist');
            assert.equal(sectionList.length, 2, 'section number is wrong');
            assert.include(iconNode[0].innerHTML, "icon-air blue-txt", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[0].innerHTML, "National Pollutant Release Inventory:", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[1].innerHTML, "More data on Air", 'infoWindowHandlerContent does not match');
        },

        'Test Land InfoWindow Content': function () {
            var parentNode = domConstruct.create("div", {}, null),
                contentNode = oilSandsmodule._getLandInfoWindowContent(parentNode, projectData),
                iconNode = query('.tab-icon', contentNode),
                sectionList = query('.infoWindowSection', contentNode);

            assert.equal(contentNode.childNodes.length, 10, 'child nodes number is wrong');
            assert.equal(iconNode.length, 1, 'icon node does not exist');
            assert.equal(sectionList.length, 9, 'section number is wrong');
            assert.include(iconNode[0].innerHTML, "icon-land dark-green-txt", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[0].innerHTML, "land has been cleared by this project", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[1].innerHTML, "land has been cleared by this project", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[2].innerHTML, "land has been cleared by this project", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[3].innerHTML, "land has been cleared by this project", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[4].innerHTML, "Select Units of Measure:", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[5].innerHTML, "View Land Impacts by Mine Project", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[6].innerHTML, "View Regional Land Impacts by Year", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[7].innerHTML, "More Land Data", 'infoWindowHandlerContent does not match');
            assert.include(sectionList[8].innerHTML, "Download Shape Files", 'infoWindowHandlerContent does not match');
        }

    });
});