﻿define([
	'intern!object',
	'intern/chai!assert',
    "dojo/query",
    'dojo/dom-construct',
    'dojo/_base/window',
    'dojo/dom',
    'dijit/registry',
    'app/layout/PortalGlossary'
], function (registerSuite, assert, query, domConstruct, win, dom, registry, PortalGlossary) {
    'use strict';
    var divName = "glossaryDiv",
        modalId = "glossaryModal",
        modalRequiredMarkup = '<div id="' + modalId + '" class="modal fade in" style="display: none;" aria-hidden="true"><div id="' + divName + '"></div></div>';

    registerSuite({
        name: 'Portal Glossary test suite',
        setup: function () {
            domConstruct.place('<link title="bootstrapCss" rel="stylesheet" href="../../Scripts/lib/bootstrap/css/bootstrap.min.css" />', win.doc.getElementsByTagName("head")[0], 'last');
        },
        teardown: function () {
            //disable and then remove the added stylesheets
            var stylesheet = query('link[title=bootstrapCss]')[0];
            stylesheet.disabled = true;
            stylesheet.remove();
        },
        beforeEach: function () {
            domConstruct.place(modalRequiredMarkup, win.body());
        },
        afterEach: function () {
            //remove the elements from the DOM
            dom.byId(modalId).remove();
            //remove from the dijit registry
            registry.remove(divName);
        },
        'test Constructor': function () {
            //constructor is run during the setup
            var glossaryModal = new PortalGlossary({}, divName),
                def = this.async(1000);
            
            glossaryModal.startup();

            setTimeout(function () {
                var domElements = query('.modal-dialog');
                assert.isDefined(domElements[0], "glossary modal should be included in the DOM.");
                assert.isTrue(query(".glossaryKey").length > 0, "glossary key should be included in the DOM.");
                assert.isTrue(query(".glossaryItem").length > 0, "glossary items should be included in the DOM.");
                def.resolve();
            }, 500);
        }
    });
});