﻿define([
    'intern!object',
    'intern/chai!assert',
    './_SearchTestFunctions',
    'app/search/modules/ContentGroupOperationalLayerMultiLayerLink'
], function (registerSuite, assert, searchTestFunctions, SearchModule) {
    'use strict';
    registerSuite({
        name: 'Search Module: ContentGroupOperationalLayerMultiLayerLink',

        //setup: function () {
        //},
        //beforeEach: function () {
        //},
        //afterEach: function () {
        //},
        //teardown: function () {
        //},

        'Search: \'Grizzly Bear\' returns \'Grizzly Bear Population\'': function () {

            this.timeout = 100;

            return searchTestFunctions.validateExpectedResults({
                assert: assert,
                searchModule: new SearchModule({ moduleIdentifier: 'ContentGroupOperationalLayerMultiLayerLink', expressionPath: "//contentGroups/group/operationalLayers/options/multiLayers/link[contains(title, \"${searchText}\")]" }),
                searchText: 'Grizzly Bear',
                expectedResultMatchedValues: ['Grizzly Bear Population']
            });
        },

        'Search: \'Population\' returns "Grizzly Bear Population", "Piping Plover Population", "Trumpeter Swan Population"': function () {

            this.timeout = 100;

            return searchTestFunctions.validateExpectedResults({
                assert: assert,
                searchModule: new SearchModule({ moduleIdentifier: 'ContentGroupOperationalLayerMultiLayerLink', expressionPath: "//contentGroups/group/operationalLayers/options/multiLayers/link[contains(title, \"${searchText}\")]" }),
                searchText: 'Population',
                expectedResultMatchedValues: ["Grizzly Bear Population", "Piping Plover Population", "Trumpeter Swan Population"]
            });
        }

    });
});