﻿define([
    'intern!object',
    'intern/chai!assert',
    './_SearchTestFunctions',
    'app/search/modules/ContentGroupOperationalLayerMultiLayerTitle'
], function (registerSuite, assert, searchTestFunctions, SearchModule) {
    'use strict';
    registerSuite({
        name: 'Search Module: ContentGroupOperationalLayerMultiLayerTitle',

        //setup: function () {
        //},
        //beforeEach: function () {
        //},
        //afterEach: function () {
        //},
        //teardown: function () {
        //},

        'Search: \'Grizzly Bear\' returns \'Grizzly Bear\'': function () {

            this.timeout = 100;

            return searchTestFunctions.validateExpectedResults({
                assert: assert,
                searchModule: new SearchModule({ moduleIdentifier: 'ContentGroupOperationalLayerMultiLayerTitle', expressionPath: "//contentGroups/group/operationalLayers/options/multiLayers[contains(title, \"${searchText}\")]" }),
                searchText: 'Grizzly Bear',
                expectedResultMatchedValues: ['Grizzly Bear']
            });
        },

        'Search: \'Land\' returns \'Land Cleared (In Situ)\', \'Land Cleared (Mines)\', \'Land Disturbed (In Situ)\', \'Land Disturbed (Mines)\'': function () {

            this.timeout = 100;

            return searchTestFunctions.validateExpectedResults({
                assert: assert,
                searchModule: new SearchModule({ moduleIdentifier: 'ContentSubGroupOperationalLayerMultiLayerTitle', expressionPath: "//contentGroups/group/operationalLayers/subGroups/operationalLayers/subGroups/operationalLayers/options/multiLayers[contains(title, \"${searchText}\")]" }),
                searchText: 'Land',
                expectedResultMatchedValues: ["Land Cleared (In Situ)", "Land Cleared (Mines)", "Land Disturbed (In Situ)", "Land Disturbed (Mines)"]
            });
        }

    });
});