﻿define([
    'intern!object',
    'intern/chai!assert',
    './_SearchTestFunctions',
    'app/search/modules/ContentGroupOperationalLayerRelatedLink'
], function (registerSuite, assert, searchTestFunctions, SearchModule) {
    'use strict';
    registerSuite({
        name: 'Search Module: ContentGroupOperationalLayerRelatedLink',

        //setup: function () {
        //},
        //beforeEach: function () {
        //},
        //afterEach: function () {
        //},
        //teardown: function () {
        //},

        'Search: \'water use\' returns \'Oil Sands Water Use\'': function () {

            this.timeout = 100;

            return searchTestFunctions.validateExpectedResults({
                assert: assert,
                searchModule: new SearchModule({ moduleIdentifier: 'ContentSubGroupOperationalLayerRelatedLink', expressionPath: "//contentGroups/group/operationalLayers/subGroups/operationalLayers/subGroups/operationalLayers/relatedLinks[contains(title, \"${searchText}\")]" }),
                searchText: 'water use',
                expectedResultMatchedValues: ['Oil Sands Water Use']
            });
        },

        'Search: \'what\' returns "What is the Air Quality Health Index?", "What substances are reported?"': function () {

            this.timeout = 100;

            return searchTestFunctions.validateExpectedResults({
                assert: assert,
                searchModule: new SearchModule({ moduleIdentifier: 'ContentGroupOperationalLayerRelatedLink', expressionPath: "//contentGroups/group/operationalLayers/relatedLinks[contains(title, \"${searchText}\")]" }),
                searchText: 'what',
                expectedResultMatchedValues: ["What is the Air Quality Health Index?", "What substances are reported?"]
            });
        }

    });
});