﻿define([
    'intern!object',
    'intern/chai!assert',
    './_SearchTestFunctions',
    'app/search/modules/ContentGroupOperationalLayerTitle'
], function (registerSuite, assert, searchTestFunctions, SearchModule) {
    'use strict';
    registerSuite({
        name: 'Search Module: ContentGroupOperationalLayerTitle',

        //setup: function () {
        //},
        //beforeEach: function () {
        //},
        //afterEach: function () {
        //},
        //teardown: function () {
        //},

        'Search: \'approved\' returns "Approved Mines", "Approved In Situ Facilities", "Approved Upgraders"': function () {

            this.timeout = 100;

            return searchTestFunctions.validateExpectedResults({
                assert: assert,
                searchModule: new SearchModule({ moduleIdentifier: 'ContentSubGroupOperationalLayerTitle', expressionPath: "//contentGroups/group/operationalLayers/subGroups/operationalLayers/subGroups/operationalLayers[contains(title, \"${searchText}\")]" }),
                searchText: 'approved',
                expectedResultMatchedValues: ["Approved Mines", "Approved In Situ Facilities", "Approved Upgraders"]
            });
        },

        'Search: \'monitoring\' returns "Industrial Emissions Monitoring Stations", "Air Quality Monitoring Stations"': function () {

            this.timeout = 100;

            return searchTestFunctions.validateExpectedResults({
                assert: assert,
                searchModule: new SearchModule({ moduleIdentifier: 'ContentGroupOperationalLayerTitle', expressionPath: "//contentGroups/group/operationalLayers[contains(title, \"${searchText}\")]" }),
                searchText: 'monitoring',
                expectedResultMatchedValues: ["Industrial Emissions Monitoring Stations", "Air Quality Monitoring Stations"]
            });
        }

    });
});