﻿define([
    'intern/chai!assert'
], function (assert) {
    'use strict';
    return {
        validateExpectedResults: function (args) {

            if (!args || !args.searchModule) {
                throw 'args.searchModule cannot be null';
            }

            if (!args.searchText) {
                throw 'args.searchText cannot be null';
            }

            if (!args.expectedResultMatchedValues) {
                throw 'args.expectedResultMatchedValues cannot be null';
            }

            return args.searchModule.searchAsync(args.searchText).then(function(results) {
                assert.isNotNull(results, "Search results should not be null");
                assert.isArray(results, "Search results should be an array");

                var resultMatchedValues = results.map(function (result) {
                    return result.matchedValue;
                });

                assert.sameMembers(args.expectedResultMatchedValues, resultMatchedValues, 'Matched Value(s) of results do not match args.expectedResultMatchedValues');
            });
        }
    };
});