﻿define([
    'intern!object',
    'intern/chai!assert',
    'app/utils/Common'
], function (registerSuite, assert, commonUtils) {
    'use strict';
    registerSuite({
        name: 'Common module tests',
        'Test Generate Id': function () {
            var result = commonUtils.generateId();
            assert.isNotNull(result, 'Generated Id cannot be null');
            var isGuid = /^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$/.test(result);
            assert.isTrue(isGuid, "Generated Id doesn't return GUID");
        },
        'Test aewError': function () {
            var errorObj = {
                message: "test error message"
            };

            var consoleLogMsg;

            var originalLogFunc = window.console.log;
            window.console.log = function (msg) { consoleLogMsg = msg; };

            var result = commonUtils.aewError(errorObj);
            assert.strictEqual(result, errorObj.message, "aewError doesn't return expected error message.");

            // check console output
            assert.strictEqual(consoleLogMsg, errorObj.message, "aewError doesn't ouput expected error message to console.");

            window.console.log = originalLogFunc;
        }
    });
});